// Note: I really hope this can be optmized? Looks scary but works.

varying MEDP vec2 uvVarying;

uniform sampler2D image;
uniform MEDP float t; // Expects [0, 1]

void main() 
{
  float foldMax = 0.12;
  float distortMax = 0.05;
  //force adjust the t to be [0.15, 1.0] so the roll up ends with a fully rolled image
  float foldLine = clamp((t + 0.15) / 1.15, 0.15, 1.0);
  float curlWidth = min(1.0 - foldLine, foldMax);
  float distortWidth = min(1.0 - foldLine, distortMax);
  float distortStrength = 0.01;
  float curlLine1 = foldLine - curlWidth * 0.5;
  float curlLine2 = curlLine1 - curlWidth * 0.5;
  float distortLine = curlLine2 - distortWidth;
  float d = (distortLine - uvVarying.y) / distortWidth;

  // Top of the fold point is empty blackness
  if(uvVarying.y > foldLine)
  {
    gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
  }
  // First half of curl is a distorted mirrored uv read with some shading
  else if(uvVarying.y > curlLine1)
  {
    float d = (uvVarying.y - curlLine1) / (curlWidth * 0.5);
    float fadeColor = min(d, 0.7);
    vec4 fadeVec = vec4(fadeColor, fadeColor, fadeColor, 0.0);
    gl_FragColor = texture2D(image, vec2(uvVarying.x - distortStrength, -uvVarying.y + foldLine * 2.0 + distortStrength * d)) - fadeVec;
  }
  // Second half of curl is a mirrored uv read
  else if(uvVarying.y > curlLine2)
  {
    gl_FragColor = texture2D(image, vec2(uvVarying.x - distortStrength, -uvVarying.y + foldLine * 2.0));
  }
  // A portion under the fold is distorted and shaded
  else if(uvVarying.y > distortLine)
  {
    float d = (uvVarying.y - distortLine) / distortWidth;
    float fadeColor = min(d, 0.7);
    vec4 fadeVec = vec4(fadeColor, fadeColor, fadeColor, 0.0);
    gl_FragColor = texture2D(image, vec2(uvVarying.x - distortStrength * d, uvVarying.y + distortStrength * d)) - fadeVec;
  }
  // The rest is a standard uv lookup
  else
  {
    gl_FragColor = texture2D(image, vec2(uvVarying.x, uvVarying.y));
  }
}
