--- AhuEnvironment
-- @author Created by Aaron Barrett on September 30, 2013.

-- ===========================================================================
class("AhuEnvironment")
-- ===========================================================================

require("Screen")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

--MOAISim settings---------------------

local DEFAULT_LONG_DELAY_THRESHOLD  = 35
local DEFAULT_BOOST_THRESHOLD       = 20
local DEFAULT_CPU_BUDGET            = 3
local DEFAULT_LOOP_FLAGS            = MOAISim.LOOP_FLAGS_FIXED

--Default setup------------------------

local function applyDefaultMOAIColorSettings()
  MOAIGfxDevice.setColorPremultiply(true)
end

local function applyDefaultMOAISimSettings()
  MOAISim.setLongDelayThreshold(DEFAULT_LONG_DELAY_THRESHOLD)
  MOAISim.setBoostThreshold(DEFAULT_BOOST_THRESHOLD)
  MOAISim.setCpuBudget(DEFAULT_CPU_BUDGET)
  MOAISim.setLoopFlags(DEFAULT_LOOP_FLAGS)
end

local function configureRandomSeed()
  -- Taken from http://lua-users.org/wiki/MathLibraryTutorial
  local seed = tonumber(tostring(MOAISim.getDeviceTime()):reverse():sub(1,6))
  math.randomseed(seed)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function AhuEnvironment.initialize()
  Screen.init()
  applyDefaultMOAIColorSettings()
  applyDefaultMOAISimSettings()
  configureRandomSeed()
end
