--- Alignment
--
-- Use these constants for all alignment purposes.
-- All others in MOAI, row, column, etc should be considered deprecated.
--
-- @author Created by karl on July 22, 2015.

class("Alignment")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

if MOAITextBox then
  Alignment.LEFT = MOAITextBox.LEFT_JUSTIFY
  Alignment.RIGHT = MOAITextBox.RIGHT_JUSTIFY
  Alignment.TOP = MOAITextBox.LEFT_JUSTIFY
  Alignment.BOTTOM = MOAITextBox.RIGHT_JUSTIFY
  Alignment.CENTER = MOAITextBox.CENTER_JUSTIFY
else
  -- This is needed in contexts where MOAI isn't available.
  Alignment.LEFT = 0
  Alignment.RIGHT = 2
  Alignment.TOP = 0
  Alignment.BOTTOM = 2
  Alignment.CENTER = 1
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function Alignment.assertIsHorizontalAlignment(alignment)
  local isHorizontalAlignment = (alignment == Alignment.LEFT)
                                or (alignment == Alignment.RIGHT)
                                or (alignment == Alignment.CENTER)
  assert(isHorizontalAlignment, string.format("Expected a horizontal aligment value, received %s", tostring(alignment)))
end

function Alignment.assertIsVerticalAlignment(alignment)
  local isVerticalAlignment = (alignment == Alignment.TOP)
                              or (alignment == Alignment.BOTTOM)
                              or (alignment == Alignment.CENTER)
  assert(isVerticalAlignment, string.format("Expected a vertical aligment value, received %s", tostring(alignment)))
end
