--- Analytics
-- @author Created by aaroncantor on August 21, 2020.

class("Analytics")

require("utils.TableUtils")

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function logEvent(eventKey, stringToStringPropertiesMapping)
  local logString = "EVENT REPORTED: " .. tostring(eventKey)
  for a, b in pairs(stringToStringPropertiesMapping) do
    logString = logString .. "\n\t" .. tostring(a) .. ": " .. tostring(b)
  end
  Log.verbose(logString)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function Analytics.reportEvent(eventKey, propertiesMapping)
  if not eventKey then
    print("WARNING: Reporting nil event")
    return
  end

  propertiesMapping = propertiesMapping or {}

  local stringToStringPropertiesMapping = TableUtils.createStringToStringMapping(propertiesMapping)

  Host.reportAnalyticsEvent(tostring(eventKey), stringToStringPropertiesMapping)
  logEvent(eventKey, stringToStringPropertiesMapping)
end
