--- Font Cache

-- ===========================================================================
class("FontFaces")
-- ===========================================================================

--- Loads a font from the asset path and caches it in FontFaces
-- @param name - A name used to refer to the font, can be any string, but I like this convention: TIMES_NEW_ROMAN
-- @param filename - the path to the font file
-- @return - (MOAIFreeTypeFont) the loaded font.
function FontFaces.loadFont(name, filename)
  local font = FontFaces[name]

  if not font then
    local fontPath = FileUtils.findFile(filename)
    assert(fontPath ~= nil, "no font found at '" .. tostring(filename) .. "'")
    font = MOAIFreeTypeFont.new()
    font:load(fontPath)
    FontFaces[name] = font
  end

  return font
end
