--- AHDims actions


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getDimX(self)
  local dimX = self:getDims()
  return dimX
end

local function setDimX(self, value)
  local dimX, dimY, dimZ = self:getDims()
  dimX = value
  dimZ = dimZ or 0
  local anchorX, anchorY, anchorZ = self:getAnchorPoint()
  self:setBounds(0.0, 0.0, 0, dimX, dimY, dimZ)
  self:setAnchorPoint(anchorX, anchorY, anchorZ)
end

local function getDimY(self)
  local _, dimY = self:getDims()
  return dimY
end

local function setDimY(self, value)
  local dimX, dimY, dimZ = self:getDims()
  dimY = value
  dimZ = dimZ or 0
  local anchorX, anchorY, anchorZ = self:getAnchorPoint()
  self:setBounds(0.0, 0.0, 0, dimX, dimY, dimZ)
  self:setAnchorPoint(anchorX, anchorY, anchorZ)
end


-- ----------------------------------------------------------------------------
-- AHDimXTo
-- ----------------------------------------------------------------------------

class("AHDimXTo")
function AHDimXTo.new(target, duration, ease, amount)
  return AHNonAttributeTo.new(target, duration, getDimX, setDimX, ease, amount)
end

-- ----------------------------------------------------------------------------
-- AHDimXBy
-- ----------------------------------------------------------------------------

class("AHDimXBy")
function AHDimXBy.new(target, duration, ease, amount)
  return AHNonAttributeBy.new(target, duration, getDimX, setDimX, ease, amount)
end

-- ----------------------------------------------------------------------------
-- AHDimYTo
-- ----------------------------------------------------------------------------

class("AHDimYTo")
function AHDimYTo.new(target, duration, ease, amount)
  return AHNonAttributeTo.new(target, duration, getDimY, setDimY, ease, amount)
end

-- ----------------------------------------------------------------------------
-- AHDimYBy
-- ----------------------------------------------------------------------------

class("AHDimYBy")
function AHDimYBy.new(target, duration, ease, amount)
  return AHNonAttributeBy.new(target, duration, getDimY, setDimY, ease, amount)
end

-- ----------------------------------------------------------------------------
-- AHDimsTo
-- ----------------------------------------------------------------------------

class("AHDimsTo")
function AHDimsTo.new(target, duration, ease, xAmount, yAmount)
  yAmount = yAmount or xAmount

  local xAction = AHDimXTo.new(target, duration, ease, xAmount)
  local yAction = AHDimYTo.new(target, duration, ease, yAmount)
  local self = AHSpawn.new(xAction, yAction)
  return self
end

-- ----------------------------------------------------------------------------
-- AHDimsBy
-- ----------------------------------------------------------------------------

class("AHDimsBy")
function AHDimsBy.new(target, duration, ease, xAmount, yAmount)
  yAmount = yAmount or xAmount

  local xAction = AHDimXBy.new(target, duration, ease, xAmount)
  local yAction = AHDimYBy.new(target, duration, ease, yAmount)
  local self = AHSpawn.new(xAction, yAction)
  return self
end
