class("AHAxisOffsetShake")
AHAxisOffsetShake.SHAKE_AXIS =
{
  X = 1,
  Y = 2
}

function AHAxisOffsetShake.new(group, width, shakeAxis, speedMultiplier)
  local groupW, _ = group:getDims()
  width = width or groupW
  shakeAxis = shakeAxis or AHAxisOffsetShake.SHAKE_AXIS.X
  speedMultiplier = speedMultiplier or 1

  local amplitudeHigh = width * 0.03
  local amplitudeMedium = width * 0.015
  local amplitudeLow = width * 0.007

  local shakeActionHelper = nil
  if (shakeAxis == AHAxisOffsetShake.SHAKE_AXIS.X) then
    shakeActionHelper = AHLocationXBy
  elseif (shakeAxis == AHAxisOffsetShake.SHAKE_AXIS.Y) then
    shakeActionHelper = AHLocationYBy
  end

  local softShakeAction = AHSequence.new(
    shakeActionHelper.new(group, 0.065 * speedMultiplier, AHEaseSimpleInOut.new(2.0), -amplitudeHigh),
    shakeActionHelper.new(group, 0.060 * speedMultiplier, AHEaseSimpleIn.new(2.0), amplitudeHigh),
    shakeActionHelper.new(group, 0.055 * speedMultiplier, AHEaseSimpleOut.new(2.0), amplitudeHigh),
    shakeActionHelper.new(group, 0.050 * speedMultiplier, AHEaseSimpleIn.new(2.0), -amplitudeHigh),
    shakeActionHelper.new(group, 0.045 * speedMultiplier, AHEaseSimpleOut.new(2.0), -amplitudeMedium),
    shakeActionHelper.new(group, 0.040 * speedMultiplier, AHEaseSimpleIn.new(2.0), amplitudeMedium),
    shakeActionHelper.new(group, 0.035 * speedMultiplier, AHEaseSimpleOut.new(2.0), amplitudeMedium),
    shakeActionHelper.new(group, 0.030 * speedMultiplier, AHEaseSimpleIn.new(2.0), -amplitudeMedium),
    shakeActionHelper.new(group, 0.080 * speedMultiplier, AHEaseSimpleOut.new(2.0), -amplitudeLow),
    shakeActionHelper.new(group, 0.055 * speedMultiplier, AHEaseSimpleInOut.new(2.0), amplitudeLow)
  ) -- Total duration 0.515s

  return softShakeAction
end
