class("AHBlink")

-- ----------------------------------------------------------------------------
-- UTILITY
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- OBJECT CREATION
-- ----------------------------------------------------------------------------
function AHBlink.new(object, duration, ease, color1, color2, uneasedBlinksPerSecond)
  uneasedBlinksPerSecond = uneasedBlinksPerSecond or 1
  color1 = ColorUtils.colorWithDefaultOpacity(color1, 1)
  color2 = ColorUtils.colorWithDefaultOpacity(color2, 1)

  local timer = AHCustomAction.new(duration, ease, function(t)
    t = t * uneasedBlinksPerSecond * duration % 1
    local phase = t * math.pi * 2   -- smooth into the color, then back out
    phase = phase - math.pi/2       -- make sure that at 0 and at 1 the color is at color1
    t = math.sin(phase)/2 + 0.5     -- go into [0, 1] space
    local r, g, b, a = unpack(ColorUtils.makeColorBetweenTwoColors(color1, color2, t))
    object:setColor(r, g, b, a)
  end)

  return timer
end
