class("AHRotationShake")
local DEFAULT_SHAKE_COUNT = 4
local DEFAULT_ROTATION_AMPLITUDE = 1.5

function AHRotationShake.new(group, numberOfShakes, rotationAmplitude)
  local shakeIndex = 0
  local shakes = numberOfShakes or DEFAULT_SHAKE_COUNT
  local rotationStrength = rotationAmplitude or DEFAULT_ROTATION_AMPLITUDE

  local function shakeFunction()
    shakeIndex = shakeIndex + 1
    local rotationAmount = 1.0
    if (shakeIndex % 2 == 0) then
      rotationAmount = -1.0
    end

    group:setRot(rotationAmount * rotationStrength)
  end
  local restoreNormality = function()
    group:setRot(0)
  end

  local shake = AHLoop.new(AHCallLogic.new(shakeFunction), shakes)
  local restore = AHCallLogic.new(restoreNormality)
  local animation = AHSequence.new(shake, restore)

  return animation
end

function AHRotationShake.newScreenShake(numberOfShakes, rotationAmplitude)
  return AHRotationShake.new(Screen.rootGroup, numberofShakes, rotationAmplitude)
end
