--- Path
-- @author Created by Aaron Barrett on July 28, 2015.

class("Path")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function Path:getLocationAtProgress(progress)
  error("Must define in subclass")
end

function Path:getProgress()
  return self.progress
end

function Path:setProgress(progress)
  self.progress = progress

  local x, y = self:getLocationAtProgress(progress)
  self.target:setLoc(x, y)
end

function Path:createMoveAction(duration, ease, destinationProgress)
  destinationProgress = destinationProgress or 1.0
  return AHNonAttributeTo.new(self, duration, self.getProgress, self.setProgress, ease, destinationProgress)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function Path.new(target)
  local self = {}
  Mixin.mix(self, Path)

  self.target = target
  self.progress = 0.0

  return self
end
