--- PathBezier
-- @author Created by Aaron Barrett on July 28, 2015.

class("PathBezier")

require("actions.advanced.Path")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PathBezier:getLocationAtProgress(progress)
  local startControlPoint = self.startControlPoint
  local startPoint = self.startPoint
  local endPoint = self.endPoint
  local endControlPoint = self.endControlPoint

  local x = MathUtils.bezier(startPoint.x, startControlPoint.x, endControlPoint.x, endPoint.x, progress)
  local y = MathUtils.bezier(startPoint.y, startControlPoint.y, endControlPoint.y, endPoint.y, progress)

  return x, y
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function PathBezier.new(target, startControlPoint, startPoint, endPoint, endControlPoint)
  local self = Path.new(target)
  Mixin.mix(self, PathBezier)

  self.startControlPoint = startControlPoint
  self.startPoint = startPoint
  self.endPoint = endPoint
  self.endControlPoint = endControlPoint

  return self
end
