--- BonusReporter
-- @author Created by Jay Austria on February 24, 2016

-- ===========================================================================
class("BonusReporter")
-- ===========================================================================

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BonusReporter:initializeBonusCount(bonusType)
  Asserts.assertType(bonusType, "bonusType", "string")

  self.bonusCounts[bonusType] = 0
end

function BonusReporter:getBonusCount(bonusType)
  assert(self.bonusCounts[bonusType], "Encountered unexpected bonus. Make sure to initialize bonuses with initializeBonusCount()")

  return self.bonusCounts[bonusType]
end

function BonusReporter:setBonusCount(bonusType, count)
  assert(self.bonusCounts[bonusType], "Encountered unexpected bonus. Make sure to initialize bonuses with initializeBonusCount()")

  self.bonusCounts[bonusType] = count
end

function BonusReporter:incrementBonusCount(bonusType)
  local previousCount = self:getBonusCount(bonusType)
  local incrementedCount = previousCount + 1

  self:setBonusCount(bonusType, incrementedCount)
end

function BonusReporter:increaseBonusCount(bonusType, valueIncrease)
  local previousCount = self:getBonusCount(bonusType)
  local increasedCount = previousCount + valueIncrease

  self:setBonusCount(bonusType, increasedCount)
end

function BonusReporter:getBonusCounts()
  return self.bonusCounts
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function BonusReporter.new()
  local self = {}
  Mixin.mix(self, BonusReporter)

  self.bonusCounts = {}

  return self
end
