--- Streak Indicator
-- Created by Jacob Eiting

class("StreakIndicator")
-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local LABEL_FONT = FontFaces.DIN_OT_BOLD
local LABEL_FONT_SIZE = 12
local TEXT = Localizer.get("StreakIndicator.TEXT")

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function StreakIndicator:playAnimation(streakCount)
  streakCount = streakCount or 2

  local function showStreak()
    self.streakLabel:setText(TEXT .. " x" .. streakCount)
    self.streakLabel:setAttrLink(MOAIColor.ATTR_OPACITY, self)
  end
  runInCoroutine(showStreak)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function StreakIndicator.new()
  local streakLabel = DeprecatedLabel.newSingleLine(TEXT .. " x_", LABEL_FONT, LABEL_FONT_SIZE)
  local w, h = streakLabel:getDims()

  local self = Group.new(w, h)
  Mixin.mix(self, StreakIndicator)

  self.streakLabel = streakLabel
  self:insertAtCenter(streakLabel)

  self:setAnchorPointLeft()
  self:setOpacity(0)

  streakLabel:setAttrLink(MOAIColor.ATTR_OPACITY, self)
  streakLabel:setAttrLink(MOAIColor.INHERIT_COLOR, self, MOAIColor.COLOR_TRAIT)

  return self
end
