-- Created by Jay Austria on 17 January, 2014
class("StreakTracker")
local function onStreak(self)
  if (self.onStreakCallback) then
    self.onStreakCallback()
  end

  if (self.correctAnswersThisStreak > self.longestStreak) then
    self.longestStreak = self.correctAnswersThisStreak
  end
end

function StreakTracker:endStreak()
  self.correctAnswersThisStreak = 0

  if (self.onStreakEndedCallback) then
    self.onStreakEndedCallback()
  end
end

function StreakTracker:notifyCorrectAnswer()
  self.correctAnswersThisStreak = self.correctAnswersThisStreak + 1
  if (self.correctAnswersThisStreak >= self.requiredCorrectAnswers) then
    self.totalStreaks = self.totalStreaks + 1
    onStreak(self)
  end
end

function StreakTracker:notifyIncorrectAnswer()
  self.correctAnswersThisStreak = 0
  self:endStreak()
end

function StreakTracker:getTotalStreaks()
  return self.totalStreaks
end

function StreakTracker:getLongestStreak()
  return self.longestStreak
end

function StreakTracker:getCurrentStreak()
  return self.correctAnswersThisStreak
end

function StreakTracker.new(requiredCorrectAnswers, onStreakCallback, onStreakEndedCallback)
  local self = {}

  self.requiredCorrectAnswers = requiredCorrectAnswers
  self.onStreakCallback = onStreakCallback
  self.onStreakEndedCallback = onStreakEndedCallback

  self.correctAnswersThisStreak = 0
  self.totalStreaks = 0
  self.longestStreak = 0

  Mixin.mix(self, StreakTracker)

  return self
end
