-- Use this class when you are evaluating a branchString but already
-- have a LuaState for a game instance.

class("BranchEvaluator")

require("ExperimentsConfiguration")
require("branching.BranchParser")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- Setup BranchDelegate methods that BranchNodes use to point
-- at existing data.
BranchDelegate = {}

-- ExperimentBranchNode
BranchDelegate.getExperimentVariant = function(experimentId)
  return Host.getExperimentVariant(experimentId)
end
-- For testing:
-- Host.getExperimentVariant = function()
--   return "variant"
-- end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BranchEvaluator.evaluateBranchString(branchString)
  local rootNode = BranchParser.buildTree(branchString)
  return rootNode:evaluate()
end
