--- ExperimentBranchNode
-- @author Created by andrewc on October 25, 2021
-- ExperimentBranchNode gets the treatment for an experimentId and
-- checks it against a list of treatments. Returns true if the returned treatment is
-- in the list.

class("ExperimentBranchNode")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ExperimentBranchNode:evaluate()
  self.treatment = BranchDelegate.getExperimentVariant(self.experimentId)
  assert(self.treatment ~= nil, "No treatment found for experiment Id: " .. tostring(self.experimentId))

  return BranchNode.checkAnswers(self.treatment, self.treatments)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Node Constructors ------------------------

function ExperimentBranchNode.new(experimentId, treatments)
  local self = BranchNode.new()
  Mixin.mix(self, ExperimentBranchNode)
  self.branchType = "experiment"

  assert(experimentId ~= nil, "Experiments require an ExperimentId.")
  self.experimentId = experimentId

  assert((treatments ~= nil) and (#treatments > 0), "Experiments require at least one treatment to check for.")
  self.treatments = treatments

  return self
end
