--- InterestBranchNode
-- @author Created by andrewc on October 25, 2021
-- InterestBranchNode checks if the user has
-- selected the topic as an interest.

class("InterestBranchNode")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function InterestBranchNode:evaluate()
  self.hasInterest = BranchDelegate.hasInterest(self.interestId)
  if (self.hasInterest == nil) then
    self.hasInterest = false
  end

  return self.hasInterest
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Node Constructors ------------------------

function InterestBranchNode.new(interestId)
  local self = BranchNode.new()
  Mixin.mix(self, InterestBranchNode)
  self.branchType = "interest"

  assert(interestId ~= nil, "Interests require an interestId.")
  self.interestId = interestId

  return self
end
