--- NotBranchNode
-- @author Created by andrewc on February 21, 2019
-- Not has a single child branch, and returns the negation of that branch's outcome.

class("NotBranchNode")

require("branching.BranchNode")
require("utils.TableUtils")
require("Mixin")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function NotBranchNode:evaluate()
  return not self.childA:evaluate()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Node Constructors ------------------------

function NotBranchNode.new(childNode)
  local self = BranchNode.new()
  Mixin.mix(self, NotBranchNode)
  self.branchType = "not"

  assert(childNode and childNode.evaluate ~= nil, "NOT requires a branch to negate.")
  self.childA = childNode

  return self
end
