--- TopInterestBranchNode
-- @author Created by andrewc on August 10, 2023
-- TopInterestBranchNode checks if the user has
-- selected one of the topics as their top interest.

class("TopInterestBranchNode")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function TopInterestBranchNode:evaluate()
  for _, interestIdentifier in ipairs(self.interestIdentifiers) do
    if BranchDelegate.isTopInterest(interestIdentifier) then
      return true
    end
  end

  return false
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Node Constructors ------------------------

function TopInterestBranchNode.new(interestIdentifiers)
  local self = BranchNode.new()
  Mixin.mix(self, TopInterestBranchNode)
  self.branchType = "topInterest"

  assert((interestIdentifiers ~= nil) and (#interestIdentifiers > 0), "TopInterest requires at least one interestId.")
  self.interestIdentifiers = interestIdentifiers

  return self
end
