--- CardCarouselCardExit
-- @author Created by karl on May 22, 2015.

class("CardCarouselCardExit")

require("containers.card_carousel.CardCarouselCard")
require("containers.card_carousel.CardCarouselCardCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local Z_NORMAL = 0
local Z_CLOSE_BACKGROUND = 10

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function CardCarouselCardExit:setScrollProgress(progress, isHorizontal)
  self.untimedAction:applyAtTime(progress, isHorizontal)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function CardCarouselCardExit.new(cardType, cardGlobals)
  fadeOutColor = cardGlobals.closeColor or CardCarouselCardCommon.COLORS.WHITE

  local self = CardCarouselCard.new(cardType, cardGlobals)
  Mixin.mix(self, CardCarouselCardExit)

  local background = CardCarouselCardCommon.newStandardBackground()
  self:insertAtCenter(background, Z_NORMAL)

  local closeBackground = CardCarouselCardCommon.newStandardBackground(fadeOutColor)
  closeBackground:setOpacity(0)
  self:insertAtCenter(closeBackground, Z_CLOSE_BACKGROUND)

  self.untimedAction = AHUntimedAction.new(AHOpacityTo.new(closeBackground, 1.0, AHEaseExponentialIn.new(), 1))

  self.untimedAction:start()

  return self
end

function CardCarouselCardExit.newPullToExit(cardType, cardGlobals)
  local self = CardCarouselCardExit.new(cardType, cardGlobals)

  local label = CardCarouselCardCommon.newCachedFontLabel("PULL TO EXIT", CardCarouselCardCommon.CACHED_FONTS.MEDIUM_MEDIUM, CardCarouselCardCommon.COLORS.LIGHT_GREY)
  label:setLoc(self:getWidthPart(0.5), label:getHeightPart(2.0))
  self:insert(label, Z_NORMAL)

  return self
end
