--- CardCarouselTouchTracker
-- @author Created by karl on June 02, 2015.

class("CardCarouselTouchTracker")


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function addEvent(self, event)
  table.insert(self.events, {x = event.x, y = event.y, time = MOAISim.getDeviceTime()})
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function  CardCarouselTouchTracker:getDifferenceX()
  return self.events[#self.events].x - self.events[1].x
end

function  CardCarouselTouchTracker:getDifferenceY()
  return self.events[#self.events].y - self.events[1].y
end

function CardCarouselTouchTracker:getEvents()
  return self.events
end

function CardCarouselTouchTracker:notifyTouchEvent(event)
  if event.phase == TouchManager.TOUCH_BEGAN then
    self.events = {}
    self.isInTouch = true
    addEvent(self, event)
  elseif event.phase == TouchManager.TOUCH_MOVED then
    if self.isInTouch then
      addEvent(self, event)
    end
  else
    addEvent(self, event)
    self.isInTouch = false
  end
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function CardCarouselTouchTracker.new()
  local self = {}
  Mixin.mix(self, CardCarouselTouchTracker)

  self.events = {}

  return self
end
