--- SoundAveragePowerGenerator.
-- Returns the average power of a playing sound.
-- @author Created by karl on July 21, 2014.

class("SoundAveragePowerGenerator")
require("data.generators.Generator")


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SoundAveragePowerGenerator:generateNextValue()
  return self.sound:getAveragePowerForAllChannels()
end

--- Reset the next value to min value.
function SoundAveragePowerGenerator:reset()
  -- Do nothing.
end

function SoundAveragePowerGenerator:setSound(sound)
  assert(sound, "sound cannot be nil")
  self.sound = sound
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SoundAveragePowerGenerator.new(sound)
  assert(sound, "sound cannot be nil")
  local self = Generator.new()
  Mixin.mix(self, SoundAveragePowerGenerator)

  self.sound = sound

  return self
end
