--- Keyframe
-- @author Created by andrewc on February 24, 2021.

class("Keyframe")


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function validateKeyframe(self)
  assert(self.key ~= nil, "A keyframe must have a key.")
  assert(type(self.key) == "number", "A keyframe key must be a number.")
  assert(self.frameNumbers ~= nil, "A keyframe must have frameNumbers.")
  assert(type(self.frameNumbers) == "table", "The frameNumbers in a keyframe must be a table.")
  for _, number in pairs(self.frameNumbers) do
    assert(type(number) == "number", "The frameNumbers in a keyframe must contain numbers")
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function Keyframe:getKey()
  return self.key
end

function Keyframe:getFrameNumbers()
  return self.frameNumbers
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function Keyframe.new(key, frameNumbers)
  local self = {}
  Mixin.mix(self, Keyframe)

  self.key = key
  self.frameNumbers = frameNumbers

  validateKeyframe(self)

  return self
end
