--- A rectangle prop
-- @author Created by Alexey Chernikov on Feb 25, 2013

-- ===========================================================================
class("FilledRectangle")
-- ===========================================================================

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function FilledRectangle.new(width, height, color)
  local self = FilledGraphicsPrimitive.new(width, height, color)
  Mixin.mix(self, FilledRectangle)
  self._normalizedPointLists = {{{x=0, y=0}, {x=1, y=0}, {x=1, y=1}, {x=0, y=1}}}
  self:updateGraphicsPrimitive()

  return self
end

function FilledRectangle.newFullScreen(color)
  return FilledRectangle.new(Screen.width, Screen.height, color)
end


-- ===========================================================================
class("HollowRectangle")
-- ===========================================================================

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function HollowRectangle.new(width, height, lineWidth, blurMargin, color)
  local self = HollowGraphicsPrimitive.new(width, height, color, lineWidth, blurMargin, true)
  Mixin.mix(self, HollowRectangle)
  self._normalizedPointLists = {{{x=0, y=0}, {x=1, y=0}, {x=1, y=1}, {x=0, y=1}}}
  self:updateGraphicsPrimitive()

  return self
end
