--- A triangle! (he hates particle man)

-- ===========================================================================
class("FilledTriangle")
-- ===========================================================================

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function FilledTriangle.newWithTable(points, color)
  local selfW, selfH = ShapeUtils.getMaxEdges(points)
  local self = FilledGraphicsPrimitive.new(selfW, selfH, color)
  Mixin.mix(self, FilledTriangle)
  ShapeUtils.normalizePoints(points, selfW, selfH)
  self._normalizedPointLists = {points}
  self:updateGraphicsPrimitive()

  return self
end

function FilledTriangle.new(p1x, p1y, p2x, p2y, p3x, p3y, color)
  local points = {{x=p1x, y=p1y}, {x=p2x, y=p2y}, {x=p3x, y=p3y}}
  local self = FilledTriangle.newWithTable(points, color)

  return self
end



-- ===========================================================================
class("HollowTriangle")
-- ===========================================================================

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function HollowTriangle.new(p1x, p1y, p2x, p2y, p3x, p3y, color, lineWidth, blurMargin)
  local points = {{x=p1x, y=p1y}, {x=p2x, y=p2y}, {x=p3x, y=p3y}}
  local selfW, selfH = ShapeUtils.getMaxEdges(points)
  local self = HollowGraphicsPrimitive.new(selfW, selfH, color, lineWidth, blurMargin, true)
  Mixin.mix(self, HollowTriangle)
  ShapeUtils.normalizePoints(points, selfW, selfH)
  self._normalizedPointLists = {points}
  self:updateGraphicsPrimitive()

  return self
end
