--- FontScaling
-- @author Created by anton on August 31, 2015.

class("FontScaling")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

FontScaling.SCALING_METHOD_WIDTH = "SCALING_METHOD_WIDTH"
FontScaling.SCALING_METHOD_HEIGHT = "SCALING_METHOD_HEIGHT"

FontScaling.scalingMethod = nil

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local benchmarkRatio = 9.0/16.0

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FontScaling.setAutoScaling(width, height)
  if (width / height < benchmarkRatio) then
    FontScaling.setScalingMethod(FontScaling.SCALING_METHOD_WIDTH)
  else
    FontScaling.setScalingMethod(FontScaling.SCALING_METHOD_HEIGHT)
  end
end

function FontScaling.setScalingMethod(scalingMethod)
  FontScaling.scalingMethod = scalingMethod
end

function FontScaling.getScaledSize(size)
  if FontScaling.scalingMethod == FontScaling.SCALING_METHOD_WIDTH then
    return ReferenceDevice.getScaledWidth(size)
  elseif FontScaling.scalingMethod == FontScaling.SCALING_METHOD_HEIGHT then
    return ReferenceDevice.getScaledHeight(size)
  else
    error(string.format("Unexpected scaling method: %s", tostring(FontScaling.scalingMethod)))
  end
end

function FontScaling.getInverseScaledSize(size)
  if FontScaling.scalingMethod == FontScaling.SCALING_METHOD_WIDTH then
    return ReferenceDevice.getInverseScaledWidth(size)
  elseif FontScaling.scalingMethod == FontScaling.SCALING_METHOD_HEIGHT then
    return ReferenceDevice.getInverseScaledHeight(size)
  else
    error(string.format("Unexpected scaling method: %s", tostring(FontScaling.scalingMethod)))
  end
end

-- ----------------------------------------------------------------------------
-- Initialization
-- ----------------------------------------------------------------------------

FontScaling.setScalingMethod(FontScaling.SCALING_METHOD_WIDTH)
