--- TextItemLayout
-- @author Created by amorant on October 20, 2014.
-- A TextItemLayout contains the information needed to position one item view in a TextView (this
-- is, the view corresponding to one TextItem).
-- TextItemLayouts are generated by a TextLayoutBuilder, and they can be applied in different ways
-- by a TextView. For instance, when items are first present, they can be placed in their position
-- in the text view with a fade in. And when new items are inserted, other items can be animated
-- from their current position to the new one.
-- TextItemLayouts are simple data containers that hold the information required for this
-- animations.

class("TextItemLayout")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- Getters and setters ----------------

function TextItemLayout:getX()
  return self.x
end

function TextItemLayout:setX(x)
  self.x = x
end

function TextItemLayout:getY()
  return self.y
end

function TextItemLayout:setY(y)
  self.y = y
end

function TextItemLayout:getAnchorX()
  return self.anchorX
end

function TextItemLayout:setAnchorX(anchorX)
  self.anchorX = anchorX
end

function TextItemLayout:getAnchorY()
  return self.anchorY
end

function TextItemLayout:setAnchorY(anchorY)
  self.anchorY = anchorY
end

-- Comparison -------------------------

function TextItemLayout:equals(itemLayout)
  return itemLayout ~= nil
         and self:getX() == itemLayout:getX()
         and self:getY() == itemLayout:getY()
         and self:getAnchorX() == itemLayout:getAnchorX()
         and self:getAnchorY() == itemLayout:getAnchorY()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function TextItemLayout.new(x, y, anchorX, anchorY)
  local self = {}
  Mixin.mix(self, TextItemLayout)

  self.x = x
  self.y = y
  self.anchorX = anchorX
  self.anchorY = anchorY

  return self
end
