--- Helpers for accessing lesson content

-- ===========================================================================
class("AssetHelper")
-- ===========================================================================

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getAbsolutePathForAsset(concept, filename)
  Asserts.assertType(concept, "concept", "table")
  Asserts.assertType(filename, "filename", "string")

  local assetsPath = concept.assets_path
  Asserts.assertType(assetsPath, "assetsPath", "string")

  local absolutePath = assetsPath .. "/" .. filename
  return absolutePath
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function AssetHelper.getAssetScaleFactor()
  return 8
end

function AssetHelper.createPhotoTextureForConcept(concept, filename)
  local absolutePath = getAbsolutePathForAsset(concept, filename)
  local shouldCache = false
  return TextureLoader.loadTexture(absolutePath, shouldCache)
end

function AssetHelper.createPhotoSpriteForConcept(concept, filename)
  local texture = AssetHelper.createPhotoTextureForConcept(concept, filename)
  return Sprite.newWithTexture(texture)
end

function AssetHelper.getAbsolutePathForSound(concept, filename)
  local absolutePath = getAbsolutePathForAsset(concept, filename)
  return FileUtils.replaceLastExtension(absolutePath, Host.musicFileExtension)
end

function AssetHelper.playSoundForConcept(concept, filename)
  local absolutePath = AssetHelper.getAbsolutePathForSound(concept, filename)
  return Sound.playLongformSoundWithPath(absolutePath)
end
