--- GroupUtils
-- @author Created by karl on April 28, 2015.

class("GroupUtils")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

--- Get the bounding rectangle of a bunch of groups.
function GroupUtils.getBoundsOfGroups(...)
  local minX, minY = math.huge, math.huge
  local maxX, maxY = -math.huge, -math.huge
  for _, group in ipairs({...}) do
    local gMinX, gMinY, gMinZ, gMaxX, gMaxY, gMaxZ = group:getBounds()
    local pivX, pivY = group:getPiv()
    local locX, locY = group:getLoc()
    minX = math.min(minX, locX + gMinX - pivX)
    minY = math.min(minY, locY + gMinY - pivY)
    maxX = math.max(maxX, locX + gMaxX - pivX)
    maxY = math.max(maxY, locY + gMaxY - pivY)
  end
  return minX, minY, maxX, maxY
end

function GroupUtils.getCenterOfRectangle(minX, minY, maxX, maxY)
  return (maxX - minX) / 2 + minX, (maxY - minY) / 2 + minY
end
