--- NumericMapping
-- @author Created by karl on April 07, 2015.

-- ============================================================================
class("NumericMapping")
-- ============================================================================


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function NumericMapping:getMappedValue(value)
  return self.mappingFunction(value)
end

function NumericMapping:getInverseMappedValue(value)
  return self.inverseMappingFunction(value)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function NumericMapping.new(mappingFunction, inverseMappingFunction)
  local self = {}
  Mixin.mix(self, NumericMapping)
  self.mappingFunction = mappingFunction
  self.inverseMappingFunction = inverseMappingFunction or function() error("No inverse mapping function defined") end
  return self
end



-- ============================================================================
class("NormalizedRangeNumericMapping")
-- ============================================================================

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function NormalizedRangeNumericMapping.new(startValue, endValue)
  local range = endValue - startValue

  local mappingFunction = function(value)
    return (value - startValue) / range
  end

  local inverseMappingFunction = function(value)
    return value * range + startValue
  end

  return NumericMapping.new(mappingFunction, inverseMappingFunction)
end
