--- SimpleParametersValidator
--
-- This is a simple implementation of a ParametersValidator that only checks for
-- the presence of a list of configuration parameters. This is what most games
-- need, so they can instantiate this class with their parameters list instead
-- of having to create a new class that does this.
--
-- @author Created by amorant on July 23, 2014.

class("SimpleParametersValidator")
require("validators.ParametersValidator")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SimpleParametersValidator:validateParameters(parameters)
  self:testRequiredParameters(parameters, self.requiredParameters)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SimpleParametersValidator.new(requiredParameters)
  local self = ParametersValidator.new()
  Mixin.mix(self, SimpleParametersValidator)

  self.requiredParameters = requiredParameters

  return self
end
