--- SpriteRevealProgressIndicator
-- @author Created by karl on September 19, 2014.

-- ===========================================================================
class("SpriteRevealProgressIndicator")
-- ===========================================================================

require("widgets.progress.ProgressIndicator")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

SpriteRevealProgressIndicator.GROW_DOWN = "SpriteRevealProgressIndicator.GROW_DOWN"
SpriteRevealProgressIndicator.GROW_UP = "SpriteRevealProgressIndicator.GROW_UP"
SpriteRevealProgressIndicator.GROW_LEFT = "SpriteRevealProgressIndicator.GROW_LEFT"
SpriteRevealProgressIndicator.GROW_RIGHT = "SpriteRevealProgressIndicator.GROW_RIGHT"


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SpriteRevealProgressIndicator:setProgress(progress)
  self.super.setProgress(self, progress)
  progress = self:getProgress()

  local width, height = self.baseWidth, self.baseHeight
  local progressW, progressH = width * progress, height * progress

  if self.growDirection == SpriteRevealProgressIndicator.GROW_DOWN then
    self.progressSprite:setVisibleRect(0, height - progressH, width, height)
  elseif self.growDirection == SpriteRevealProgressIndicator.GROW_UP then
    self.progressSprite:setVisibleRect(0, 0, width, progressH)
  elseif self.growDirection == SpriteRevealProgressIndicator.GROW_LEFT then
    self.progressSprite:setVisibleRect(width - progressW, 0, width, height)
  else
    self.progressSprite:setVisibleRect(0, 0, progressW, height)
  end
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SpriteRevealProgressIndicator.new(fgSprite, bgSprite, growDirection, stepCount)
  local self = Group.new(bgSprite:getEffectiveDims())
  ProgressIndicator.makeProgressIndicator(self, stepCount)
  Mixin.mix(self, SpriteRevealProgressIndicator)

  self.baseWidth, self.baseHeight = fgSprite:getDims()

  self:insertAtCenter(bgSprite)
  self:insertAtCenter(fgSprite)
  self:linkColorAttrToChildren()

  self.backingSprite = bgSprite
  self.progressSprite = fgSprite
  self.growDirection = growDirection

  return self
end
