--- ArcticBackground
-- @author Created by Joe Poka on October 31, 2016.

class("ArcticBackground")

require("ArcticTrees")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REAR_MOUNTAIN_VERTICES = {
  { x = Screen.getWidthPart(0.00), y = Screen.getHeightPart(0.00)},
  { x = Screen.getWidthPart(0.00), y = Screen.getHeightPart(0.66)},
  { x = Screen.getWidthPart(0.10), y = Screen.getHeightPart(0.63)},
  { x = Screen.getWidthPart(0.24), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(0.29), y = Screen.getHeightPart(0.73)},
  { x = Screen.getWidthPart(0.35), y = Screen.getHeightPart(0.79)},
  { x = Screen.getWidthPart(0.42), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(0.50), y = Screen.getHeightPart(0.65)},
  { x = Screen.getWidthPart(0.59), y = Screen.getHeightPart(0.68)},
  { x = Screen.getWidthPart(0.63), y = Screen.getHeightPart(0.71)},
  { x = Screen.getWidthPart(0.66), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(0.88), y = Screen.getHeightPart(0.64)},
  { x = Screen.getWidthPart(0.97), y = Screen.getHeightPart(0.69)},
  { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.00)}
}

local SNOW_MOUNTAIN_VERTICES_LEFT = {
  { x = Screen.getWidthPart(0.00), y = Screen.getHeightPart(0.00)},
  { x = Screen.getWidthPart(0.00), y = Screen.getHeightPart(0.58)},
  { x = Screen.getWidthPart(0.02), y = Screen.getHeightPart(0.59)},
  { x = Screen.getWidthPart(0.06), y = Screen.getHeightPart(0.65)},
  { x = Screen.getWidthPart(0.14), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(0.19), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(0.31), y = Screen.getHeightPart(0.57)},
  { x = Screen.getWidthPart(0.46), y = Screen.getHeightPart(0.56)},
  { x = Screen.getWidthPart(0.61), y = Screen.getHeightPart(0.57)},
  { x = Screen.getWidthPart(0.61), y = Screen.getHeightPart(0.00)}
}

local SNOW_MOUNTAIN_VERTICES_RIGHT = {
  { x = Screen.getWidthPart(0.61), y = Screen.getHeightPart(0.00)},
  { x = Screen.getWidthPart(0.61), y = Screen.getHeightPart(0.57)},
  { x = Screen.getWidthPart(0.67), y = Screen.getHeightPart(0.70)},
  { x = Screen.getWidthPart(0.78), y = Screen.getHeightPart(0.82)},
  { x = Screen.getWidthPart(0.83), y = Screen.getHeightPart(0.82)},
  { x = Screen.getWidthPart(0.86), y = Screen.getHeightPart(0.66)},
  { x = Screen.getWidthPart(0.90), y = Screen.getHeightPart(0.63)},
  { x = Screen.getWidthPart(0.90), y = Screen.getHeightPart(0.59)},
  { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.56)},
  { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.00)},
}

local LEFT_SHADOW_VERTICES = {
  { x = Screen.getWidthPart(0.32), y = Screen.getHeightPart(0.55)},
  { x = Screen.getWidthPart(0.37), y = Screen.getHeightPart(0.53)},
  { x = Screen.getWidthPart(0.30), y = Screen.getHeightPart(0.47)},
  { x = Screen.getWidthPart(0.27), y = Screen.getHeightPart(0.46)},
  { x = Screen.getWidthPart(0.26), y = Screen.getHeightPart(0.46)},
  { x = Screen.getWidthPart(0.24), y = Screen.getHeightPart(0.49)},
  { x = Screen.getWidthPart(0.17), y = Screen.getHeightPart(0.70)},
  SNOW_MOUNTAIN_VERTICES_LEFT[6],
  SNOW_MOUNTAIN_VERTICES_LEFT[7]
}

local RIGHT_SHADOW_VERTICES = {
  { x = Screen.getWidthPart(0.76), y = Screen.getHeightPart(0.53)},
  { x = Screen.getWidthPart(0.94), y = Screen.getHeightPart(0.48)},
  { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.47)},
  SNOW_MOUNTAIN_VERTICES_RIGHT[9],
  SNOW_MOUNTAIN_VERTICES_RIGHT[8],
  SNOW_MOUNTAIN_VERTICES_RIGHT[7],
  SNOW_MOUNTAIN_VERTICES_RIGHT[6],
  SNOW_MOUNTAIN_VERTICES_RIGHT[5],
  { x = Screen.getWidthPart(0.81), y = Screen.getHeightPart(0.78)}
}

local TREE_LINE_POINTS = {
  {
    { x = Screen.getWidthPart(0.02), y = Screen.getHeightPart(0.63)},
    { x = Screen.getWidthPart(0.11), y = Screen.getHeightPart(0.59)},
    { x = Screen.getWidthPart(-0.01), y = Screen.getHeightPart(0.58)}
  },
  {
    { x = Screen.getWidthPart(0.26), y = Screen.getHeightPart(0.69)},
    { x = Screen.getWidthPart(0.22), y = Screen.getHeightPart(0.59)},
    { x = Screen.getWidthPart(0.27), y = Screen.getHeightPart(0.58)}
  },
  {
    { x = Screen.getWidthPart(0.29), y = Screen.getHeightPart(0.71)},
    { x = Screen.getWidthPart(0.24), y = Screen.getHeightPart(0.57)},
    { x = Screen.getWidthPart(0.33), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(0.34), y = Screen.getHeightPart(0.69)},
    { x = Screen.getWidthPart(0.32), y = Screen.getHeightPart(0.56)},
    { x = Screen.getWidthPart(0.37), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(0.39), y = Screen.getHeightPart(0.66)},
    { x = Screen.getWidthPart(0.36), y = Screen.getHeightPart(0.56)},
    { x = Screen.getWidthPart(0.42), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(0.43), y = Screen.getHeightPart(0.66)},
    { x = Screen.getWidthPart(0.40), y = Screen.getHeightPart(0.55)},
    { x = Screen.getWidthPart(0.50), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(0.50), y = Screen.getHeightPart(0.62)},
    { x = Screen.getWidthPart(0.48), y = Screen.getHeightPart(0.56)},
    { x = Screen.getWidthPart(0.54), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(0.57), y = Screen.getHeightPart(0.65)},
    { x = Screen.getWidthPart(0.51), y = Screen.getHeightPart(0.56)},
    { x = Screen.getWidthPart(0.60), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(0.62), y = Screen.getHeightPart(0.68)},
    { x = Screen.getWidthPart(0.59), y = Screen.getHeightPart(0.57)},
    { x = Screen.getWidthPart(0.65), y = Screen.getHeightPart(0.57)}
  },
  {
    { x = Screen.getWidthPart(0.90), y = Screen.getHeightPart(0.72)},
    { x = Screen.getWidthPart(0.93), y = Screen.getHeightPart(0.57)},
    { x = Screen.getWidthPart(0.86), y = Screen.getHeightPart(0.58)}
  },
  {
    { x = Screen.getWidthPart(0.96), y = Screen.getHeightPart(0.65)},
    { x = Screen.getWidthPart(0.92), y = Screen.getHeightPart(0.57)},
    { x = Screen.getWidthPart(0.98), y = Screen.getHeightPart(0.56)}
  },
  {
    { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.64)},
    { x = Screen.getWidthPart(0.95), y = Screen.getHeightPart(0.55)},
    { x = Screen.getWidthPart(1.00), y = Screen.getHeightPart(0.55)}
  }
}

local TREE_LINE_COLOR = {0.42, 0.35, 0.38}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createTreeLine(self)
  for _, treePoints in ipairs(TREE_LINE_POINTS) do
    local tree = FilledTriangle.newWithTable(treePoints, TREE_LINE_COLOR)
    tree:setAnchorPointBottomLeft()
    self:insert(tree)
  end
end

local function getIntroScaleAnimation(self)
  local scaleCount = 11
  local actions = {}

  local maximumScaleDuration = 0.04
  local currentScaleDuration = maximumScaleDuration
  local scaleDurationFactor = 0.88

  local minimumScale = 1.0
  local scaleFactor = 1.00185
  local currentScale = minimumScale

  for i = 1, scaleCount do
    local scaleUp = AHScaleTo.new(self, currentScaleDuration, nil, currentScale)
    local scaleDown = AHScaleTo.new(self, currentScaleDuration, nil, minimumScale)
    local scaleOnce = AHSequence.new(scaleUp, scaleDown)
    table.insert(actions, scaleOnce)

    currentScale = currentScale * scaleFactor
    currentScaleDuration = currentScaleDuration * scaleDurationFactor
  end

  local scale = AHSequence.new(actions)
  return scale
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ArcticBackground:getIntroAnimation(shakingCompletedCallback)
  local treeShakingAnimation = self.trees:getShakingAnimation()

  local introScaleAnimation = getIntroScaleAnimation(self)
  local shakingSequence = AHSequence.new(introScaleAnimation, shakingCompletedCallback)

  local introAnimation = AHSpawn.new(treeShakingAnimation, shakingSequence)
  return introAnimation
end

function ArcticBackground:startOverlayTinting()
  local overlayTintAction = self.overlayGradient:newOpacityToAction(ArcticConfiguration.GAME_DURATION, nil, 1.0, 0.0)
  overlayTintAction:start()
end

function ArcticBackground:getCorrectAnswerScaleAnimation()
  local scaleCount = 3
  local scaleDuration = 0.045
  local screenScaleUp = AHScaleTo.new(self, scaleDuration, nil, 1.01)
  local screenScaleDown = AHScaleTo.new(self, scaleDuration, nil, 1.0)
  local screenScaleOnce = AHSequence.new(screenScaleUp, screenScaleDown)
  local scale = AHLoop.new(screenScaleOnce, scaleCount)
  return scale
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local width, height = Screen.width, Screen.height

  local topColor = ColorUtils.colorHex24ToStd(0xA39999)
  local bottomColor = {0.85, 0.67, 0.71}
  local skyGradient = RectangleGradient.new(width, height / 2.8, topColor, bottomColor)
  skyGradient:setAnchorPointTop()
  self:insertAtTop(skyGradient)

  local rearMountainsColor = {0.66, 0.47, 0.54}
  local rearMountains = FilledPolygon.new(width, height, REAR_MOUNTAIN_VERTICES, rearMountainsColor)
  self:insertAtCenter(rearMountains)

  createTreeLine(self)

  local snowMountainsColor = {0.95, 0.90, 0.93}
  local snowMountainsRight = FilledPolygon.new(width, height, SNOW_MOUNTAIN_VERTICES_RIGHT, snowMountainsColor)
  self:insertAtCenter(snowMountainsRight)

  local snowMountainsLeft = FilledPolygon.new(width, height, SNOW_MOUNTAIN_VERTICES_LEFT, snowMountainsColor)
  self:insertAtCenter(snowMountainsLeft)

  local shadowColor = {0.87, 0.79, 0.82}
  local leftShadow = FilledPolygon.new(width, height, LEFT_SHADOW_VERTICES, shadowColor)
  self:insertAtCenter(leftShadow)

  local rightShadow = FilledPolygon.new(width, height, RIGHT_SHADOW_VERTICES, shadowColor)
  self:insertAtCenter(rightShadow)

  self.trees = ArcticTrees.new()
  self:insertAtCenter(self.trees)

  local overlayTopColor = {0.164, 0.133, 0.266, 0.3}
  local overlayBottomColor = {1.0, 1.0, 1.0, 0.0}
  local backgroundOverlay = RectangleGradient.new(Screen.width, Screen.getHeightPart(0.25), overlayTopColor, overlayBottomColor)
  backgroundOverlay:setAnchorPointTop()
  self:insertAtTop(backgroundOverlay)
  self.overlayGradient = backgroundOverlay
end

-- Constructor ------------------------

function ArcticBackground.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, ArcticBackground)

  createLayout(self)

  return self
end
