--- ArcticBlend
-- @author Created by Joe Poka on November 4, 2016.

class("ArcticBlend")

require("graphics.OffscreenRenderedTexture")
require("utils.ShaderUtils")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createTexture(group)
  local groupWidth = group:getWidth()
  local groupHeight = group:getHeight()
  local contentScale = Host.contentScale
  local textureWidth = MathUtils.incrementUntilPowerOf2(groupWidth * contentScale)
  local textureHeight = MathUtils.incrementUntilPowerOf2(groupHeight * contentScale)
  local texture = OffscreenRenderedTexture.new(group, textureWidth, textureHeight)
  return texture
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ArcticBlend:getShader(parameters)
  return nil
end

function ArcticBlend:setUpShader(parameters)
  self.shader = self:getShader(parameters);
  self:setShader(self.shader)
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ArcticBlend.new(group)
  local texture = createTexture(group)
  local self = Sprite.newWithTexture(texture)
  Mixin.mix(self, ArcticBlend)

  self.textureWidth, self.textureHeight = texture:getSize()

  return self
end
