--- ArcticCommon
-- @author Created by Jay Austria on December 5, 2016.

class("ArcticCommon")

require("utils.ShaderUtils")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

ArcticCommon.COLORS = {
  TEXT_WHITE = {1.0, 0.98, 0.93}
}

ArcticCommon.SHINY_RECTANGLES_SHADER = nil

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ArcticCommon.initialize()
  local shader = MOAIShader.new()
  shader:reserveUniforms(1)
  shader:declareUniform(1, 'transform', MOAIShader.UNIFORM_WORLD_VIEW_PROJ)
  shader:setVertexAttribute(1, "position")
  shader:setVertexAttribute(2, "color")

  local vsh = ShaderUtils.loadShader("ArcticShinyRectanglesShader.vsh")
  local fsh = ShaderUtils.loadShader("ArcticShinyRectanglesShader.fsh")
  shader:load(vsh, fsh)

  ArcticCommon.SHINY_RECTANGLES_SHADER = shader
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
