--- ArcticHollowTriangle
-- @author Created by Joe Poka on November 30, 2016.

class("ArcticHollowTriangle")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ArcticHollowTriangle:startRotating(reverse)
  local radius = self.offset * 0.5

  local minimumDeltaThetaRadians = 0.012
  local maximumDeltaThetaRadians = 0.018
  local deltaThetaRadians = MathUtils.getRandomFloat(minimumDeltaThetaRadians, maximumDeltaThetaRadians)

  if (reverse) then
    deltaThetaRadians = deltaThetaRadians * -1.0
  end

  local thetaRadians = 0.0
  local x, y = self:getLoc()

  local updatePositionOnce = function()
    local dx = radius * math.cos(thetaRadians)
    local dy = radius * math.sin(thetaRadians)
    self:setLoc(x + dx, y + dy)

    thetaRadians = thetaRadians + deltaThetaRadians
    if (thetaRadians > 2.0 * math.pi) then
      thetaRadians = 0.0
    end
  end

  local updatePosition = AHLoop.new(updatePositionOnce)
  updatePosition:start()
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ArcticHollowTriangle.new(triangleParameters, offset)
  local self = HollowTriangle.new(unpack(triangleParameters))
  Mixin.mix(self, ArcticHollowTriangle)

  self.offset = offset

  return self
end
