--- ArcticNumberPadInputField
-- @author Created by Joe Poka on November 16, 2016.

class("ArcticNumberPadInputField")

require("widgets.number_pad.NumberPadInputField")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ArcticNumberPadInputField:append(displayedValueAsString)
  local tappedDecimal = (displayedValueAsString == ".")
  local alreadyHaveDecimal = (string.find(self.displayedValueAsString, "[.]") ~= nil)
  local ignoreAdditionalDecimal = (tappedDecimal and alreadyHaveDecimal)

  if (ignoreAdditionalDecimal) then
    self:reactToInvalidInput()
  else
    self.super.append(self, displayedValueAsString)
  end
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ArcticNumberPadInputField.new(inputHeight, fontFace, fontSize, defaultColor)
  local characters = ".0123456789"
  local self = NumberPadInputField.new(inputHeight, fontFace, fontSize, defaultColor, nil, characters)
  Mixin.mix(self, ArcticNumberPadInputField)

  return self
end
