--- ArcticNumbersGroup
-- @author Created by Joe Poka on November 16, 2016.

class("ArcticNumbersGroup")

require("ArcticCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ArcticNumbersGroup:getExitAnimation()
  local duration = 0.3
  local fadeOut = AHOpacityTo.new(self, duration, nil, 0.0)
  return fadeOut
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self, round)
  local values = round.values
  local count = #values

  local fontSize = 33.0
  local font = Font.new(FontFaces.DIN_OT_MEDIUM, fontSize)

  local horizontalSpacing = self:getWidthPart(0.13)
  local totalWidth = horizontalSpacing * (count - 1)
  local labels = {}

  for _, value in ipairs(values) do
    local label = Label.new(tostring(value), font)
    self:insert(label)
    table.insert(labels, label)
    totalWidth = totalWidth + label:getWidth()
  end

  local x = self:getWidthPart(0.5) - totalWidth * 0.5
  local y = self:getHeightPart(0.54)
  for _, label in ipairs(labels) do
    x = x + label:getWidthPart(0.5)
    label:setLoc(x, y)
    x = x + label:getWidthPart(0.5) + horizontalSpacing
  end
end

-- Constructor ------------------------

function ArcticNumbersGroup.new(round)
  local width = Screen.getWidthPart(0.75)
  local height = Screen.getHeightPart(0.15)
  local self = Group.new(width, height)
  Mixin.mix(self, ArcticNumbersGroup)

  createLayout(self, round)

  local recursive = true
  self:linkOpacityAttrToChildren(recursive)

  return self
end
