--- BrevityColors
-- @author created by Joe Poka on May 2, 2016

class("BrevityColors")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

BLACK = {0.0, 0.0, 0.0}
WHITE = {1.0, 1.0, 1.0}
NEAR_WHITE = {0.92, 0.92, 0.92}
DARK_GRAY = {0.87, 0.87, 0.87}
LIGHT_GRAY = {0.1, 0.1, 0.1}
PURPLE = {0.94, 0.0, 1.0}
YELLOW = {0.96, 0.96, 0.0}
PINK = {1.0, 0.0, 0.72}
GREEN = {0.0, 1.0, 0.2}
BLUE = {0.0, 0.79, 0.99}

local GAME_COLORS =
{
  background = WHITE,
  promptBacking = DARK_GRAY,
  interstitialBacking = BLACK,
  tangramArea = WHITE,
  text = BLACK,
  rationale = LIGHT_GRAY,
  palette =
  {
    PURPLE, YELLOW, PINK, GREEN, BLUE
  }
}

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BrevityColors.getPalette()
  local currentPalette = GAME_COLORS.palette
  return currentPalette
end

function BrevityColors.getPaletteColor(index)
  local currentPalette = BrevityColors.getPalette()
  return currentPalette[index]
end

function BrevityColors.getBackgroundColor()
  local backgroundColor = GAME_COLORS.background
  return backgroundColor
end

function BrevityColors.getPromptBackgroundColor()
  local fillColor = GAME_COLORS.promptBacking
  return fillColor
end

function BrevityColors.getTextColor()
  local textColor = GAME_COLORS.text
  return textColor
end

function BrevityColors.getInterstitialBackingColor()
  local interstitialBackingColor = GAME_COLORS.interstitialBacking
  return interstitialBackingColor
end

function BrevityColors.getTangramAreaColor()
  local tangramAreaColor = GAME_COLORS.tangramArea
  return tangramAreaColor
end

function BrevityColors.getRationaleColor()
  return GAME_COLORS.rationale
end
