--- BrevityData
-- @author created by Joe Poka on May 2, 2016

class("BrevityData")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local INSTRUCTIONS_STRING = "What part of the sentence is unnecessary?"
local TUTORIAL_STRING = "Tap here. All or part of this selection can be removed without changing the sentence's meaning."
-- Edit or create tangrams with tangramEditor.html
local TANGRAM_GROUPS =
{
  -- 1, Triangle -—
  '[{"rotation":225,"scale":15.01,"x":69.56,"y":45.8,"shape":"triangle","paletteIndex":0,"colorIndex":4}]',

  -- 2, Triangles -—
  '[{"rotation":90,"scale":18.56,"x":79.35,"y":49.56,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":360,"scale":18.6,"x":60.9,"y":49.6,"shape":"triangle","paletteIndex":0,"colorIndex":1}]',

  -- 3, Box -—
  '[{"rotation":225,"scale":19.8,"x":70.37,"y":35.76,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":495,"scale":20,"x":84.3,"y":49.62,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":28,"x":70.53,"y":49.78,"shape":"triangle","paletteIndex":0,"colorIndex":0}]',

  -- 4, Goose -—
  '[{"rotation":225,"scale":12.26,"x":57.43,"y":58.49,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":135,"scale":7.03,"x":56.02,"y":53.56,"shape":"parallelogram_left","paletteIndex":0,"colorIndex":2},{"rotation":0,"scale":11.78,"x":63.67,"y":42.75,"shape":"parallelogram_left","paletteIndex":0,"colorIndex":4},{"rotation":45,"scale":16.88,"x":81.45,"y":48.64,"shape":"triangle","paletteIndex":0,"colorIndex":0}]',

  -- 5, Pig -—
  '[{"rotation":90,"scale":19.85,"x":92.71,"y":53.93,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":270,"scale":19.27,"x":73.17,"y":49.14,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":225,"scale":20.46,"x":63.72,"y":44.28,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":14.57,"x":56.79,"y":51.51,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":90,"scale":6.98,"x":45.99,"y":48.05,"shape":"parallelogram_left","paletteIndex":0,"colorIndex":0}]',

  -- 6, Fish -—
  '[{"rotation":315,"scale":16.06,"x":39.48,"y":51.14,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":135,"scale":23,"x":66.84,"y":51.27,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":0,"scale":16.23,"x":74.82,"y":59.29,"shape":"square","paletteIndex":0,"colorIndex":3},{"rotation":0,"scale":16.23,"x":74.66,"y":43.18,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":180,"scale":16.23,"x":74.82,"y":43.19,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":315,"scale":23,"x":82.78,"y":51.25,"shape":"triangle","paletteIndex":0,"colorIndex":1}]',

  -- 7, Duck -—
  '[{"rotation":225,"scale":17.43,"x":59.46,"y":66.45,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":270,"scale":12.61,"x":65.45,"y":72.58,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":10.54,"x":56.87,"y":59.08,"shape":"parallelogram_left","paletteIndex":0,"colorIndex":2},{"rotation":360,"scale":14.9,"x":49.51,"y":44.53,"shape":"square","paletteIndex":0,"colorIndex":3},{"rotation":90,"scale":29.2,"x":71.13,"y":37.28,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":45,"scale":29.04,"x":76.92,"y":51.98,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":14.75,"x":49.18,"y":29.84,"shape":"triangle","paletteIndex":0,"colorIndex":0}]',

  -- 8, Camel -—
  '[{"rotation":270,"scale":8.82,"x":50.3,"y":59.36,"shape":"parallelogram_right","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":33.25,"x":54.62,"y":40.31,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":270,"scale":34.87,"x":84.65,"y":33.63,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":0,"scale":17.5,"x":75.98,"y":59.63,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":90,"scale":17.4,"x":93.37,"y":59.63,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":630,"scale":12.82,"x":61.06,"y":57.39,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":540,"scale":12.86,"x":73.8,"y":57.3,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":270,"scale":19.12,"x":45.15,"y":73.25,"shape":"triangle","paletteIndex":0,"colorIndex":0}]',

  -- 9, Giraffe -—
  '[{"rotation":315,"scale":27.79,"x":56.42,"y":27.26,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":270,"scale":16.24,"x":64.45,"y":38.91,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":90,"scale":8.06,"x":76.53,"y":34.78,"shape":"parallelogram_right","paletteIndex":0,"colorIndex":3},{"rotation":315,"scale":22.63,"x":80.45,"y":22.92,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":0,"scale":15.98,"x":64.46,"y":54.81,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":180,"scale":15.98,"x":64.46,"y":54.81,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":15.96,"x":64.45,"y":70.86,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":450,"scale":15.96,"x":64.6,"y":70.78,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":225,"scale":22.97,"x":56.42,"y":78.63,"shape":"triangle","paletteIndex":0,"colorIndex":0}]',

  -- 10, Eagle -—
  '[{"rotation":0,"scale":18.5,"x":70.09,"y":39.36,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":18.5,"x":69.91,"y":39.11,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":0,"scale":20.17,"x":79.26,"y":58.14,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":90,"scale":20.17,"x":99.17,"y":58.14,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":90,"scale":20.55,"x":59.1,"y":58.39,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":20.55,"x":38.83,"y":58.39,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":135,"scale":12.72,"x":69.38,"y":56.84,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":90,"scale":12.72,"x":75.74,"y":67.26,"shape":"parallelogram_left","paletteIndex":0,"colorIndex":1},{"rotation":45,"scale":18.49,"x":69.12,"y":86.27,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":225,"scale":18.4,"x":70.01,"y":17.06,"shape":"triangle","paletteIndex":0,"colorIndex":3}]',

  -- 11, Unicorn -—
  '[{"rotation":345,"scale":14.98,"x":87.84,"y":28.62,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":270,"scale":39.05,"x":88.76,"y":42.26,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":240,"scale":11.28,"x":121.3,"y":49.82,"shape":"parallelogram_right","paletteIndex":0,"colorIndex":3},{"rotation":225,"scale":39.38,"x":64.11,"y":39.15,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":14.98,"x":51.89,"y":31.74,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":45,"scale":17.96,"x":51.4,"y":66.95,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":225,"scale":17.96,"x":51.4,"y":66.95,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":27.84,"x":37.75,"y":65.89,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":360,"scale":7.29,"x":20.04,"y":76.04,"shape":"square","paletteIndex":0,"colorIndex":4},{"rotation":360,"scale":7.23,"x":12.68,"y":76.12,"shape":"square","paletteIndex":0,"colorIndex":1},{"rotation":495,"scale":5.2,"x":9.32,"y":76.12,"shape":"triangle","paletteIndex":0,"colorIndex":2}]',

  -- 12, little dog -—
  '[{"rotation":540,"scale":10.99,"x":19.68,"y":25.32,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":450,"scale":11.49,"x":19.68,"y":36.56,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":45,"scale":15.81,"x":25.03,"y":42.07,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":22.27,"x":25.16,"y":53.07,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":90,"scale":22.14,"x":47.28,"y":53.17,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":270,"scale":46.1,"x":59.51,"y":41.03,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":180,"scale":21.79,"x":93.22,"y":53.19,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":0,"scale":21.79,"x":92.95,"y":53.46,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":405,"scale":15.15,"x":93.23,"y":42.49,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":15.39,"x":104.05,"y":31.97,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":90,"scale":28.96,"x":118.24,"y":57.13,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":60,"scale":10.05,"x":24.68,"y":74.73,"shape":"parallelogram_right","paletteIndex":0,"colorIndex":2}]',

  -- 13, cat -—
  '[{"rotation":180,"scale":8.77,"x":105.11,"y":8.07,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":270,"scale":8.77,"x":96.56,"y":8.07,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":90,"scale":8.77,"x":96.59,"y":8.07,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":0,"scale":8.77,"x":87.81,"y":8.07,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":38.29,"x":64.42,"y":22.8,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":315,"scale":33.6,"x":59.84,"y":41.9,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":11.83,"x":54.15,"y":47.81,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":0,"scale":11.83,"x":54.15,"y":59.36,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":45,"scale":17.98,"x":53.82,"y":71.6,"shape":"square","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":12.78,"x":47.68,"y":77.76,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":270,"scale":12.67,"x":60.21,"y":77.7,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":90,"scale":12.78,"x":47.68,"y":90.47,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":360,"scale":12.67,"x":60.21,"y":90.38,"shape":"triangle","paletteIndex":0,"colorIndex":4}]',

  -- 14, rooster -—
  '[{"rotation":225,"scale":12.5,"x":62.17,"y":2.38,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":12.5,"x":70.86,"y":11.13,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":12.5,"x":70.61,"y":11.13,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":225,"scale":12.5,"x":79.37,"y":2.38,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":270,"scale":37.36,"x":52.08,"y":38.48,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":180,"scale":37.33,"x":89.28,"y":38.48,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":225,"scale":17.05,"x":45.43,"y":57.03,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":17.05,"x":33.49,"y":68.97,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":135,"scale":17,"x":33.61,"y":69.14,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":45,"scale":17.05,"x":21.57,"y":81.08,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":20.97,"x":97.55,"y":67.69,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":180,"scale":21.07,"x":97.55,"y":67.69,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":21.14,"x":97.51,"y":88.72,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":90,"scale":21.14,"x":118.41,"y":88.72,"shape":"triangle","paletteIndex":0,"colorIndex":1}]',

  -- 15, kangaroo -—
  '[{"rotation":225,"scale":11.79,"x":27.51,"y":3.51,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":11.79,"x":35.71,"y":11.75,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":11.79,"x":35.71,"y":11.75,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":225,"scale":11.79,"x":43.98,"y":3.51,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":270,"scale":16.49,"x":44.03,"y":11.75,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":180,"scale":16.49,"x":60.28,"y":11.75,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":225,"scale":22.8,"x":67.96,"y":3.64,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":405,"scale":19.44,"x":81.34,"y":19.95,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":585,"scale":19.44,"x":81.59,"y":19.95,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":315,"scale":22.16,"x":67.65,"y":35.35,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":45,"scale":21.89,"x":83.33,"y":50.77,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":225,"scale":21.89,"x":83.33,"y":50.77,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":21.89,"x":98.83,"y":66.22,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":16.81,"x":98.83,"y":52.57,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":90,"scale":16.81,"x":107.24,"y":89.88,"shape":"triangle","paletteIndex":0,"colorIndex":0}]',

  -- 16, bear -—
  '[{"rotation":225,"scale":11.9,"x":12.91,"y":14.47,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":135,"scale":11.9,"x":21.19,"y":23.06,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":315,"scale":11.9,"x":21.19,"y":23.06,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":315,"scale":18.25,"x":4.3,"y":27.36,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":45,"scale":18.25,"x":17.29,"y":40.1,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":225,"scale":50.6,"x":40.12,"y":40,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":45,"scale":50.37,"x":75.18,"y":75.64,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":0,"scale":26.23,"x":87.78,"y":52.94,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":180,"scale":25.95,"x":88.03,"y":26.96,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":225,"scale":10.98,"x":82.75,"y":14,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":135,"scale":10.98,"x":90.43,"y":21.68,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":315,"scale":10.98,"x":90.39,"y":21.68,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":225,"scale":10.98,"x":98.07,"y":14,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":135,"scale":30.44,"x":122.62,"y":66.32,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":22.03,"x":122.62,"y":60.45,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":225,"scale":11.69,"x":29.52,"y":14.74,"shape":"triangle","paletteIndex":0,"colorIndex":1}]',

  -- 17, horse on hind legs -—
  '[{"rotation":480,"scale":7.65,"x":100.79,"y":22.57,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":390,"scale":7.95,"x":94.2,"y":26.47,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":570,"scale":7.65,"x":94.2,"y":26.47,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":75,"scale":10.71,"x":95.57,"y":21.16,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":165,"scale":10.61,"x":98.34,"y":10.98,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":45,"scale":11.11,"x":88.62,"y":38.3,"shape":"square","paletteIndex":0,"colorIndex":1},{"rotation":45,"scale":10.91,"x":80.82,"y":30.49,"shape":"square","paletteIndex":0,"colorIndex":0},{"rotation":315,"scale":10.81,"x":73.23,"y":22.94,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":0,"scale":17.2,"x":64.56,"y":16.47,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":45,"scale":22.08,"x":73.14,"y":46.16,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":225,"scale":22.26,"x":72.97,"y":46.07,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":45,"scale":22.58,"x":57.37,"y":61.88,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":225,"scale":15.91,"x":41.47,"y":50.67,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":90,"scale":18.19,"x":64.07,"y":70.76,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":18.19,"x":64.07,"y":70.49,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":225,"scale":25.24,"x":55.36,"y":79.53,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":120,"scale":7.8,"x":98.12,"y":33.15,"shape":"triangle","paletteIndex":0,"colorIndex":2}]',

  -- 18, lion -—
  '[{"rotation":0,"scale":13.03,"x":8.62,"y":36.85,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":13.03,"x":21.66,"y":42.79,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":225,"scale":33.82,"x":45.7,"y":43.08,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":33.96,"x":62.59,"y":49.97,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":25.67,"x":34.52,"y":30.27,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":12.13,"x":38.74,"y":25.93,"shape":"parallelogram_left","paletteIndex":0,"colorIndex":1},{"rotation":225,"scale":24.36,"x":55.91,"y":17.28,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":315,"scale":34.44,"x":79.53,"y":42.67,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":225,"scale":18.87,"x":92.58,"y":18.2,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":270,"scale":13.64,"x":99.17,"y":24.93,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":180,"scale":13.64,"x":112.72,"y":24.93,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":225,"scale":19.35,"x":119.16,"y":18.11,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":34.33,"x":103.94,"y":66.93,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":90,"scale":18.79,"x":113.15,"y":75.57,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":540,"scale":18.79,"x":113.15,"y":57.26,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":0,"scale":18.24,"x":112.54,"y":56.88,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":270,"scale":17.97,"x":112.81,"y":75.86,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":315,"scale":19.4,"x":121.72,"y":61.17,"shape":"triangle","paletteIndex":0,"colorIndex":1}]',

  -- 19, dinosaur -—
  '[{"rotation":0,"scale":6.44,"x":64.98,"y":10.35,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":90,"scale":6.44,"x":71.51,"y":10.35,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":180,"scale":6.44,"x":65.06,"y":10.35,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":90,"scale":6.44,"x":65.23,"y":16.63,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":135,"scale":8.95,"x":62,"y":13.39,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":45,"scale":8.68,"x":55.77,"y":19.6,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":225,"scale":12.96,"x":58.89,"y":19.57,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":270,"scale":37.09,"x":62.39,"y":25.27,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":315,"scale":21.95,"x":80.94,"y":22.16,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":225,"scale":22.1,"x":96.41,"y":6.53,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":270,"scale":9.2,"x":107.72,"y":10.86,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":180,"scale":9.2,"x":116.92,"y":10.86,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":9.66,"x":119.67,"y":20.26,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":90,"scale":37.24,"x":62.46,"y":62.33,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":0,"scale":10.85,"x":38.4,"y":49.02,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":180,"scale":18.29,"x":34.59,"y":45.28,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":45,"scale":24.83,"x":26.17,"y":80.79,"shape":"square","paletteIndex":0,"colorIndex":1},{"rotation":0,"scale":7.88,"x":39.92,"y":77.03,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":630,"scale":4.76,"x":41.51,"y":70.93,"shape":"triangle","paletteIndex":0,"colorIndex":1}]',

  -- 20, heart -—
  '[{"rotation":135,"scale":24.76,"x":68.58,"y":22.98,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":315,"scale":12.7,"x":68.57,"y":14.39,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":45,"scale":12.25,"x":77.26,"y":22.83,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":90,"scale":17.59,"x":77.37,"y":31.54,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":315,"scale":13.29,"x":51.26,"y":32.57,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":45,"scale":13.59,"x":59.81,"y":41.22,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":90,"scale":17.24,"x":59.74,"y":48.97,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":270,"scale":34.02,"x":34.17,"y":40.29,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":225,"scale":23.96,"x":34.45,"y":57.12,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":135,"scale":24.09,"x":51.42,"y":73.98,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":90,"scale":33.82,"x":68.21,"y":73.93,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":0,"scale":17.28,"x":94.91,"y":65.8,"shape":"triangle","paletteIndex":0,"colorIndex":3},{"rotation":90,"scale":17.28,"x":112.14,"y":65.67,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":315,"scale":13.52,"x":85.39,"y":65.56,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":135,"scale":12.63,"x":85.51,"y":65.41,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":45,"scale":13.06,"x":76.76,"y":74.38,"shape":"triangle","paletteIndex":0,"colorIndex":2},{"rotation":45,"scale":13.16,"x":94.37,"y":74.4,"shape":"triangle","paletteIndex":0,"colorIndex":0},{"rotation":0,"scale":18.14,"x":76.48,"y":83.43,"shape":"triangle","paletteIndex":0,"colorIndex":1},{"rotation":90,"scale":18.07,"x":94.5,"y":83.35,"shape":"triangle","paletteIndex":0,"colorIndex":4},{"rotation":45,"scale":49.05,"x":85.66,"y":57.25,"shape":"triangle","paletteIndex":0,"colorIndex":4}]}'
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function checkTangramGroupData()
  local tangramGroupJSONStrings = TANGRAM_GROUPS
  local expectedCount = 1

  for _, tangramGroupJSONString in ipairs(tangramGroupJSONStrings) do
    local tangramGroup = MOAIJsonParser.decode(tangramGroupJSONString)
    local actualCount = #tangramGroup

    if (actualCount ~= expectedCount) then
      print("checkTangramGroupData... fail... expected " .. expectedCount .. " tangrams, found " .. actualCount)
      return false
    end

    expectedCount = expectedCount + 1
  end
  return true
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BrevityData.getTangramGroups()
  assert(checkTangramGroupData(), "potentially malformed tangram group data")

  local tangramGroupJSONStrings = TANGRAM_GROUPS
  local tangramGroups = {}

  for _, tangramGroupJSONString in ipairs(tangramGroupJSONStrings) do
    local tangramGroup = MOAIJsonParser.decode(tangramGroupJSONString)

    for _, tangram in ipairs(tangramGroup) do
      -- Colors
      local colorIndex = tangram.colorIndex + 1
      tangram.color = BrevityColors.getPaletteColor(colorIndex)

      -- Fix widths
      tangram.width = tangram.scale

      -- MOAI rotation is flipped
      tangram.rotation = -tangram.rotation
    end

    table.insert(tangramGroups, tangramGroup)
  end

  return tangramGroups
end

function BrevityData.getInstructionsString()
  return INSTRUCTIONS_STRING
end

function BrevityData.getTutorialString()
  return TUTORIAL_STRING
end
