-- BrevityTangramCounter.lua
-- created by Jay Austria on April 26, 2016

class("BrevityTangramCounter")

require("BrevityCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local LARGE_NOT_HUGE_NUMBER = 999

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getProgressStepText(self)
  local labelText = tostring(self:getProgressStep())

  return labelText
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BrevityTangramCounter:setProgressStep(step)
  self.super.setProgressStep(self, step)

  self.countLabel:setText(getProgressStepText(self))
end

function BrevityTangramCounter:getKeyColor()
  return UI_COMPONENTS_COLOR
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local icon = Sprite.newWithName("counter.png")
  self:insert(icon)

  self:insertSpacer(5)

  local countLabelColumn = Column.new()

  local countLabel = Label.new(getProgressStepText(self), Font.new(StandardUIBuilder.STANDARD_FONT, 16))
  countLabelColumn:insert(countLabel)
  self.countLabel = countLabel

  countLabelColumn:insertSpacer(2)

  countLabelColumn:alignChildren()
  self:insert(countLabelColumn)

  self:alignChildren()

  self:setColor(unpack(UI_COMPONENTS_COLOR))

  local isRecursive = true
  self:linkColorAttrToChildren(isRecursive)
end

function BrevityTangramCounter.new()
  local self = Row.new()

  local stepCount = LARGE_NOT_HUGE_NUMBER -- math.huge seems to break this
  ProgressIndicator.makeProgressIndicator(self, stepCount)

  Mixin.mix(self, BrevityTangramCounter)

  createLayout(self)

  return self
end
