--- BrevityTextInterpreter
-- @author created by Joe Poka on May 2, 2016

class("BrevityTextInterpreter")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TAG_REDUCE = "reduce"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BrevityTextInterpreter:parseXmlTextElement(element, attributesForElement, fullText)
  attributesForElement.groupingIndex = self.currentGroupingIndex

  local items = self.super.parseXmlTextElement(self, element, attributesForElement, fullText)

  return items
end

function BrevityTextInterpreter:parseXmlTagElement(element, attributesForElement)
  local label = element:getLabel()
  local items = self.super.parseXmlTagElement(self, element, attributesForElement)

  --- Everyime a NEW "reduce" tag is encountered, increment the grouping index by one
  -- which then applies to all subsequent words encountered.
  -- The grouping of "drop" tagged words is irrelevant since they will always be dropped.
  -- The grouping of non-droppable and non-reducible words is also irrelevant since they
  -- don't have the isReducible or isDroppable attribute.
  if label == TAG_REDUCE then
    self.currentGroupingIndex = self.currentGroupingIndex + 1
  end

  return items
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function BrevityTextInterpreter.new(baseAttributes, attributesForLabels)
  local self = TextInterpreter.new(baseAttributes, attributesForLabels)
  Mixin.mix(self, BrevityTextInterpreter)
  self.currentGroupingIndex = 0

  return self
end
