--- ClarityColors
-- @author created by Jay Austria on May 13, 2014

class("ClarityColors")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

ClarityColors.BLACK = {0.0, 0.0, 0.0}
ClarityColors.WHITE = {1.0, 1.0, 1.0}
ClarityColors.PAYNES_GRAY = {0.14, 0.2, 0.25}
ClarityColors.DARK_PAYNES_GRAY = {0.05, 0.09, 0.12}

ClarityColors.PEACH = ColorUtils.colorHex24ToStd(0xFFB294)
ClarityColors.LIGHT_BLUE = ColorUtils.colorHex24ToStd(0xEBF8EF)
ClarityColors.DUSTY_ROSE = ColorUtils.colorHex24ToStd(0xD28F8E)
ClarityColors.TAUPE = ColorUtils.colorHex24ToStd(0xA59381)
ClarityColors.RUST = ColorUtils.colorHex24ToStd(0xF46348)
ClarityColors.WHEAT = ColorUtils.colorHex24ToStd(0xF1D8B3)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ClarityColors.getPalette()
  return {
    ClarityColors.PEACH,
    ClarityColors.LIGHT_BLUE,
    ClarityColors.DUSTY_ROSE,
    ClarityColors.TAUPE,
    ClarityColors.WHEAT
  }
end

function ClarityColors.getPaletteColor(index)
  local currentPalette = ClarityColors.getPalette()
  return currentPalette[index]
end

function ClarityColors.getBackgroundColor()
  return ClarityColors.PAYNES_GRAY
end

function ClarityColors.getTextBackingColor()
  return ClarityColors.DARK_PAYNES_GRAY
end


function ClarityColors.getTextColor()
  return ClarityColors.WHITE
end

function ClarityColors.getInterstitialBackingColor()
  return ClarityColors.DARK_PAYNES_GRAY
end

function ClarityColors.getTangramAreaColor()
  return ClarityColors.PAYNES_GRAY
end

function ClarityColors.getRationaleColor()
  local rationaleColor = ClarityColors.BLACK
  return rationaleColor
end
