--- ClarityData
-- @author created by Jay Austria on February 17, 2014

class("ClarityData")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REDUCIBLE_INSTRUCTIONS_STRING = Localizer.get("REDUCIBLE_INSTRUCTIONS_STRING")
local REPLACEMENT_INSTRUCTIONS_STRING = Localizer.get("REPLACEMENT_INSTRUCTIONS_STRING")
-- Edit or create tangrams with tangramEditor.html
local TANGRAM_LAYOUT_JSON_STRINGS =
{
  [5] = {
    '[{"rotation":0,"scale":11.2,"x":71.25,"y":36,"shape":"parallelogram_right","paletteIndex":1,"colorIndex":2},{"rotation":45,"scale":15.89,"x":54.52,"y":41.64,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":585,"scale":15.95,"x":54.74,"y":41.6,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":495,"scale":16.16,"x":66.08,"y":52.77,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":450,"scale":38.36,"x":84.97,"y":60.86,"shape":"triangle","paletteIndex":1,"colorIndex":0}]',
    '[{"rotation":45,"scale":15.36,"x":56.14,"y":38.93,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":1},{"rotation":315,"scale":15.25,"x":77.82,"y":38.93,"shape":"parallelogram_right","paletteIndex":1,"colorIndex":4},{"rotation":315,"scale":15.3,"x":56.15,"y":60.49,"shape":"square","paletteIndex":1,"colorIndex":3},{"rotation":315,"scale":15.3,"x":67,"y":49.75,"shape":"square","paletteIndex":1,"colorIndex":0},{"rotation":315,"scale":15.3,"x":77.75,"y":60.57,"shape":"square","paletteIndex":0,"colorIndex":3}]',
    '[{"rotation":315,"scale":16.32,"x":85.75,"y":51.51,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":135,"scale":16.3,"x":85.75,"y":51.46,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":0,"scale":6.66,"x":70.83,"y":54.78,"shape":"parallelogram_right","paletteIndex":1,"colorIndex":2},{"rotation":180,"scale":15.52,"x":59.54,"y":50.29,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":135,"scale":7.25,"x":62.25,"y":47.69,"shape":"triangle","paletteIndex":1,"colorIndex":3}]',
    '[{"rotation":90,"scale":22.78,"x":70.09,"y":40.24,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":270,"scale":22.89,"x":70.02,"y":40.15,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":0,"scale":22.78,"x":70.13,"y":62.96,"shape":"square","paletteIndex":1,"colorIndex":1},{"rotation":45,"scale":10,"x":88.5,"y":60.5,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":4},{"rotation":315,"scale":10,"x":51.75,"y":60.25,"shape":"parallelogram_right","paletteIndex":1,"colorIndex":0}]',
    '[{"rotation":0,"scale":26.86,"x":76.43,"y":41.37,"shape":"square","paletteIndex":1,"colorIndex":4},{"rotation":0,"scale":13.1,"x":56.75,"y":34.5,"shape":"square","paletteIndex":1,"colorIndex":3},{"rotation":0,"scale":13.2,"x":56.64,"y":47.77,"shape":"square","paletteIndex":1,"colorIndex":1},{"rotation":225,"scale":33.42,"x":69.2,"y":54.41,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":270,"scale":14.61,"x":84.29,"y":62.9,"shape":"triangle","paletteIndex":1,"colorIndex":2}]',
    '[{"rotation":0,"scale":14.75,"x":70.63,"y":26.63,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":90,"scale":14.8,"x":70.65,"y":41.5,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":0},{"rotation":540,"scale":14.25,"x":70.52,"y":56.28,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":225,"scale":24.86,"x":65.01,"y":63.5,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":270,"scale":17.51,"x":73.83,"y":72.17,"shape":"triangle","paletteIndex":1,"colorIndex":2}]'
  },
  [6] = {
    '[{"rotation":45,"scale":15.53,"x":77.16,"y":41.75,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":225,"scale":15.99,"x":65.81,"y":30.54,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":45,"scale":15.89,"x":54.52,"y":41.64,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":585,"scale":15.95,"x":54.74,"y":41.6,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":495,"scale":16.16,"x":66.08,"y":52.77,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":450,"scale":38.36,"x":84.97,"y":60.86,"shape":"triangle","paletteIndex":1,"colorIndex":0}]',
    '[{"rotation":45,"scale":34.43,"x":69.86,"y":46.94,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":90,"scale":16.1,"x":53.6,"y":54.73,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":0,"scale":16.34,"x":69.64,"y":54.96,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":1},{"rotation":270,"scale":16.04,"x":85.72,"y":55.23,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":225,"scale":17.07,"x":57.53,"y":63.08,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":225,"scale":17.08,"x":82,"y":63.1,"shape":"triangle","paletteIndex":1,"colorIndex":2}]',
    '[{"rotation":0,"scale":12.55,"x":70.28,"y":23.28,"shape":"square","paletteIndex":1,"colorIndex":3},{"rotation":945,"scale":12.89,"x":61,"y":29.52,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":720,"scale":9.15,"x":74.73,"y":34.03,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":2},{"rotation":0,"scale":17.45,"x":70.23,"y":47.22,"shape":"square","paletteIndex":1,"colorIndex":4},{"rotation":810,"scale":17.08,"x":70.18,"y":64.58,"shape":"square","paletteIndex":1,"colorIndex":0},{"rotation":1305,"scale":12.09,"x":69.95,"y":73.43,"shape":"triangle","paletteIndex":1,"colorIndex":1}]',
    '[{"rotation":90,"scale":22.78,"x":70.09,"y":40.24,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":270,"scale":22.89,"x":70.02,"y":40.15,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":0,"scale":22.5,"x":70.05,"y":62.95,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":180,"scale":22.5,"x":70.15,"y":63.1,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":45,"scale":10,"x":88.5,"y":60.5,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":4},{"rotation":315,"scale":10,"x":51.75,"y":60.25,"shape":"parallelogram_right","paletteIndex":1,"colorIndex":0}]',
    '[{"rotation":0,"scale":26.86,"x":76.43,"y":41.37,"shape":"square","paletteIndex":1,"colorIndex":4},{"rotation":0,"scale":13.25,"x":56.4,"y":34.71,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":180,"scale":13.12,"x":56.46,"y":34.79,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":0,"scale":13.2,"x":56.64,"y":47.77,"shape":"square","paletteIndex":1,"colorIndex":1},{"rotation":225,"scale":33.42,"x":69.2,"y":54.41,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":270,"scale":14.61,"x":84.29,"y":62.9,"shape":"triangle","paletteIndex":1,"colorIndex":2}]',
    '[{"rotation":0,"scale":14.56,"x":70.63,"y":27.6,"shape":"square","paletteIndex":1,"colorIndex":2},{"rotation":90,"scale":14.75,"x":70.63,"y":42.13,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":135,"scale":20.57,"x":78,"y":49.33,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":540,"scale":14.25,"x":70.52,"y":56.28,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":225,"scale":24.86,"x":65.01,"y":63.5,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":270,"scale":17.51,"x":73.83,"y":72.17,"shape":"triangle","paletteIndex":1,"colorIndex":2}]'
  },
  [7] = {
    '[{"rotation":45,"scale":15.53,"x":77.16,"y":41.75,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":225,"scale":15.99,"x":65.81,"y":30.54,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":45,"scale":15.89,"x":54.52,"y":41.64,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":585,"scale":15.95,"x":54.74,"y":41.6,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":495,"scale":16.16,"x":66.08,"y":52.77,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":315,"scale":27.23,"x":66.31,"y":61.05,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":585,"scale":27.37,"x":85.47,"y":41.71,"shape":"triangle","paletteIndex":1,"colorIndex":0}]',
    '[{"rotation":270,"scale":24,"x":57.35,"y":34.6,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":180,"scale":24.08,"x":81.45,"y":34.62,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":90,"scale":16.1,"x":53.6,"y":54.73,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":0,"scale":16.34,"x":69.64,"y":54.96,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":1},{"rotation":270,"scale":16.04,"x":85.72,"y":55.23,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":225,"scale":17.07,"x":57.53,"y":63.08,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":225,"scale":17.08,"x":82,"y":63.1,"shape":"triangle","paletteIndex":1,"colorIndex":2}]',
    '[{"rotation":0,"scale":12.55,"x":70.28,"y":23.28,"shape":"square","paletteIndex":1,"colorIndex":3},{"rotation":945,"scale":12.89,"x":61,"y":29.52,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":45,"scale":12.77,"x":70.25,"y":38.46,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":225,"scale":12.77,"x":79,"y":29.54,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":0,"scale":17.45,"x":70.23,"y":47.22,"shape":"square","paletteIndex":1,"colorIndex":4},{"rotation":810,"scale":17.08,"x":70.18,"y":64.58,"shape":"square","paletteIndex":1,"colorIndex":0},{"rotation":1305,"scale":12.09,"x":69.95,"y":73.43,"shape":"triangle","paletteIndex":1,"colorIndex":1}]',
    '[{"rotation":90,"scale":22.68,"x":70.34,"y":39.99,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":135,"scale":10.72,"x":66.43,"y":51.38,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":45,"scale":10.84,"x":73.98,"y":44.03,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":0},{"rotation":135,"scale":21.3,"x":81.55,"y":59.2,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":180,"scale":22.5,"x":70.15,"y":62.6,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":315,"scale":10,"x":51.75,"y":59.75,"shape":"parallelogram_right","paletteIndex":1,"colorIndex":0},{"rotation":45,"scale":10,"x":88.5,"y":60,"shape":"parallelogram_left","paletteIndex":1,"colorIndex":4}]',
    '[{"rotation":0,"scale":26.86,"x":76.43,"y":41.37,"shape":"square","paletteIndex":1,"colorIndex":4},{"rotation":0,"scale":13.25,"x":56.4,"y":34.71,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":180,"scale":13.12,"x":56.46,"y":34.79,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":0,"scale":13.24,"x":56.33,"y":47.92,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":180,"scale":12.8,"x":56.5,"y":48,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":225,"scale":33.42,"x":69.2,"y":54.41,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":270,"scale":14.61,"x":84.29,"y":62.9,"shape":"triangle","paletteIndex":1,"colorIndex":2}]',
    '[{"rotation":0,"scale":14.56,"x":70.63,"y":27.6,"shape":"square","paletteIndex":1,"colorIndex":2},{"rotation":90,"scale":14.75,"x":70.63,"y":42.13,"shape":"triangle","paletteIndex":1,"colorIndex":3},{"rotation":135,"scale":20.57,"x":78,"y":49.33,"shape":"triangle","paletteIndex":1,"colorIndex":0},{"rotation":540,"scale":14.25,"x":70.52,"y":56.28,"shape":"triangle","paletteIndex":1,"colorIndex":1},{"rotation":225,"scale":24.86,"x":65.01,"y":63.5,"shape":"triangle","paletteIndex":1,"colorIndex":4},{"rotation":135,"scale":12.4,"x":82.51,"y":72.25,"shape":"triangle","paletteIndex":1,"colorIndex":2},{"rotation":45,"scale":12.77,"x":73.75,"y":81.21,"shape":"triangle","paletteIndex":1,"colorIndex":3}]'
  }
}

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ClarityData.getTangramLayout(numberOfPieces)
  local layoutForMode = TANGRAM_LAYOUT_JSON_STRINGS[numberOfPieces]
  assert(layoutForMode ~= nil, string.format("No tangram layouts found for %d pieces.", numberOfPieces))

  local randomLayoutIndex = math.random(#layoutForMode)
  local jsonString = layoutForMode[randomLayoutIndex]

  local layoutJSON = MOAIJsonParser.decode(jsonString)

  for _, tangram in pairs(layoutJSON) do

    -- Colors
    local colorIndex = tangram.colorIndex + 1
    tangram.color = ClarityColors.getPaletteColor(colorIndex)

    -- Fix widths
    tangram.width = tangram.scale

    -- MOAI rotation is flipped
    tangram.rotation = -tangram.rotation
  end

  return layoutJSON
end

function ClarityData.getInstructionsString()
  return REDUCIBLE_INSTRUCTIONS_STRING
end

function ClarityData.getReplacementInstructionsString()
  return REPLACEMENT_INSTRUCTIONS_STRING
end
