--- ClarityHelpLayer
-- @author created by Jay Austria on May 1, 2014

class("ClarityHelpLayer")

require("tutorials.TutorialHighlighter")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local OVERLAY_COLOR = {0.04, 0.05, 0.08, 0.3}

local FADE_IN_DURATION = 0.167
local FADE_OUT_DURATION = 0.033

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ClarityHelpLayer:fadeOutAndRemove()
  wait(self:createFadeAndClearHighlightsAction(FADE_OUT_DURATION):start())
  self:disposeOfSelf()
  self:removeSelf()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function ClarityHelpLayer.newWithMasks(highlightShapeFactories)
  local self = TutorialHighlighter.newWithMasks(highlightShapeFactories)
  Mixin.mix(self, ClarityHelpLayer)

  self:setOverlayColor(unpack(OVERLAY_COLOR))
  self:setPulseSize(5)

  self:createFadeInAnimation(FADE_IN_DURATION):start()

  return self
end
