--- ClarityParticles
-- @author created by Jay Austria sometime in March, 2014

class("ClarityParticles")
require("Particles")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local PARTICLES_FILENAME = "circular_particles.pex"
local NUMBER_OF_PARTICLES_TO_SURGE = 50
local DELAY_BEFORE_REMOVING_PARTICLES = 3.0

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ClarityParticles:emit()
  local function emitParticles()
      self:start()
      self:surge(NUMBER_OF_PARTICLES_TO_SURGE)
      waitFor(DELAY_BEFORE_REMOVING_PARTICLES)
      self:stop()
      self:removeSelf()
  end
  runInCoroutine(emitParticles)
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function ClarityParticles.newWithColor(color)
  local self = Particles.new(PARTICLES_FILENAME)
  Mixin.mix(self, ClarityParticles)

  self:setStartColor(unpack(color))
  self:setFinishColor(unpack(color))

  return self
end
