--- ClarityShapeUtils
-- @author created by Jay Austria sometime in March, 2014

class("ClarityShapeUtils")
function ClarityShapeUtils.getVerticesOfBoxWithDims(width, height)
  return
  {
    {
      x = -width * 0.5,
      y = -height * 0.5
    },
    {
      x = -width * 0.5,
      y = height * 0.5
    },
    {
      x = width * 0.5,
      y = height * 0.5
    },
    {
      x = width * 0.5 ,
      y = -height * 0.5
    }
  }
end

function ClarityShapeUtils.getEndVerticesForShape(shape, width)
  local halfW = width * 0.5
  local oneAndHalfW = width * 1.5
  if (shape == "square") then
    return
    {
      {
        x = -halfW,
        y = -halfW
      },
      {
        x = -halfW,
        y = halfW
      },
      {
        x = halfW,
        y = halfW
      },
      {
        x = halfW,
        y = -halfW
      }
    }
  elseif (shape == "triangle") then
    return
    {
      {
        x = -halfW,
        y = -halfW
      },
      {
        x = -halfW,
        y = -halfW,
      },
      {
        x = halfW,
        y = halfW
      },
      {
        x = halfW,
        y = -halfW
      }
    }
    elseif (shape == "parallelogram_right") then
      return
      {
        {
          x = -oneAndHalfW,
          y = -halfW
        },
        {
          x = -halfW,
          y = halfW
        },
        {
          x = oneAndHalfW,
          y = halfW
        },
        {
          x = halfW,
          y = -halfW
        }
      }
    elseif (shape == "parallelogram_left") then
      return
      {
        {
          x = -halfW,
          y = -halfW
        },
        {
          x = -oneAndHalfW,
          y = halfW
        },
        {
          x = halfW,
          y = halfW
        },
        {
          x = oneAndHalfW,
          y = -halfW
        }
      }
  end
end
