--- CollateUnitConversionMatrix
-- @author Created by Jay Austria on May 15, 2014.

-- Formatted by Content team. Can't be done programmatically
HINT_STRINGS =
{
  -- Distances:
  ["millimeters"] =
  {
    ["millimeters"] = "1 mm = 1 mm",
    ["centimeters"] = "10 mm = 1 cm",
    ["inches"] = "25.4 mm ≈ 1 inch",
    ["feet"] = "305 mm ≈ 1 foot",
    ["yards"] = "914 mm ≈ 1 yard",
    ["meters"] = "1000 mm = 1 meter",
    ["kilometers"] = "1,000,000 mm = 1 km",
    ["miles"] = "1,600,000 mm ≈ 1 mile"
  },

  ["centimeters"] =
  {
    ["millimeters"] = "1 cm = 10 mm",
    ["centimeters"] = "1 cm = 1 cm",
    ["inches"] = "2.54 cm ≈ 1 inch",
    ["feet"] = "30.5 cm ≈ 1 foot",
    ["yards"] = "91 cm ≈ 1 yard",
    ["meters"] = "100 cm = 1 meter",
    ["kilometers"] = "100,000 cm = 1 km",
    ["miles"] = "160,000 cm ≈ 1 mile"
  },

  ["inches"] =
  {
    ["millimeters"] = "1 inch ≈ 25.4 mm",
    ["centimeters"] = "1 inch ≈ 2.54 cm",
    ["inches"] = "1 inch = 1 inch",
    ["feet"] = "12 inches = 1 foot",
    ["yards"] = "36 inches = 1 yard",
    ["meters"] = "39.4 inches ≈ 1 meter",
    ["kilometers"] = "39,370 inches ≈ 1 km",
    ["miles"] = "63,360 inches = 1 mile"
  },

  ["feet"] =
  {
    ["millimeters"] = "1 foot ≈ 305 mm",
    ["centimeters"] = "1 foot ≈ 30.5 cm",
    ["inches"] = "1 foot = 12 inches",
    ["feet"] = "1 foot = 1 foot",
    ["yards"] = "3 feet = 1 yard",
    ["meters"] = "3.3 feet ≈ 1 meter",
    ["kilometers"] = "3280 feet ≈ 1 km",
    ["miles"] = "5,280 feet = 1 mile"
  },

  ["yards"] =
  {
    ["millimeters"] = "1 yard ≈ 910 mm",
    ["centimeters"] = "1 yard ≈ 91 cm",
    ["inches"] = "1 yard = 36 inches",
    ["feet"] = "1 yard = 3 feet",
    ["yards"] = "1 yard = 1 yard",
    ["meters"] = "1 yard ≈ 0.9 meters",
    ["kilometers"] = "1,093 yards ≈ 1 km",
    ["miles"] = "1,760 yards = 1 mile"
  },

  ["meters"] =
  {
    ["millimeters"] = "1 meter = 1,000 mm",
    ["centimeters"] = "1 meter = 100 cm",
    ["inches"] = "1 meter ≈ 39.4 inches",
    ["feet"] = "1 meter ≈ 3.3 feet",
    ["yards"] = "1 meter ≈ 1.1 yards",
    ["meters"] = "1 meter = 1 meter",
    ["kilometers"] = "1,000 meters = 1 km",
    ["miles"] = "1,609 meters ≈ 1 mile"
  },

  ["kilometers"] =
  {
    ["millimeters"] = "1 km = 1,000,000 mm",
    ["centimeters"] = "1 km = 100,000 cm",
    ["inches"] = "1 km ≈ 39,370 inches",
    ["feet"] = "1 km ≈ 3,281 feet",
    ["yards"] = "1 km ≈ 1,094 yards",
    ["meters"] = "1 km = 1,000 meters",
    ["kilometers"] = "1 km = 1 km",
    ["miles"] = "1 km ≈ 0.6 miles"
  },

  ["miles"] =
  {
    ["millimeters"] = "1 mile ≈ 1,600,000 mm",
    ["centimeters"] = "1 mile ≈ 160,000 cm",
    ["inches"] = "1 mile = 63,360 inches",
    ["feet"] = "1 mile = 5,280 feet",
    ["yards"] = "1 mile = 1,760 yards",
    ["meters"] = "1 mile ≈ 1,600 meters",
    ["kilometers"] = "1 mile ≈ 1.6 km",
    ["miles"] = "1 mile = 1 mile"
  },

  -- Fluid [Not Currently Used]:
  ["milliliters"] =
  {
    ["milliliters"] = "1 ml = 1 ml",
    ["fluid ounces"] = "1 ml ≈ 0.034 ounces",
    ["cups"] = "1 ml ≈ 0.004 cups",
    ["pints"] = "1 ml ≈ 0.002 pints",
    ["quarts"] = "1 ml ≈ 0.00106 quarts",
    ["liters"] = "1 ml = 0.001 liters",
    ["gallons"] = "1 ml = 0.00026 gallons"
  },

  ["fluid ounces"] =
  {
    ["milliliters"] = "1 ounce ≈ 29.574 ml",
    ["fluid ounces"] = "1 ounce = 1 ounce",
    ["cups"] = "1 ounce = 0.125 cups",
    ["pints"] = "1 ounce = 0.0625 pints",
    ["quarts"] = "1 ounce = 0.03125 quarts",
    ["liters"] = "1 ounce ≈ 0.0296 liters",
    ["gallons"] = "1 ounce ≈ 0.0078 gallons"
  },

  ["cups"] =
  {
    ["milliliters"] = "1 cup ≈ 236.588 ml",
    ["fluid ounces"] = "1 cup = 8 ounces",
    ["cups"] = "1 cup = 1 cup",
    ["pints"] = "1 cup = 0.5 pints",
    ["quarts"] = "1 cup = 0.25 quarts",
    ["liters"] = "1 cup ≈ 0.2366 liters",
    ["gallons"] = "1 cup = 0.0625 gallons"
  },

  ["pints"] =
  {
    ["milliliters"] = "1 pint ≈ 473.18 ml",
    ["fluid ounces"] = "1 pint = 16 ounces",
    ["cups"] = "1 pint = 2 cups",
    ["pints"] = "1 pint = 1 pint",
    ["quarts"] = "1 pint = 0.5 quarts",
    ["liters"] = "1 pint ≈ 0.4732 liters",
    ["gallons"] = "1 pint = 0.125 gallons"
  },

  ["quarts"] =
  {
    ["milliliters"] = "1 quart ≈ 946.353 ml",
    ["fluid ounces"] = "1 quart = 32 ounces",
    ["cups"] = "1 quart = 4 cups",
    ["pints"] = "1 quart = 2 pints",
    ["quarts"] = "1 quart = 1 quart",
    ["liters"] = "1 quart ≈ 0.946 liters",
    ["gallons"] = "1 quart = 0.25 gallons"
  },

  ["liters"] =
  {
    ["milliliters"] = "1 liter = 1,000 ml",
    ["fluid ounces"] = "1 liter ≈ 33.814 ounces",
    ["cups"] = "1 liter ≈ 4.227 cups",
    ["pints"] = "1 liter ≈ 2.113 pints",
    ["quarts"] = "1 liter ≈ 1.057 quarts",
    ["liters"] = "1 liter = 1 liter",
    ["gallons"] = "1 liter ≈ 0.264 gallons"
  },

  ["gallons"] =
  {
    ["milliliters"] = "1 gallon = 3,785.4 ml",
    ["fluid ounces"] = "1 gallon = 128 ounces",
    ["cups"] = "1 gallon = 16 cups",
    ["pints"] = "1 gallon = 8 pints",
    ["quarts"] = "1 gallon = 4 quarts",
    ["liters"] = "1 gallon ≈ 3.785 liters",
    ["gallons"] = "1 gallon = 1 gallon"
  },

  -- Mass:
  ["grams"] =
  {
    ["grams"] = "1 gram = 1 gram",
    ["ounces"] = "28 grams ≈ 1 ounce",
    ["pounds"] = "454 grams ≈ 1 pound",
    ["kilograms"] = "1,000 grams = 1 kg",
    ["tons"] = "907,000 grams ≈ 1 ton"
  },

  ["ounces"] =
  {
    ["grams"] = "1 ounce ≈ 28 grams",
    ["ounces"] = "1 ounce = 1 ounce",
    ["pounds"] = "16 ounces = 1 pound",
    ["kilograms"] = "35 ounces ≈ 1 kg",
    ["tons"] = "32,000 ounces = 1 ton"
  },

  ["pounds"] =
  {
    ["grams"] = "1 pound ≈ 454 grams",
    ["ounces"] = "1 pound = 16 ounces",
    ["pounds"] = "1 pound = 1 pound",
    ["kilograms"] = "2.2 pounds ≈ 1 kg",
    ["tons"] = "2,000 pounds = 1 ton"
  },

  ["kilograms"] =
  {
    ["grams"] = "1 kg = 1,000 grams",
    ["ounces"] = "1 kg ≈ 35 ounces",
    ["pounds"] = "1 kg ≈ 2.2 pounds",
    ["kilograms"] = "1 kg = 1 kg",
    ["tons"] = "907 kg ≈ 1 ton"
  },

  ["tons"] =
  {
    ["grams"] = "1 ton ≈ 907,000 grams",
    ["ounces"] = "1 ton = 32,000 ounces",
    ["pounds"] = "1 ton = 2,000 pounds",
    ["kilograms"] = "1 ton ≈ 907 kg",
    ["tons"] = "1 ton = 1 ton"
  }
}
