--- CommasCommon
-- @author Created by andrewc on May 30, 2019.

class("CommasCommon")

-- Misc -----------------------

CommasCommon.MISSING_COMMA_TAG_LABEL = "comma"
CommasCommon.DISTRACTOR_COMMA_TAG_LABEL = "distractor"
CommasCommon.PREPOPULATED_COMMA_TAG_LABEL = "prepopulated"
CommasCommon.OXFORD_COMMA_TAG_LABEL = "oxford"

CommasCommon.IGNORE_WORD = "ignore"

CommasCommon.IS_CORRECT_ATTRIBUTE = "isCorrect"
CommasCommon.IS_INCORRECT_ATTRIBUTE = "isIncorrect"
CommasCommon.IS_FOUND_ATTRIBUTE = "isFound"
CommasCommon.IS_OXFORD_ATTRIBUTE = "isOxford"

CommasCommon.REFERENCE_COMMA = nil

CommasCommon.FONT = {
  RATIONALE = Font.new(FontFaces.DIN_OT_MEDIUM, 20),
  RATIONALE_ITALIC = Font.new(FontFaces.DIN_OT_MEDIUM_ITALIC, 20),
  LEARN_MORE = Font.new(FontFaces.DIN_OT_MEDIUM, 16),
  SMALL = Font.new(FontFaces.TISA_REGULAR, 24),
  TINY = Font.new(FontFaces.DIN_OT_MEDIUM, 12),
  TAP_TO_CONTINUE = Font.new(FontFaces.DIN_OT_MEDIUM, 15),
  MAIN_TEXT = Font.new(FontFaces.MERRIWEATHER_REGULAR, 25),
  MAIN_TEXT_ITALIC = Font.new(FontFaces.MERRIWEATHER_ITALIC, 25),
  COMMA = Font.new(FontFaces.NUNITO_REGULAR, 38),
  HELPER_TEXT = Font.new(FontFaces.DIN_OT_MEDIUM, 18),
  TIMES_UP = Font.new(FontFaces.DIN_OT_MEDIUM, 57),
  ENCOURAGEMENT = Font.new(FontFaces.DIN_OT_MEDIUM, 18)
}

-- Animation Speeds -------------------------

CommasCommon.LASER_TIME = 0.4

CommasCommon.TEXT_ANIMATION = {
  MOVE = 0.238,
  SHOW = 0.167,
  HIDE = 0.1,
  COMMA_MOVE = 0.15
}

CommasCommon.ROUND_TRANSITION_OUT = 0.333
CommasCommon.ROUND_TRANSITION_IN = 0.5

CommasCommon.RATIONALE_IN = 0.75
CommasCommon.RATIONALE_OUT = 0.5

CommasCommon.RATIONALE_IN_CURVE = AHEaseBezier.newFlat({0.55,0.2,0,1})

-- ----------------------------------------------------------------------------
-- Helpful Functions
-- ----------------------------------------------------------------------------

function CommasCommon.offsetItemToComma(item)
  item:offsetX(2 + (CommasCommon.REFERENCE_COMMA:getWidth() * 0.5))
  item:offsetY(1 - (CommasCommon.REFERENCE_COMMA:getHeight() * 0.25))
end

function CommasCommon.getWidthOfComma()
  return CommasCommon.REFERENCE_COMMA:getWidth()
end

function CommasCommon.initialize()
  CommasCommon.REFERENCE_COMMA = Label.new(",", CommasCommon.FONT.COMMA)
end
