--- CommasHelperText
-- @author Created by andrewc on June 20, 2019.

class("CommasHelperText")

require("CommasCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function fadeTo(self, opacity)
  if self.currentAnim then
    self.currentAnim:stop()
  end
  local duration = 0.5
  local ease = AHEaseBezier.newFlat({0.35,0.04,0.65,0.95})

  local fade = AHOpacityTo.new(self.label, duration, ease, opacity)
  self.currentAnim = fade
  fade:start()
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function CommasHelperText:setupText()
  local text = Localizer.get("HELPER")
  self.label:setText(text)
end

function CommasHelperText:show()
  fadeTo(self, 1)
end

function CommasHelperText:hide()
  fadeTo(self, 0)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function CommasHelperText.new()
  local self = Group.new(Screen.width, Screen.height * 0.1)
  Mixin.mix(self, CommasHelperText)

  local font = CommasCommon.FONT.HELPER_TEXT
  local width = Screen.width * 0.7
  local label = DynamicTextArea.newSimple("", width, font, Alignment.CENTER, Alignment.CENTER)

  self:insertAtCenter(label)
  self.label = label

  self.label:setOpacity(0)

  self.currentAnim = nil

  return self
end
