--- CommasRoundGenerator
-- @author Created by andrewcousins on April 11, 2023.

class("CommasRoundGenerator")

require("CommasRound")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function CommasRoundGenerator:next()
  local roundObject = self.conceptGenerator:generateNextValue()
  if (roundObject == nil) then
    self.conceptGenerator:reset()
    roundObject = self.conceptGenerator:generateNextValue()
  end
  local nextRound = CommasRound.new(roundObject, self.maximumNumberOfCommas)
  if nextRound:getNumberOfInteractions() == self.maximumNumberOfCommas then
    self.maximumNumberOfCommas = self.maximumNumberOfCommas + 1
  end
  return nextRound
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function CommasRoundGenerator.new(conceptGenerator)
  local self = {}
  Mixin.mix(self, CommasRoundGenerator)

  self.conceptGenerator = conceptGenerator
  self.maximumNumberOfCommas = 1

  return self
end
