--- CommasTextAnimationBuilder
-- @author Created by andrewc on June 14, 2019.

class("CommasTextAnimationBuilder")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function CommasTextAnimationBuilder:_createAllMoveItemAnimations(oldItemLayouts, newItemLayouts)
  local moveAnimations = self.super._createAllMoveItemAnimations(self, oldItemLayouts, newItemLayouts)

  local forceWaitForMoveDuration = AHDelay.new(self.moveDuration)

  moveAnimations:addAction(forceWaitForMoveDuration)

  return moveAnimations
end

function TextAnimationBuilder:createItemsInsertedAnimation(textView, oldItemLayouts, newItemLayouts, newHeight)
  local moveAnimations = self:_createAllMoveItemAnimations(oldItemLayouts, newItemLayouts)
  local showAnimations = self:_createAllShowItemAnimations(textView, oldItemLayouts, newItemLayouts)
  local adjustHeightAnimation = self:_createAdjustHeightAnimationIfNeeded(textView, newHeight)
  local animation = AHSequence.new(AHSpawn.new(moveAnimations, adjustHeightAnimation), AHDelay.new(CommasCommon.TEXT_ANIMATION.COMMA_MOVE), showAnimations)
  return animation
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function CommasTextAnimationBuilder.new()
  local self = TextAnimationBuilder.new()
  Mixin.mix(self, CommasTextAnimationBuilder)

  self.moveDuration = CommasCommon.TEXT_ANIMATION.MOVE
  self.showDuration = CommasCommon.TEXT_ANIMATION.SHOW
  self.hideDuration = CommasCommon.TEXT_ANIMATION.HIDE
  self.adjustHeightDuration = CommasCommon.TEXT_ANIMATION.MOVE

  return self
end
