--- ContentReviewTextViewMemory
-- @author Created by Joe Poka on September 27, 2016.

class("ContentReviewTextViewMemory")

require("ContentReviewCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ContentReviewTextViewMemory:getAnimatedWordView()
  local views = self:getItemViews()
  return views[2]
end

function ContentReviewTextViewMemory:createViewForTextItem(item)
  local text = item:getText()
  local font = item:getFont()
  local color = item:getAttribute("color")

  local label = Label.new(text, font)
  if (color) then
    label:setColor(unpack(color))
  end

  return label
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ContentReviewTextViewMemory.new(words, textWidth, baseAttributesList)
  local self = TextView.new(textWidth, Alignment.CENTER)
  Mixin.mix(self, ContentReviewTextViewMemory)

  self.items = {}
  local attributesForLabels = {}

  for i = 1, #words do
    local word = words[i]
    local baseAttributes = baseAttributesList[i]
    local textInterpreter = TextInterpreter.new(baseAttributes, attributesForLabels)
    local items = textInterpreter:interpretXmlText(word)
    local item = items[1]
    item:setSkipNextSpacing(true)
    table.insert(self.items, item)
  end

  local textModel = TextModel.new(self.items)
  self:setModel(textModel)

  return self
end
