--- ContentReviewTextViewPrompt
-- @author Created by Joe Poka on July 12, 2016.

class("ContentReviewTextViewPrompt")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ContentReviewTextViewPrompt.new(xmlText, textWidth, fontSize)
  fontSize = fontSize or 28.0
  local skillName = ContentReviewCommon.SKILL

  local playingSpelling = (skillName == ContentReviewCommon.GAMES.SPELLING)
  local playingAdjectiveRecall = (skillName == ContentReviewCommon.GAMES.ADJECTIVE_RECALL)
  local playingAgility = (skillName == ContentReviewCommon.GAMES.AGILITY)
  
  local fontFace = FontFaces.DIN_OT_LIGHT
  if (playingSpelling or playingAdjectiveRecall or playingAgility) then
    fontFace = FontFaces.DIN_OT_BOLD
  end

  local baseAttributes = {
    font = Font.new(fontFace, fontSize),
    color = ContentReviewCommon.Colors.darkGray
  }

  local playingBrevity = (skillName == ContentReviewCommon.GAMES.BREVITY)
  local strikeColor = ContentReviewCommon.Colors.lightGray
  if (playingBrevity) then
    strikeColor = ContentReviewCommon.Colors.strikeRed
  end

  local strikeAttributes = {
    color = strikeColor,
    strike = true
  }

  local attributesForLabels = {
    highlight = {
      color = ContentReviewCommon.Colors.correctGreen
    },
    reduce = strikeAttributes,
    strike = strikeAttributes,
    drop = strikeAttributes
  }

  local lineSpacing = nil
  local horizontalAlignment = nil
  local verticalAlignment = nil

  local self = ContentReviewTextView.new(xmlText, textWidth, baseAttributes, attributesForLabels, lineSpacing, horizontalAlignment, verticalAlignment)
  Mixin.mix(self, ContentReviewTextViewPrompt)

  return self
end
