--- ContentReviewTextViewRationale
-- @author Created by Joe Poka on July 12, 2016.

class("ContentReviewTextViewRationale")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ContentReviewTextViewRationale.new(xmlText, textWidth, fontSize, horizontalAlignment)
  fontSize = fontSize or 17.0

  local baseAttributes = {
    font = Font.new(FontFaces.DIN_OT_MEDIUM, fontSize),
    color = ContentReviewCommon.Colors.lightGray
  }

  local attributesForLabels = {
    i = {
      font = Font.new(FontFaces.DIN_OT_MEDIUM, fontSize),
      color = ContentReviewCommon.Colors.darkGray
    },
    strong = {
      font = Font.new(FontFaces.DIN_OT_MEDIUM, fontSize),
      color = ContentReviewCommon.Colors.darkGray
    },
    em = {
      font = Font.new(FontFaces.DIN_OT_MEDIUM, fontSize),
      color = ContentReviewCommon.Colors.darkGray
    }
  }

  local lineSpacing = textWidth * 0.014
  local verticalAlignment= nil

  local self = ContentReviewTextView.new(xmlText, textWidth, baseAttributes, attributesForLabels, lineSpacing, horizontalAlignment, verticalAlignment)
  Mixin.mix(self, ContentReviewTextViewRationale)

  return self
end

function ContentReviewTextViewRationale.newWithHexagon(xmlText, textWidth)
  local fontSize = 16
  return ContentReviewTextViewRationale.new(xmlText, textWidth, fontSize)
end
