--- CrossColors
-- @author Created by andrewcousins on May 15, 2023.

class("CrossColors")


local COLOR_WHITE = {1, 1, 1}
local COLOR_BLACK = {0, 0, 0}
local COLOR_BLUE = {0.00, 0.71, 0.85}
local COLOR_BUTTON_BLUE = ColorUtils.colorHex24ToStd(0x05C3F9)
local COLOR_BLUE_DOWNSTATE = ColorUtils.colorHex24ToStd(0x00A6C7)
local COLOR_BLUE_WHITE_BORDER = ColorUtils.colorHex24ToStd(0x82E1FC)

CrossColors.WHITE = COLOR_WHITE
CrossColors.BLACK = COLOR_BLACK

CrossColors.BACKGROUND = COLOR_BLUE
CrossColors.UI_COMPONENTS = COLOR_WHITE

CrossColors.CELL_SURFACE = COLOR_WHITE
CrossColors.CELL_SURFACE_DOWNSTATE = {0.32, 0.84, 0.59}
CrossColors.CELL_SHADOW = {0.83, 0.89, 0.90}
CrossColors.CELL_CURSOR_SURFACE = {0.47, 1.0, 0.75}
CrossColors.CELL_CURSOR_SURFACE_DOWNSTATE = {0.32, 0.84, 0.59}
CrossColors.CELL_CURSOR_SHADOW = {0.4, 0.9, 0.7}
CrossColors.CELL_BACKGROUND = ColorUtils.colorHex24ToStd(0x00A6C7)
CrossColors.CELL_OUTLINE = {0.1, 0.1, 0.1}
CrossColors.CELL_LABEL = {0.1, 0.1, 0.1}
CrossColors.CELL_CLUE_INDEX_LABEL = {0.5, 0.5, 0.5}
CrossColors.CELL_REVEALED_ICON = {0.02, 0.76, 0.98}
CrossColors.CELL_CHECKED_INCORRECT = ColorUtils.colorHex24ToStd(0xFE4358)

CrossColors.KEYBOARD_BACKGROUND = ColorUtils.colorHex24ToStd(0xABD0DC)
CrossColors.KEYBOARD_KEY = {0.99, 0.99, 1.0}
CrossColors.KEYBOARD_KEY_POP_UP_OUTLINE = {0.88, 0.87, 0.88}
CrossColors.KEYBOARD_DELETE_KEY = ColorUtils.colorHex24ToStd(0x84B7C7)
CrossColors.KEYBOARD_KEY_DROPSHADOW = ColorUtils.colorHex24ToStd(0x80B1C0)
CrossColors.KEYBOARD_TEXT = COLOR_BLACK

CrossColors.CLUE_BACKGROUND = COLOR_BLUE
CrossColors.CLUE_TEXT = COLOR_WHITE
CrossColors.CLUE_DOWNSTATE = COLOR_BLUE_DOWNSTATE
CrossColors.CLUE_LINE = COLOR_BLUE_WHITE_BORDER

CrossColors.UI_BUTTON_TEXT = COLOR_WHITE
CrossColors.UI_BUTTON_BORDER = COLOR_BLUE_WHITE_BORDER
CrossColors.UI_BUTTON = COLOR_BLUE
CrossColors.UI_BUTTON_DOWNSTATE = COLOR_BLUE_DOWNSTATE

CrossColors.TRAY = COLOR_WHITE
CrossColors.TRAY_TEXT = {0.2, 0.2, 0.2}
CrossColors.TRAY_DESCRIPTION = {0.4, 0.4, 0.4}
CrossColors.TRAY_BUTTON_TEXT = {0.2, 0.2, 0.2}
CrossColors.TRAY_BUTTON_BACKGROUND = {0.85, 0.9, 0.92}
CrossColors.TRAY_BUTTON_OUTLINE = {0.95, 0.97, 0.97}
CrossColors.TRAY_BUTTON_SHADOW = {0.91, 0.94, 0.95}
CrossColors.TRAY_BUTTON_SURFACE = COLOR_WHITE
CrossColors.TRAY_BUTTON_TOGGLE_BACKING = {0.84, 0.84, 0.84}
CrossColors.TRAY_BUTTON_TOGGLE_BACKING_ACTIVE = ColorUtils.colorHex24ToStd(0x05C3F9)
CrossColors.TRAY_BUTTON_TOGGLE_SWITCH = COLOR_WHITE
CrossColors.TRAY_OVERLAY = {0, 0, 0, 0.3}

CrossColors.POP_UP_SCREEN_CARD_BUTTON = COLOR_BUTTON_BLUE
CrossColors.POP_UP_SCREEN_CARD_BUTTON_TEXT = COLOR_WHITE
CrossColors.POP_UP_SCREEN_CARD_SECONDARY_BUTTON_TEXT = COLOR_BUTTON_BLUE
CrossColors.POP_UP_SCREEN_CARD_TEXT = {0.1, 0.1, 0.1}
CrossColors.POP_UP_SCREEN_BACKGROUND = COLOR_BLACK
CrossColors.POP_UP_SCREEN_CARD = COLOR_WHITE
CrossColors.POP_UP_SCREEN_CARD_SUBTITLE = {0.6, 0.6, 0.6}

CrossColors.COMPLETION_SCREEN_BACKGROUND = COLOR_BLUE
CrossColors.COMPLETION_SCREEN_TEXT = COLOR_WHITE
CrossColors.COMPLETION_SCREEN_SUBTITLE = COLOR_WHITE
CrossColors.COMPLETION_SCREEN_BUTTON = COLOR_WHITE
CrossColors.COMPLETION_SCREEN_BUTTON_TEXT = COLOR_BUTTON_BLUE
CrossColors.COMPLETION_SCREEN_XP_BACKGROUND = ColorUtils.colorHex24ToStd(0x34C3E0)

CrossColors.FEEDBACK_SCREEN_BACKGROUND = COLOR_BLUE
CrossColors.FEEDBACK_SCREEN_TEXT = COLOR_WHITE
CrossColors.FEEDBACK_SCREEN_BUTTON_OUTLINE = COLOR_WHITE
CrossColors.FEEDBACK_SCREEN_BUTTON_TEXT = COLOR_WHITE
CrossColors.FEEDBACK_SCREEN_BUTTON_TEXT_SELECTED = COLOR_BLUE

CrossColors.POST_GAME_SCREEN_BUTTON = COLOR_WHITE
CrossColors.POST_GAME_SCREEN_BUTTON_TEXT = COLOR_BUTTON_BLUE
CrossColors.POST_GAME_SCREEN_INVERTED_BUTTON = COLOR_BLUE
CrossColors.POST_GAME_SCREEN_INVERTED_BUTTON_OUTLINE = COLOR_BLUE_WHITE_BORDER
CrossColors.POST_GAME_SCREEN_INVERTED_BUTTON_DOWNSTATE = COLOR_BLUE_DOWNSTATE
CrossColors.POST_GAME_SCREEN_INVERTED_BUTTON_TEXT = COLOR_WHITE
CrossColors.POST_GAME_SCREEN_INVERTED_BUTTON_TEXT_DOWNSTATE = COLOR_BLUE_WHITE_BORDER
