--- CrossHelpButton
-- @author Created by andrewcousins on April 05, 2022.

class("CrossHelpButton")

require("CrossUIButton")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BUTTON_ICON_NAME = "help_icon.png"
local ICON_SCALE = 0.6

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local helpIcon = Sprite.newWithName(BUTTON_ICON_NAME)
  local iconSize = self:getHeightPart(ICON_SCALE)
  helpIcon:setEffectiveDims(iconSize)

  self:insertAtCenter(helpIcon)

  local virtualButtonDirectionCapIsLeft = true
  self:setButtonWidth(self:getEffectiveWidth(), virtualButtonDirectionCapIsLeft, self.virtualButtonExtensionCap)
end

-- Constructor ------------------------

function CrossHelpButton.new(buttonPressedCallback, virtualButtonExtensionCap)
  local self = CrossUIButton.new(buttonPressedCallback)
  Mixin.mix(self, CrossHelpButton)

  self.virtualButtonExtensionCap = virtualButtonExtensionCap


  createLayout(self)
  self:linkOpacityToChildren()

  return self
end
