--- CrossResetConfirmationScreen
-- @author Created by andrewcousins on July 06, 2023.

class("CrossResetConfirmationScreen")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TITLE_TEXT = Localizer.get("RESET_CONFIRMATION_TITLE")
local SUB_TEXT = Localizer.get("RESET_CONFIRMATION_SUBTITLE")
local RESET_TEXT = Localizer.get("RESET")
local CANCEL_TEXT = Localizer.get("CANCEL")

local BACKGROUND_OPACITY = 0.3

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function CrossResetConfirmationScreen:hide()
  self:removeSelf()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function CrossResetConfirmationScreen.new(resetCallback)
  local self = CrossPopUpScreen.new(TITLE_TEXT, SUB_TEXT, RESET_TEXT, resetCallback, nil, CANCEL_TEXT, nil, BACKGROUND_OPACITY)
  Mixin.mix(self, CrossResetConfirmationScreen)

  return self
end
