--- DepthBackground
-- @author Created by Aaron Barrett on January 28, 2014.

class("DepthBackground")
-- ---------------------------------------------------------------------------
-- Configuration
-- ---------------------------------------------------------------------------

local START_TOP_COLOR = {0.43, 0.56, 0.64}
local START_BOTTOM_COLOR = {0.30, 0.31, 0.48}

local FINISH_TOP_COLOR = {0.56, 0.81, 0.81}
local FINISH_BOTTOM_COLOR = {0.47, 0.64, 0.69}

-- ---------------------------------------------------------------------------
-- Utility
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- API
-- ---------------------------------------------------------------------------

function DepthBackground:pause(isPaused)
  local tintAction = self.tintAction
  tintAction:pause(isPaused)
end

function DepthBackground:startTinting()
  local topColor = self:getBeginColor()
  local bottomColor = self:getEndColor()

  local topColorAction = AHColorTo.new(topColor, DepthConstants.GAME_DURATION, nil, FINISH_TOP_COLOR)
  local bottomColorAction = AHColorTo.new(bottomColor, DepthConstants.GAME_DURATION, nil, FINISH_BOTTOM_COLOR)

  local tintAction = AHSpawn.new(
                                 topColorAction,
                                 bottomColorAction
                                 )
  self.tintAction = tintAction
  tintAction:start()
end

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function DepthBackground.new()
  local self = RectangleGradient.new(Screen.width, Screen.height, START_TOP_COLOR, START_BOTTOM_COLOR)
  Mixin.mix(self, DepthBackground)

  return self
end
