--- DepthBubbleGenerator
-- @author Created by Aaron Barrett on January 28, 2014.

class("DepthBubbleGenerator")
-- ---------------------------------------------------------------------------
-- Configuration
-- ---------------------------------------------------------------------------




-- ---------------------------------------------------------------------------
-- Utility
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- API
-- ---------------------------------------------------------------------------

function DepthBubbleGenerator:pause(isPaused)
  local intervalAction = self.intervalAction
  intervalAction:pause(isPaused)
end

function DepthBubbleGenerator:startGenerating()
  local bubbleGenerator = function()
    while (true) do
     self.sendBubbleCallback()

     local intervalAction = AHDelay.new(self.bubbleInterval)
     self.intervalAction = intervalAction
     wait(intervalAction:start())

     self.bubbleInterval = self.bubbleInterval - DepthConstants.BUBBLE_INTERVAL_DECREMENT
     if (self.bubbleInterval < DepthConstants.MIN_BUBBLE_INTERVAL) then
       self.bubbleInterval = DepthConstants.MIN_BUBBLE_INTERVAL
     end

     self.incrementBubbleSpeedCallback()
    end
  end
  runInCoroutine(bubbleGenerator)
end

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function DepthBubbleGenerator.new(sendBubbleCallback, incrementBubbleSpeedCallback)
  local self = {}
  Mixin.mix(self, DepthBubbleGenerator)

  self.sendBubbleCallback = sendBubbleCallback
  self.incrementBubbleSpeedCallback = incrementBubbleSpeedCallback

  self.bubbleInterval = DepthConstants.INITIAL_BUBBLE_INTERVAL

  return self
end
