--- DepthContentDifficultyChooser
-- @author Created by alexey chernikov on October 06, 2014.

class("DepthContentDifficultyChooser")

require("data.KeyFrameInterpolator")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local function getFirstRoundDifficulty(self)
  local difficulty = GameSession.getDifficulty()
  if(difficulty < 0.3) then
    return "Basic"
  elseif(difficulty < 0.7) then
    return "Easy"
  else
    return "Medium"
  end
end

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function DepthContentDifficultyChooser:nextValue()
 if self.isFirstRound then
    self.isFirstRound = false
    return getFirstRoundDifficulty(self)
  else
    return self.super.nextValue(self)
  end
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function DepthContentDifficultyChooser.new()
  local difficultyKeyFrames = DepthConfiguration.getDifficultyKeyFrames()
  local self = KeyFrameInterpolator.new(difficultyKeyFrames, GameSession.getDifficulty())
  Mixin.mix(self, DepthContentDifficultyChooser)

  self.isFirstRound = true

  return self
end
