--- DepthDot
-- @author Created by Aaron Barrett on January 27, 2014.

class("DepthDot")
-- ---------------------------------------------------------------------------
-- Configuration
-- ---------------------------------------------------------------------------

DepthDot.RADIUS = 15.0
local DIAMETER = DepthDot.RADIUS * 2.0
local WIDTH = DIAMETER
local HEIGHT = DIAMETER

local CIRCLE_STEPS = 24


local RED_COLOR = ColorUtils.colorRGBToStd(255, 0, 51)

local Z_RED_CIRCLE = 10

-- ---------------------------------------------------------------------------
-- Utility
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- API
-- ---------------------------------------------------------------------------

function DepthDot:getBody()
  return self.body
end

function DepthDot:setBody(body)
  self.body = body
end

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function DepthDot.new()
  local self = Group.new(WIDTH, HEIGHT)
  Mixin.mix(self, DepthDot)

  local redCircle = FilledCircle.new(DepthDot.RADIUS, RED_COLOR, CIRCLE_STEPS)
  redCircle:setLoc(DepthDot.RADIUS, DepthDot.RADIUS)
  self:insert(redCircle, Z_RED_CIRCLE)

  self.body = nil

  return self
end
