class("DepthInsidesIncorrectView")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local darken = 0.6
local INCORRECT_COLOR = {0.99 * darken, 0.18 * darken, 0.22 * darken}

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function DepthInsidesIncorrectView:die()
  local seconds = 0.8
  local dy = 40
  local fade = AHOpacityTo.new(self, seconds, nil, 0)
  local move = AHLocationBy.new(self, seconds, nil, 0, dy)
  local scale = AHScaleTo.new(self, seconds, nil, 1.5, 1.5)
  local die = AHSequence.new(AHSpawn.new(fade, move, scale), function() self:removeSelf() end)
  die:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function DepthInsidesIncorrectView.new(concept)
  local percent = MathUtils.round(100 * concept.fraction/concept.total)
  local percentText = percent .. "%"
  local self = Label.new(percentText, Font.new(FontFaces.DIN_OT_MEDIUM, 18))
  Mixin.mix(self, DepthInsidesIncorrectView)
  self:setColor(unpack(INCORRECT_COLOR))
  return self
end
