--- DepthLevelLedge
-- @author Created by Aaron Barrett on January 27, 2014.

class("DepthLevelLedge")
-- ---------------------------------------------------------------------------
-- Configuration
-- ---------------------------------------------------------------------------

local Z_LEDGE = 10

local LEDGE_KIND_COUNT = 2

-- ---------------------------------------------------------------------------
-- Utility
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- API
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function DepthLevelLedge.new(opacity)
  local self = Group.new(DepthLevel.WIDTH, DepthLevel.HEIGHT)
  Mixin.mix(self, DepthLevelLedge)

  local ledgeKind = math.random(LEDGE_KIND_COUNT)
  local ledgeFilename = "ledge_" .. ledgeKind .. ".png"

  local ledge = Sprite.newWithName(ledgeFilename)
  ledge:setOpacity(opacity)
  local ledgeWidth, ledgeHeight = ledge:getDims()

  local isOnLeft = MathUtils.getRandomBoolean()
  if (isOnLeft) then
    ledge:setLoc(ledgeWidth * 0.5, ledgeHeight * 0.5)
  else
    ledge:setLoc(DepthLevel.WIDTH - ledgeWidth * 0.5, ledgeHeight * 0.5)
    ledge:setScl(-1.0, 1.0)
  end

  self:insert(ledge, Z_LEDGE)

  return self
end
