--- DepthLevelWhale
-- @author Created by Aaron Barrett on January 27, 2014.

class("DepthLevelWhale")
-- ---------------------------------------------------------------------------
-- Configuration
-- ---------------------------------------------------------------------------

local Z_WHALE = 10

local MOVEMENT_DURATION = 20.94

local MIN_WHALE_SCALE = 0.5

-- ---------------------------------------------------------------------------
-- Utility
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- API
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function DepthLevelWhale.new(opacity)
  local self = Group.new(DepthLevel.WIDTH, DepthLevel.HEIGHT)
  Mixin.mix(self, DepthLevelWhale)

  local whale = Sprite.newWithName("whale.png")

  local whaleScale = math.random() * (1.0 - MIN_WHALE_SCALE) + MIN_WHALE_SCALE

  whale:setOpacity(opacity)

  local whaleWidth, whaleHeight = whale:getDims()

  local y = whaleHeight * 0.5 + math.random() * (DepthLevel.HEIGHT - whaleHeight)
  local x = math.random() * DepthLevel.WIDTH * 0.25
  local movementAmount = DepthLevel.WIDTH + whaleWidth

  local isGoingLeft = MathUtils.getRandomBoolean()
  if (isGoingLeft) then
    x = x + DepthLevel.WIDTH * 0.75
    whale:setScl(-whaleScale, whaleScale)
    movementAmount = -movementAmount
  else
    whale:setScl(whaleScale)
  end

  whale:setLoc(x, y)
  self:insert(whale, Z_WHALE)

  local movementAction = AHLocationXBy.new(whale, MOVEMENT_DURATION, nil, movementAmount)
  movementAction:start()

  return self
end
