--- DepthRedAlert
-- @author Created by Aaron Barrett on January 30, 2014.

class("DepthRedAlert")
-- ---------------------------------------------------------------------------
-- Configuration
-- ---------------------------------------------------------------------------

local WIDTH = Screen.width
local HEIGHT = Screen.height

local RED_COLOR = {0.99, 0.18, 0.22}

-- ---------------------------------------------------------------------------
-- Utility
-- ---------------------------------------------------------------------------

-- ---------------------------------------------------------------------------
-- API
-- ---------------------------------------------------------------------------

function DepthRedAlert:flash()
  if (self.flashAction) then
    self.flashAction:stop()
  end

  local flashAction = AHSequence.new(
                                     AHOpacityTo.new(self, 0.0375, nil, 0.2),
                                     AHOpacityTo.new(self, 0.0375, nil, 0.05),
                                     AHOpacityTo.new(self, 0.0375, nil, 0.2),
                                     AHOpacityTo.new(self, 0.0375, nil, 0.05),
                                     AHOpacityTo.new(self, 0.1, AHEaseSimpleIn.new(1.0), 0.0)
                                     )
  self.flashAction = flashAction
  flashAction:start()
end

-- ---------------------------------------------------------------------------
-- Object Creation
-- ---------------------------------------------------------------------------

-- Constructor ------------------------

function DepthRedAlert.new()
  local self = FilledRectangle.new(WIDTH, HEIGHT, RED_COLOR)
  Mixin.mix(self, DepthRedAlert)

  self:setOpacity(0.0)

  self.flashAction = nil

  return self
end
