--- default
-- @author Created by amorant on July 28, 2014.
-- Test content validation entry point for Depth.

require("Bootstrap")
require("DepthValidator")
require("validators.SimpleParametersValidator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_PARAMETERS = {}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local validator = DepthValidator.new()
local parametersValidator = SimpleParametersValidator.new(REQUIRED_PARAMETERS)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function validate(concept)
  validator:validate(concept)
  return validator:getPassed(), validator:getMessage()
end

function validateParameters(parameters)
  parametersValidator:validate(MOAIJsonParser.decode(parameters))
  return parametersValidator:getPassed(), parametersValidator:getMessage()
end
