--- EggcornsCommon
-- @author Created by Jay Austria on August 14, 2015.

class("EggcornsCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

EggcornsCommon.COLORS = {
  WHITE = ColorUtils.colorHex24ToStd(0xFFFFFF),
  BLACK = ColorUtils.colorHex24ToStd(0x000000),
  AQUA = ColorUtils.colorHex24ToStd(0x50E3C2),
  OVEREXPOSED_AQUA = ColorUtils.colorHex24ToStd(0x90FEFE),
  RED = ColorUtils.colorHex24ToStd(0x810000),
  LIGHT_RED = ColorUtils.colorHex24ToStd(0xFF005E),
  INVISIBLE_WHITE = ColorUtils.colorHex32ToStd(0x00000000)
}

EggcornsCommon.GAME_UI_WIDTH = Screen.safeWidth - 50
EggcornsCommon.VISIBLE_OPACITY = 1.0
EggcornsCommon.INVISIBLE_OPACITY = 0.0
EggcornsCommon.EGGCORNS_TEXT_VIEW_FONT = nil
EggcornsCommon.EGGCORNS_TEXT_VIEW_FONT_ITALIC = nil
EggcornsCommon.FALL_DURATION = 0.6
EggcornsCommon.UI_FADE_OPACITY = 0.02
EggcornsCommon.UI_FADE_DURATION = 0.3
EggcornsCommon.BACKING_PADDING_X = 8
EggcornsCommon.SHAKE_MAGNITUDE = 10
EggcornsCommon.FONT_SIZE = 32

local VALID_CHARACTER_SET = TextCommon.getDefaultCharacters() .. 'àèìòùâêîôûÀÈÌÒÙÂÊÎÔÛ'

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function EggcornsCommon.initialize()
  EggcornsCommon.EGGCORNS_TEXT_VIEW_FONT = PrerenderedFont.new(FontFaces.DIN_OT_LIGHT, EggcornsCommon.FONT_SIZE, VALID_CHARACTER_SET)
  EggcornsCommon.EGGCORNS_TEXT_VIEW_FONT_ITALIC = PrerenderedFont.new(FontFaces.DIN_OT_LIGHT_ITALIC, EggcornsCommon.FONT_SIZE, VALID_CHARACTER_SET)
end
