--- EggcornsScreenShake
-- @author Created by Jay Austria on September 3, 2015.

class("EggcornsScreenShake")

require("EggcornsCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createScreenShakeAction(progress, returnDuration)
  local minX = -EggcornsCommon.SHAKE_MAGNITUDE
  local maxX = EggcornsCommon.SHAKE_MAGNITUDE
  local rootGroup = Screen.rootGroup
  local x, y = rootGroup:getLoc()

  local shakeOffsetX = MathUtils.interpolateLinearFromNormalized(progress, minX, maxX)
  local shakeOffsetY = -EggcornsCommon.SHAKE_MAGNITUDE

  local screenShakeAction = AHSequence.new(
    function() rootGroup:setLoc(x + shakeOffsetX, y + shakeOffsetY) end,
    AHLocationTo.new(rootGroup, returnDuration, AHEaseElasticOut.new(), x, y)
  )

  return screenShakeAction
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function EggcornsScreenShake.createOutroScreenShake()
  local progress = 0.0 -- Determines the shake angle. Doesn't matter for outro, but 0.0 looks nice.
  local returnDuration = 2.0
  local screenShakeAction = createScreenShakeAction(progress, returnDuration)

  return screenShakeAction
end

function EggcornsScreenShake.playScreenShake(progress)
  local returnDuration = 1.0
  local screenShakeAction = createScreenShakeAction(progress, returnDuration)

  screenShakeAction:start()
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
