--- EggcornsTextAnimationBuilder
-- @author Created by Jay Austria on September 2, 2015.
--
-- Contains overrides for the default animation builder behavior for purposes
-- of fine tuning the durations and effects used when replacing text

class("EggcornsTextAnimationBuilder")

require("text.dynamic.TextAnimationBuilder")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local ANIMATION_DURATION = 0.3

local MOVE_DURATION = ANIMATION_DURATION
local SHOW_DURATION = 0.1
local HIDE_DURATION = 0.01
local HEIGHT_DURATION = ANIMATION_DURATION

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function setDurations(self)
  self:setMoveDuration(MOVE_DURATION)
  self:setShowDuration(SHOW_DURATION)
  self:setHideDuration(HIDE_DURATION)
  self:setAdjustHeightDuration(HEIGHT_DURATION)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function EggcornsTextAnimationBuilder.new()
  local self = TextAnimationBuilder.new()
  Mixin.mix(self, EggcornsTextAnimationBuilder)
  setDurations(self)

  return self
end
