--- EggcornsValidator
-- @author Created by Jay Austria on August 14, 2015.
-- ConceptValidator for Eggcorns.

class("EggcornsValidator")

require("validators.ConceptValidator")
require("validators.TagValidator")
require("text.TextCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_KEYS = {
  "prompt",
  "correctReplace",
  "incorrectReplace",
  "rationale",
  "reportKey"
}

local PROMPT_REQUIRED_SINGLE_TAGS = {
  "blank"
}

local PROMPT_OPTIONAL_PAIRED_TAGS = {
  "i"
}

local RATIONALE_OPTIONAL_PAIRED_TAGS = {
  "strong"
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function EggcornsValidator:validateConcept(concept)
  self:validateRequiredKeys(concept, REQUIRED_KEYS)

  self:validateTags(concept.prompt, PROMPT_REQUIRED_SINGLE_TAGS, nil, nil, PROMPT_OPTIONAL_PAIRED_TAGS)
  self:validateTags(concept.rationale, nil, nil, nil, RATIONALE_OPTIONAL_PAIRED_TAGS)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function EggcornsValidator.new()
  local self = ConceptValidator.new()
  TagValidator.make(self)
  Mixin.mix(self, EggcornsValidator)

  return self
end
