--- ExerciseCardConstructors
-- @author Created by Aaron Barrett on May 05, 2015.

class("ExerciseCardConstructors")


require("cards.ExerciseCardDone")
require("cards.ExerciseCardExampleAndText")
require("cards.ExerciseCardEyeMovement")
require("cards.ExerciseCardFlashCard")
require("cards.ExerciseCardImageAndCaption")
require("cards.ExerciseCardImageAndText")
require("cards.ExerciseCardImageExplanation")
require("cards.ExerciseCardInstructionAndDetail")
require("cards.ExerciseCardIntroText")
require("cards.ExerciseCardMultipleChoice")
require("cards.ExerciseCardPassage")
require("cards.ExerciseCardPassageTitle")
require("cards.ExerciseCardQuote")
require("cards.ExerciseCardSentenceGrouping")
require("cards.ExerciseCardSpeechAnalysis")
require("cards.ExerciseCardSpeechIntro")
require("cards.ExerciseCardSpeedReadingTestComplete")
require("cards.ExerciseCardText")
require("cards.ExerciseCardTextAndInstructions")
require("cards.ExerciseCardTipExplanation")
require("cards.ExerciseCardTitle")
require("cards.ExerciseCardTitleSubtitle")
require("cards.ExerciseCardWordHighlight")
require("cards.ExerciseCardWordPartExample")
require("cards.ExerciseCardWordPartExplanation")
require("containers.card_carousel.CardCarouselCardExit")
require("ExerciseCardDefinitions")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

ExerciseCardConstructors.CONSTRUCTORS_BY_CARD_TYPE = {
  [ExerciseCardDefinitions.CARD_TYPES.DONE] = ExerciseCardDone.new,
  [ExerciseCardDefinitions.CARD_TYPES.EXAMPLE_AND_TEXT] = ExerciseCardExampleAndText.new,
  [ExerciseCardDefinitions.CARD_TYPES.EXIT] = CardCarouselCardExit.new,
  [ExerciseCardDefinitions.CARD_TYPES.EYE_MOVEMENT] = ExerciseCardEyeMovement.new,
  [ExerciseCardDefinitions.CARD_TYPES.FLASH_CARD] = ExerciseCardFlashCard.new,
  [ExerciseCardDefinitions.CARD_TYPES.IMAGE_AND_CAPTION] = ExerciseCardImageAndCaption.new,
  [ExerciseCardDefinitions.CARD_TYPES.IMAGE_AND_TEXT] = ExerciseCardImageAndText.new,
  [ExerciseCardDefinitions.CARD_TYPES.IMAGE_EXPLANATION] = ExerciseCardImageExplanation.new,
  [ExerciseCardDefinitions.CARD_TYPES.INSTRUCTION_AND_DETAIL] = ExerciseCardInstructionAndDetail.new,
  [ExerciseCardDefinitions.CARD_TYPES.INTRO_TEXT] = ExerciseCardIntroText.new,
  [ExerciseCardDefinitions.CARD_TYPES.MULTIPLE_CHOICE] = ExerciseCardMultipleChoice.new,
  [ExerciseCardDefinitions.CARD_TYPES.PASSAGE] = ExerciseCardPassage.new,
  [ExerciseCardDefinitions.CARD_TYPES.PASSAGE_TITLE] = ExerciseCardPassageTitle.new,
  [ExerciseCardDefinitions.CARD_TYPES.PULL_TO_EXIT] = CardCarouselCardExit.newPullToExit,
  [ExerciseCardDefinitions.CARD_TYPES.QUOTE] = ExerciseCardQuote.new,
  [ExerciseCardDefinitions.CARD_TYPES.SPEECH_ANALYSIS] = ExerciseCardSpeechAnalysis.new,
  [ExerciseCardDefinitions.CARD_TYPES.SPEECH_INTRO] = ExerciseCardSpeechIntro.new,
  [ExerciseCardDefinitions.CARD_TYPES.SPEED_READING_SENTENCE_GROUPING] = ExerciseCardSentenceGrouping.new,
  [ExerciseCardDefinitions.CARD_TYPES.SPEED_READING_TEST_COMPLETE] = ExerciseCardSpeedReadingTestComplete.new,
  [ExerciseCardDefinitions.CARD_TYPES.TEXT] = ExerciseCardText.new,
  [ExerciseCardDefinitions.CARD_TYPES.TEXT_AND_INSTRUCTIONS] = ExerciseCardTextAndInstructions.new,
  [ExerciseCardDefinitions.CARD_TYPES.TIP_EXPLANATION] = ExerciseCardTipExplanation.new,
  [ExerciseCardDefinitions.CARD_TYPES.TITLE] = ExerciseCardTitle.new,
  [ExerciseCardDefinitions.CARD_TYPES.TITLE_SUBTITLE] = ExerciseCardTitleSubtitle.new,
  [ExerciseCardDefinitions.CARD_TYPES.WORD_HIGHLIGHT] = ExerciseCardWordHighlight.new,
  [ExerciseCardDefinitions.CARD_TYPES.WORD_PART_EXAMPLE] = ExerciseCardWordPartExample.new,
  [ExerciseCardDefinitions.CARD_TYPES.WORD_PART_EXPLANATION] = ExerciseCardWordPartExplanation.new,
}
