--- ExerciseCheckbox
-- @author Created by karl on May 21, 2015.

class("ExerciseCheckbox")

require("containers.card_carousel.CardCarouselCardCommon")
require("graphics.primitives.Checkmark")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ExerciseCheckbox:setChecked(isChecked)
  self._isChecked = isChecked
  self.checkmark:setVisible(isChecked)
end

function ExerciseCheckbox:isChecked()
  return self._isChecked
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ExerciseCheckbox.new(size, color, checkCallback)
  local cornerRadius = size * 0.2
  local lineWidth = 2

  local self = HollowRoundedRectangle.new(size, size, cornerRadius, color, lineWidth)
  Mixin.mix(self, ExerciseCheckbox)

  self.checkmark = FilledCheckmark.new(size * 0.6, 0.42, 0.3, color)
  self:insertAtCenter(self.checkmark)

  local virtualSize = size + 40

  local virtualButton = Button.addVirtualButton(self, virtualSize, virtualSize, function()
    self:setChecked(not self:isChecked())
    if checkCallback then
      checkCallback(self:isChecked())
    end
  end)

  FunctionUtils.forwardMethodCalls(self, virtualButton, "setTouchEnabled")
  self:setChecked(false)

  return self
end
