--- ExerciseNavigator
-- @author Created by Jay Austria on April 30, 2022.

class("ExerciseNavigator")

require("containers.card_carousel.CardCarouselCardCommon")
require("containers.card_carousel.CardCarouselNavigator")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local HOME_ROW = 2
local TUTORIAL_ROW = HOME_ROW
local TUTORIAL_COLUMN = 2

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function addTutorialCallback(self)
  local card = self.cardColumns[TUTORIAL_COLUMN][TUTORIAL_ROW]
  card:addTutorialOverlay()
end

local function addDoneCallback(self)
  local function doneFunction()
    self.visitedDoneCard = true
  end

  self:overloadOnEnterForCardsOfType(ExerciseCardDefinitions.CARD_TYPES.DONE, doneFunction)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ExerciseNavigator:hasVisitedDoneCard()
  return self.visitedDoneCard
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constuctor -------------------------

function ExerciseNavigator.new(cardColumns, completionCallback, clearColor)
  local self = CardCarouselNavigator.new(cardColumns, completionCallback, clearColor)
  Mixin.mix(self, ExerciseNavigator)

  self.visitedDoneCard = false
  addDoneCallback(self)

  if (GameSession.hasNeverWon()) then
    addTutorialCallback(self)
  end

  return self
end
