--- ExerciseSession
-- @author Created by amorant on May 21, 2015.

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

--- Tells the app whether the user accepted to receive a reminder to review the exercise in the
-- a given number of days.
-- @param didUserAcceptToReviewExercise (boolean) - true if the user accepted, false otherwise.
function ExerciseSession.setUserAcceptedToReviewExercise(didUserAcceptToReviewExercise)
  ExerciseSession.userAcceptedToReviewExercise = didUserAcceptToReviewExercise
end

--- Gets whether notifications are enabled in the app.
-- @return (boolean) - true if the user has accepted to enable notifications.
function ExerciseSession.areNotificationsEnabled()
  return ExerciseSession.notificationsAreEnabled
end

--- Gets the number of days until the next review for the current exercise.
-- This is to prompt the user if they would like a notification in those many days.
-- @return (number) - days until next exercise review.
function ExerciseSession.getDaysUntilNextExerciseReview()
  return ExerciseSession.daysUntilNextExerciseReview
end
