--- ExerciseSlideOrchestrator
-- @author Created by karl on May 11, 2015.

class("ExerciseSlideOrchestrator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local slideDistance = CardCarouselCardCommon.CACHED_FONTS.MEDIUM_MEDIUM:getActualSize() * 2
local slideDuration = 0.8

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ExerciseSlideOrchestrator:addProps(...)
  for _, prop in ipairs({...}) do
    local x, y = prop:getLoc()
    table.insert(self.propDescriptors, {
      originX = x,
      originY = y,
      prop = prop,
      destinationOpacity = prop:getOpacity()
    })
  end
end

function ExerciseSlideOrchestrator:reset()
  for _, descriptor in ipairs(self.propDescriptors) do
    local prop = descriptor.prop
    prop:setLoc(descriptor.originX, descriptor.originY + slideDistance)
    prop:setOpacity(0)
  end
end

function ExerciseSlideOrchestrator:newAnimateAction()
  local action = AHSpawn.new()
  for _, descriptor in ipairs(self.propDescriptors) do
    local prop = descriptor.prop
    local destinationOpacity = descriptor.destinationOpacity
    action:addAction(AHOpacityTo.new(prop, slideDuration, nil, destinationOpacity))
    action:addAction(AHLocationYTo.new(prop, slideDuration, AHEaseExponentialOut.new(), descriptor.originY))
  end

  return action
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ExerciseSlideOrchestrator.new()
  local self = {}
  Mixin.mix(self, ExerciseSlideOrchestrator)

  self.propDescriptors = {}

  return self
end
