--- ExerciseCard
-- @author Created by Aaron Barrett on April 21, 2015.

class("ExerciseCard")

require("containers.card_carousel.CardCarouselCard")
require("containers.card_carousel.CardCarouselCardCommon")
require("ExerciseIcon")
require("ExerciseSession")
require("ExerciseTutorial")


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ExerciseCard:addTutorialOverlay()
  local seenTutorial = false
  local tutorial = nil

  self:overloadOnEnter(function(self)
    if not seenTutorial then
      tutorial = ExerciseTutorial.newIntro()
      self:insertAtCenter(tutorial, math.huge)
      tutorial:animateIn()
      seenTutorial = true
    end
  end)

  self:overloadOnLeaveBegin(function(self)
    if tutorial then
      tutorial:removeSelf()
      tutorial = nil
    end
  end)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constuctor -------------------------

function ExerciseCard.new(cardType, cardGlobals)
  local self = CardCarouselCard.new(cardType, cardGlobals)
  Mixin.mix(self, ExerciseCard)

  return self
end
