--- Expelliarmus Checkmark
-- @author Created by karl on September 08, 2014.

class("ExpelliarmusCheckmark")

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ExpelliarmusCheckmark.newExternalPieces(width, shortProp, thickProp, extendedWidth, extendedHeight)
  local points = ShapeUtils.makeCheckmarkPoints(width, shortProp, thickProp)
  local checkW, checkH = ShapeUtils.getMaxEdges(points)
  local xOffset = (extendedWidth - checkW) / 2
  local yOffset = (extendedHeight - checkH) / 2

  local rightPiece = FilledPolygon.newAutomatic({{x=extendedWidth/2, y=0}, {x=extendedWidth/2, y=extendedWidth}, {x=0, y=extendedWidth/2}})
  rightPiece:setAnchorPointLeft()
  rightPiece:setLoc(xOffset + points[3]["x"], yOffset + points[3]["y"])

  local topPiece = FilledPolygon.newAutomatic({{x=extendedHeight*0.75, y=0}, {x=extendedHeight*1.5, y=extendedHeight*0.75}, {x=0, y=extendedHeight*0.75}})
  topPiece:setAnchorPointBottom()
  topPiece:setLoc(xOffset + points[4]["x"], yOffset + points[4]["y"])

  local leftPiece = FilledPolygon.newAutomatic({{x=extendedWidth/2, y=extendedWidth/2}, {x=0, y=extendedWidth}, {x=0, y=0}})
  leftPiece:setAnchorPointRight()
  leftPiece:setLoc(xOffset + points[5]["x"], yOffset + points[5]["y"])

  local bottomPiece = FilledPolygon.newAutomatic({{x=0, y=0}, {x=extendedHeight, y=0}, {x=extendedHeight/2, y=extendedHeight/2}})
  bottomPiece:setAnchorPointTop()
  bottomPiece:setLoc(xOffset + points[6]["x"], yOffset + points[6]["y"])

  local fillOffset = width * (1-shortProp)
  local fillPiece = FilledPolygon.newAutomatic({{x=0, y=extendedHeight/2}, {x=extendedHeight/2, y=0}, {x=extendedHeight/2 + fillOffset, y=fillOffset}, {x=fillOffset, y=extendedHeight/2 + fillOffset}})
  local fillHeight = fillPiece:getHeight()
  fillPiece:setAnchorPoint(0, 1 - fillOffset / fillHeight)
  fillPiece:setLoc(xOffset + points[1]["x"], yOffset + points[1]["y"])


  return {fillPiece, rightPiece, topPiece, leftPiece, bottomPiece}
end
