--- ExpelliarmusCommon
-- @author Created by karl on September 02, 2014.

class("ExpelliarmusCommon")
require("text.ComposedGlyphLabel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

ExpelliarmusCommon.TOPIC_COLORS = {
  {0.3, 0.83, 0.8, 1.0},
  {0.21, 0.81, 0.95, 1.0},
  {0.87, 0.3, 0.93, 1.0}
}

ExpelliarmusCommon.COLOR_BACKGROUND = ColorUtils.colorHex24ToStd(0xededed)
ExpelliarmusCommon.COLOR_TEXT = {0, 0, 0, 0.5}
ExpelliarmusCommon.COLOR_TIMER = {1, 1, 1}
ExpelliarmusCommon.COLOR_UI = ExpelliarmusCommon.COLOR_TEXT

ExpelliarmusCommon.CHECKMARK_SHORT_LENGTH = 0.39
ExpelliarmusCommon.CHECKMARK_THICKNESS = 0.22

ExpelliarmusCommon.CARD_BUMP_AMOUNT = 4

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

--- Create a new composed label, properly kerned based on the "prefix" text (if any).
function ExpelliarmusCommon.newKernedLabel(prefix, text, font)
  local startIndex = 1
  if prefix and #prefix > 0 then
    text = string.sub(prefix, -1) .. text
    startIndex = 2
  end

  local default = nil
  local buildGlyphs = true
  local label = Label.new(text, font, default, default, buildGlyphs)
  local composedLabel = ComposedGlyphLabel.new(label, label:getGlyphTable())
  return composedLabel:sublabel(startIndex, #text)
end
