--- ExpendituresBanner
-- @author Created by Jay Austria on November 11, 2014.

class("ExpendituresBanner")
-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local UNROLL_FRAME_RATE = 48

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ExpendituresBanner:newUnrollAnimation()
  local unrollAnimation = Animation.newWithPrefix("banner_")

  local animateAction = AHAnimate.new(self, unrollAnimation, UNROLL_FRAME_RATE)
  return animateAction
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function ExpendituresBanner.new()
  local banner = Sprite.newWithName("banner_000.png")
  Mixin.mix(banner, ExpendituresBanner)

  local incorrectBanner = Sprite.newWithName("orange_banner.png")
  incorrectBanner:setOpacity(0)
  banner:insertAtCenter(incorrectBanner)
  banner.incorrectBanner = incorrectBanner

  return banner
end
