class("ExpendituresRockShake")
-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function ExpendituresRockShake.new(group, maxAmplitude, totalDuration, cyclesUntilEnd)
  local rotationSequence = AHSequence.new()

  local durationPerCycle = totalDuration / cyclesUntilEnd
  local amplitudeReductionPerCycle = maxAmplitude / cyclesUntilEnd

  local amplitude = maxAmplitude

  for i = 1, cyclesUntilEnd do
    rotationSequence:addAction(AHRotationTo.new(group, durationPerCycle * 0.5, AHEaseSimpleInOut.new(), amplitude))
    rotationSequence:addAction(AHRotationTo.new(group, durationPerCycle * 0.5, AHEaseSimpleInOut.new(), -amplitude))

    amplitude = amplitude - amplitudeReductionPerCycle
  end

  rotationSequence:addAction(AHRotationTo.new(group, durationPerCycle, AHEaseSimpleInOut.new(), 0))

  return rotationSequence
end
