--- FoodConceptGenerator
-- @author Created by Jay on January 08, 2015.

class("FoodConceptGenerator")

require("data.generators.UtilityGenerators")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FoodConceptGenerator:setRandomRound()
  local randomRoundName = self.roundNameChooser:nextValue()
  self.conceptGenerator:setFilters({round = randomRoundName})

  self.currentRoundName = randomRoundName
end

function FoodConceptGenerator:reset()
  self.conceptGenerator:reset()
end

function FoodConceptGenerator:generateNextValue()
  assert(self.currentRoundName, "Round name must be set before concepts can be generated")
  return self.conceptGenerator:generateNextValue()
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FoodConceptGenerator.new(roundKeyFrames, difficultyKeyFrames)
  local self = Generator.new()
  Mixin.mix(self, FoodConceptGenerator)

  local conceptGenerator = GameSession.conceptGenerator
  local roundNameChooser = KeyFrameInterpolator.new(roundKeyFrames, GameSession.getDifficulty())
  local difficultyNameChooser = KeyFrameInterpolator.new(difficultyKeyFrames, GameSession.getDifficulty())

  conceptGenerator:setDifficultyNameChooser(difficultyNameChooser)

  self.conceptGenerator = conceptGenerator
  self.roundNameChooser = roundNameChooser
  self.currentRoundName = nil

  return self
end
