--- FoodRoundColors
-- @author Created by Aaron Barrett on January 05, 2015.

class("FoodRoundColors")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLORS_BY_ROUND_INDEX = {
  {0.71, 0.25, 1.00}, -- Purple
  {1.00, 0.88, 0.37}, -- Yellow
  {0.14, 0.99, 0.91}, -- Cyan
  {1.00, 0.88, 0.37}, -- Yellow
  {0.94, 0.20, 0.58}, -- Pink
  {0.71, 0.25, 1.00}  -- Purple
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FoodRoundColors.getColorForRoundIndex(roundIndex)
  local color = COLORS_BY_ROUND_INDEX[roundIndex]
  assert(color ~= nil, "No round color specified for round index: `" .. tostring(roundIndex) .. "`")
  return color
end

function FoodRoundColors.getGlowColorForRoundIndex(roundIndex)
  local roundColor = FoodRoundColors.getColorForRoundIndex(roundIndex)

  local amountToLighten = -0.11
  local glowColor = ColorUtils.lightenColor(roundColor, amountToLighten)

  return glowColor
end
