--- FoodStrobeAction
-- @author Created by Aaron Barrett on January 08, 2015.

class("FoodStrobeAction")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WHITE = {1.00, 1.00, 1.00}
local TIMES_TO_LOOP = 2
local COLOR_DURATION = 0.333
local EASE_TO_WHITE = AHEaseBezier.newFlat({0.5, 0.0, 0.3, 1.0})
local EASE_TO_STARTING_COLOR = AHEaseBezier.newFlat({0.7, 0.0, 0.5, 1.0})


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FoodStrobeAction.new(target)
  local startingColor = {target:getColor()}
  local self = AHLoop.new(
                          AHSequence.new(
                                         AHColorTo.new(target, COLOR_DURATION, EASE_TO_WHITE, WHITE),
                                         AHColorTo.new(target, COLOR_DURATION, EASE_TO_STARTING_COLOR, startingColor)
                                         ),
                          TIMES_TO_LOOP
                          )
  Mixin.mix(self, FoodStrobeAction)

  return self
end
