--- FoodTipsData
-- @author Created by Jay Austria on January 12, 2015

class("FoodTipsData")

local TIP_DOUBLE =
{
  subjectText = "DOUBLING",
  example = "1 2/3",
  steps =
  {
    {
      headerText = "Express the number as an improper fraction",
      illustrations =
      {
        {
          formula = "1 2/3",
          displayedFractions = "1 2/3"
        },
        {
          formula = "5/3",
          displayedFractions = "3/3 2/3"
        }
      }
    },
    {
      headerText = "Multiply the numerator by 2",
      illustrations =
      {
        {
          formula = "5/3 × 2/1",
          displayedFractions = "3/3 2/3"
        },
        {
          formula = "10/3",
          displayedFractions = "3/3 3/3 3/3 1/3"
        }
      }
    },
    {
      headerText = "Convert your answer to a mixed number",
      illustrations =
      {
        {
          formula = "10/3",
          displayedFractions = "3/3 3/3 3/3 1/3"
        },
        {
          formula = "3 1/3",
          displayedFractions = "1 1 1 1/3"
        }
      }
    }
  }
}

local TIP_TRIPLE =
{
  subjectText = "TRIPLING",
  example = "1 3/4",
  steps =
  {
    {
      headerText = "Express the number as an improper fraction",
      illustrations =
      {
        {
          formula = "1 3/4",
          displayedFractions = "1 3/4"
        },
        {
          formula = "7/4",
          displayedFractions = "4/4 3/4"
        }
      }
    },
    {
      headerText = "Multiply the numerator by 3",
      illustrations =
      {
        {
          formula = "7/4 × 3/1",
          displayedFractions = "4/4 3/4"
        },
        {
          formula = "21/4",
          displayedFractions = "4/4 4/4 4/4 4/4 4/4 1/4"
        }
      }
    },
    {
      headerText = "Convert your answer to a mixed number",
      illustrations =
      {
        {
          formula = "21/4",
          displayedFractions = "4/4 4/4 4/4 4/4 4/4 1/4"
        },
        {
          formula = "5 1/4",
          displayedFractions = "1 1 1 1 1 1/4"
        }
      }
    }
  }
}

local TIP_HALF =
{
  subjectText = "FINDING ONE-HALF",
  example = "2 1/2",
  steps =
  {
    {
      headerText = "Express the number as an improper fraction",
      illustrations =
      {
        {
          formula = "2 1/2",
          displayedFractions = "1 1 1/2"
        },
        {
          formula = "5/2",
          displayedFractions = "2/2 2/2 1/2"
        }
      }
    },
    {
      headerText = "Multiply the fraction by 1/2",
      illustrations =
      {
        {
          formula = "5/2 × 1/2",
          displayedFractions = "2/2 2/2 1/2"
        },
        {
          formula = "5/4",
          displayedFractions = "4/4 1/4"
        }
      }
    },
    {
      headerText = "Convert your answer to a mixed number",
      illustrations =
      {
        {
          formula = "5/4",
          displayedFractions = "4/4 1/4"
        },
        {
          formula = "1 1/4",
          displayedFractions = "1 1/4"
        }
      }
    }
  }
}

local TIP_THIRD =
{
  subjectText = "FINDING ONE-THIRD",
  example = "2 1/4",
  steps =
  {
    {
      headerText = "Express the number as an improper fraction",
      illustrations =
      {
        {
          formula = "2 1/4",
          displayedFractions = "1 1 1/4"
        },
        {
          formula = "9/4",
          displayedFractions = "4/4 4/4 1/4"
        }
      }
    },
    {
      headerText = "Multiply the fraction by 1/3",
      illustrations =
      {
        {
          formula = "9/4 × 1/3",
          displayedFractions = "4/4 4/4 1/4"
        },
        {
          formula = "9/12",
          displayedFractions = "9/12"
        }
      }
    },
    {
      headerText = "Reduce your answer",
      illustrations =
      {
        {
          formula = "9/12",
          displayedFractions = "9/12"
        },
        {
          formula = "3/4",
          displayedFractions = "3/4"
        }
      }
    }
  }
}

local TIP_QUARTER =
{
  subjectText = "FINDING ONE-FOURTH",
  example = "2 2/3",
  steps =
  {
    {
      headerText = "Express the number as an improper fraction",
      illustrations =
      {
        {
          formula = "2 2/3",
          displayedFractions = "1 1 2/3"
        },
        {
          formula = "8/3",
          displayedFractions = "3/3 3/3 2/3"
        }
      }
    },
    {
      headerText = "Multiply the fraction by 1/4",
      illustrations =
      {
        {
          formula = "8/3 × 1/4",
          displayedFractions = "3/3 3/3 2/3"
        },
        {
          formula = "8/12",
          displayedFractions = "8/12"
        }
      }
    },
    {
      headerText = "Reduce your answer",
      illustrations =
      {
        {
          formula = "8/12",
          displayedFractions = "8/12"
        },
        {
          formula = "2/3",
          displayedFractions = "2/3"
        }
      }
    }
  }
}

local TIP_THIRD_EASY =
{
  subjectText = "FINDING ONE-THIRD",
  subtitleText = "WHEN DIVIDING A WHOLE NUMBER",
  example = "6",
  steps =
  {
    {
      headerText = "Divide the whole number by 3",
      illustrations =
      {
        {
          formula = "6 ÷ 3",
          displayedFractions = "1 1 1 1 1 1"
        },
        {
          formula = "2",
          displayedFractions = "1 1"
        }
      }
    }
  }
}

local TIP_QUARTER_EASY =
{
  subjectText = "FINDING ONE-FOURTH",
  subtitleText = "WHEN DIVIDING A WHOLE NUMBER",
  example = "4",
  steps =
  {
    {
      headerText = "Divide the whole number by 4",
      illustrations =
      {
        {
          formula = "4 ÷ 4",
          displayedFractions = "1 1 1 1"
        },
        {
          formula = "1",
          displayedFractions = "1"
        }
      }
    }
  }
}

local TIP_DOUBLE_EASY =
{
  subjectText = "DOUBLING",
  subtitleText = "WHEN MULTIPLYING A WHOLE NUMBER",
  example = "2",
  steps =
  {
    {
      headerText = "Multiply by 2",
      illustrations =
      {
        {
          formula = "2 × 2",
          displayedFractions = "1 1"
        },
        {
          formula = "4",
          displayedFractions = "1 1 1 1"
        }
      }
    }
  }
}

local TIP_TRIPLE_EASY =
{
  subjectText = "TRIPLING",
  subtitleText = "WHEN MULTIPLYING A WHOLE NUMBER",
  example = "2",
  steps =
  {
    {
      headerText = "Multiply by 3",
      illustrations =
      {
        {
          formula = "2 × 3",
          displayedFractions = "1 1"
        },
        {
          formula = "6",
          displayedFractions = "1 1 1 1 1 1"
        }
      }
    }
  }
}

local TIP_THIRD_SPECIAL =
{
  subjectText = "FINDING ONE-THIRD",
  subtitleText = "BOTH PARTS EVENLY DIVISIBLE BY 3",
  example = "3 3/4",
  steps =
  {
    {
      headerText = "Divide the whole number by 3",
      illustrations =
      {
        {
          formula = "3 ÷ 3",
          displayedFractions = "1 1 1"
        },
        {
          formula = "1",
          displayedFractions = "1"
        }
      }
    },
    {
      headerText = "Divide the fraction by 3",
      illustrations =
      {
        {
          formula = "3/4 ÷ 3",
          displayedFractions = "3/4"
        },
        {
          formula = "1/4",
          displayedFractions = "1/4"
        }
      }
    },
    {
      headerText = "Combine the whole number and fraction",
      illustrations =
      {
        {
          formula = "1 1/4",
          displayedFractions = "1 1/4"
        }
      }
    }
  }
}

local TIP_HALF_SPECIAL =
{
  subjectText = "FINDING ONE-HALF",
  subtitleText = "BOTH PARTS EVENLY DIVISIBLE BY 2",
  example = "4 2/3",
  steps =
  {
    {
      headerText = "Divide the whole number by 2",
      illustrations =
      {
        {
          formula = "4 ÷ 2",
          displayedFractions = "1 1 1 1"
        },
        {
          formula = "2",
          displayedFractions = "1 1"
        }
      }
    },
    {
      headerText = "Divide the fraction by 2",
      illustrations =
      {
        {
          formula = "2/3 ÷ 2",
          displayedFractions = "2/3"
        },
        {
          formula = "1/3",
          displayedFractions = "1/3"
        }
      }
    },
    {
      headerText = "Combine the whole number and fraction",
      illustrations =
      {
        {
          formula = "2 1/3",
          displayedFractions = "1 1 1/3"
        }
      }
    }
  }
}

local TIP_TRIPLE_SPECIAL =
{
  subjectText = "TRIPLING",
  example = "1 1/4",
  steps =
  {
    {
      headerText = "Multiply the whole number by 3",
      illustrations =
      {
        {
          formula = "1 × 3",
          displayedFractions = "1"
        },
        {
          formula = "3",
          displayedFractions = "1 1 1"
        }
      }
    },
    {
      headerText = "Multiply the fraction by 3",
      illustrations =
      {
        {
          formula = "1/4 × 3",
          displayedFractions = "1/4"
        },
        {
          formula = "3/4",
          displayedFractions = "3/4"
        }
      }
    },
    {
      headerText = "Combine the whole number and fraction",
      illustrations =
      {
        {
          formula = "3 3/4",
          displayedFractions = "1 1 1 3/4"
        }
      }
    }
  }
}

local TIP_DOUBLE_SPECIAL =
{
  subjectText = "DOUBLING",
  example = "1 1/3",
  steps =
  {
    {
      headerText = "Multiply the whole number by 2",
      illustrations =
      {
        {
          formula = "1 × 2",
          displayedFractions = "1"
        },
        {
          formula = "2",
          displayedFractions = "1 1"
        }
      }
    },
    {
      headerText = "Multiply the fraction by 2",
      illustrations =
      {
        {
          formula = "1/3 × 2",
          displayedFractions = "1/3"
        },
        {
          formula = "2/3",
          displayedFractions = "2/3"
        }
      }
    },
    {
      headerText = "Combine the whole number and fraction",
      illustrations =
      {
        {
          formula = "2 2/3",
          displayedFractions = "1 1 2/3"
        }
      }
    }
  }
}

local TYPE_TO_DESCRIPTOR_MAP =
{
  ["double_tip"] = TIP_DOUBLE,
  ["triple_tip"] = TIP_TRIPLE,
  ["half_tip"] = TIP_HALF,
  ["third_tip"] = TIP_THIRD,
  ["quarter_tip"] = TIP_QUARTER,
  ["third_tip_special"] = TIP_THIRD_SPECIAL,
  ["half_tip_special"] = TIP_HALF_SPECIAL,
  ["triple_tip_special"] = TIP_TRIPLE_SPECIAL,
  ["double_tip_special"] = TIP_DOUBLE_SPECIAL,
  ["third_tip_easy"] = TIP_THIRD_EASY,
  ["quarter_tip_easy"] = TIP_QUARTER_EASY,
  ["double_tip_easy"] = TIP_DOUBLE_EASY,
  ["triple_tip_easy"] = TIP_TRIPLE_EASY
}

function FoodTipsData.getTipDescriptor(tipType)
  return TYPE_TO_DESCRIPTOR_MAP[tipType]
end
