--- FunkyFraction
-- @author Created by Aaron Barrett on February 01, 2016.

class("FunkyFraction")

require("FunkyFractionFormat")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FunkyFraction:getNumerator()
  return self.numerator
end

function FunkyFraction:getDenominator()
  return self.denominator
end

function FunkyFraction:equals(otherFraction)
  return ((self.numerator == otherFraction:getNumerator())
          and (self.denominator == otherFraction:getDenominator()))
end

function FunkyFraction:getReducedForm()
  return tostring(self.numerator) .. "/" .. tostring(self.denominator)
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FunkyFraction.new(numerator, denominator)
  local self = {}
  Mixin.mix(self, FunkyFraction)

  self.numerator = numerator
  self.denominator = denominator

  return self
end
