--- FunkyItemFaceMoney
-- @author Created by Aaron Barrett on February 01, 2016.

class("FunkyItemFaceMoney")

require("FunkyExpressionMoney")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FunkyItemFaceMoney.new(width, height, fraction, multiplier)
  local self = Group.new(width, height)
  Mixin.mix(self, FunkyItemFaceMoney)

  local spacing = -ReferenceDevice.getScaledHeight(2.0)
  local column = Column.new(spacing)

  local fontSize = 26.0

  local numeratorBaseAmount = fraction:getNumerator()
  local numeratorExpression = FunkyExpressionMoney.new(numeratorBaseAmount, multiplier, fontSize)
  numeratorExpression:inheritColor(self)

  local denominatorBaseAmount = fraction:getDenominator()
  local denominatorExpression = FunkyExpressionMoney.new(denominatorBaseAmount, multiplier, fontSize)
  denominatorExpression:inheritColor(self)

  local ofFont = Font.new(FontFaces.DIN_OT_LIGHT, 20.0)
  local ofLabel = Label.new(Localizer.get("OF"), ofFont)
  ofLabel:inheritColor(self)

  column:insert(numeratorExpression)
  column:insert(ofLabel)
  column:insert(denominatorExpression)
  column:alignChildren()

  self:insertAtCenter(column)

  return self
end
