--- FunkyOutroFlashOverlay
-- @author Created by Aaron Barrett on March 04, 2016.

class("FunkyOutroFlashOverlay")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_WHITE = {1.0, 1.0, 1.0}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FunkyOutroFlashOverlay:playOutro()
  local outroAction = AHSequence.new(
    AHOpacityTo.new(self, 0.05, AHEaseSineIn.new(), 1.0),
    AHOpacityTo.new(self, 0.05, AHEaseSineOut.new(), 0.0),
    AHOpacityTo.new(self, 0.25, AHEaseSineIn.new(), 1.0),
    AHOpacityTo.new(self, 0.25, AHEaseSineOut.new(), 0.0)
  )
  return outroAction:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FunkyOutroFlashOverlay.new()
  local self = FilledRectangle.newFullScreen(COLOR_WHITE)
  Mixin.mix(self, FunkyOutroFlashOverlay)

  self:setBlendMode(MOAIProp2D.BLEND_ADD)

  self:setOpacity(0.0)

  return self
end
