--- FunkyPercentageFormatter
-- @author Created by Aaron Barrett on February 25, 2016.

class("FunkyPercentageFormatter")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FunkyPercentageFormatter.getTextFormattedAsPercentage(numerator, denominator)
  local text = nil

  local decimal = numerator / denominator
  local multipliedDecimal = decimal * 100.0

  local percentageIsRoundNumber = (multipliedDecimal == math.floor(multipliedDecimal))
  local percentageIsRoundAfterOneDecimalPlace = (decimal * 1000.0 == math.floor(decimal * 1000.0))

  if (percentageIsRoundNumber) then
    text = tostring(multipliedDecimal)
  elseif (percentageIsRoundAfterOneDecimalPlace) then
    text = string.format("%.1f", multipliedDecimal)
  else
    text = string.format("%.2f", multipliedDecimal)
  end

  return text
end
