--- FunkyRibbonSegmentBase
-- @author Created by Aaron Barrett on February 19, 2016.

class("FunkyRibbonSegmentBase")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FunkyRibbonSegmentBase:configureRibbonInterval(startProgress, endProgress)
  self.startProgress = startProgress
  self.endProgress = endProgress
  self.relativeInterval = endProgress - startProgress
end

function FunkyRibbonSegmentBase:getRelativeInterval()
  return self.relativeInterval
end

function FunkyRibbonSegmentBase:appendCoordinatesAlongRibbonInterval(coordinates, bandStartProgress, bandEndProgress)
  local relativeStartProgress = (bandStartProgress - self.startProgress) / self.relativeInterval
  local relativeEndProgress = (bandEndProgress - self.startProgress) / self.relativeInterval

  local segmentFallsWithinInterval = (((relativeStartProgress > 0.0) or (relativeEndProgress > 0.0)) and
                                      ((relativeStartProgress < 1.0) or (relativeEndProgress < 1.0)))
  if (segmentFallsWithinInterval) then
    self:appendCoordinatesAlongInterval(coordinates,
                                        MathUtils.clamp(relativeStartProgress, 0.0, 1.0),
                                        MathUtils.clamp(relativeEndProgress, 0.0, 1.0))
  end
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FunkyRibbonSegmentBase.new()
  local self = {}
  Mixin.mix(self, FunkyRibbonSegmentBase)

  self.startProgress = nil
  self.endProgress = nil
  self.relativeInterval = nil

  return self
end
