--- FunkyShaker
-- @author Created by Aaron Barrett on March 08, 2016.

class("FunkyShaker")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

FunkyShaker.Z_BACKGROUND = 10
FunkyShaker.Z_BUNCH = 20

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FunkyShaker:playWrong()
  local ease = AHEaseSineInOut.new()
  local centerX = self:getWidthPart(0.5)
  local shakeAction = AHSequence.new(
    AHLocationXTo.new(self, 0.20, ease, centerX + ReferenceDevice.getScaledWidth(6.0)),
    AHLocationXTo.new(self, 0.12, ease, centerX - ReferenceDevice.getScaledWidth(4.0)),
    AHLocationXTo.new(self, 0.06, ease, centerX + ReferenceDevice.getScaledWidth(1.0)),
    AHLocationXTo.new(self, 0.04, ease, centerX)
  )
  return shakeAction:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FunkyShaker.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, FunkyShaker)

  return self
end
