--- FunkySkewedGradient
-- @author Created by Aaron Barrett on March 08, 2016.

class("FunkySkewedGradient")

require("graphics.TiledImage")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local HEIGHT = Screen.getHeightPart(0.3)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function FunkySkewedGradient:playAppear()
  local appearAction = AHOpacityTo.new(self, 1.0, nil, 1.0)
  return appearAction:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function FunkySkewedGradient.new()
  local texture = TextureLoader.loadTexture("tiles/upper_gradient.png")

  local _, textureHeight = texture:getSize()

  local effectiveHeight = HEIGHT * Host.contentScale
  local textureScale = effectiveHeight / textureHeight

  local scaleFudgeAmount = 0.01
  local fudgedTextureScale = textureScale + scaleFudgeAmount

  local self = TiledImage.newWithTexture(texture, WIDTH, HEIGHT, fudgedTextureScale)
  Mixin.mix(self, FunkySkewedGradient)

  return self
end
