--- GoodsRationaleExample
-- @author Created by Aaron Barrett on July 12, 2021.

class("GoodsRationaleExample")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local FONT_FACE = FontFaces.DIN_OT_MEDIUM

local SPACING = FontScaling.getScaledSize(4.0)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function getPercentage(self)
  local item = self.item
  local effect = item:getEffect()
  local amountAsDecimal = effect:getAmount()
  return MathUtils.round(amountAsDecimal * 100)
end

local function buildLabels(self, fontSize)
  local basePrice = self.item:getBasePrice()
  local percentage = getPercentage(self)
  local lines = GoodsExampleLinesBuilder.getLines(basePrice, percentage)

  local font = Font.new(FONT_FACE, fontSize)

  for _, line in ipairs(lines) do
    local label = Label.new(line, font)
    self:insert(label)
    label:inheritOpacity(self)
  end
end

-- Constructor ------------------------

function GoodsRationaleExample.new(item, fontSize)
  local self = Column.new(SPACING)
  Mixin.mix(self, GoodsRationaleExample)

  self.item = item

  buildLabels(self, fontSize)
  self:alignChildren()

  return self
end
