--- GoodsRationaleTextView
-- @author Created by Aaron Barrett on July 15, 2021.

class("GoodsRationaleTextView")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function GoodsRationaleTextView:createViewForImageItem(item)
  local emptyView = self:createViewForEmptyItem(item)
  local lineHeight = emptyView:getHeight()

  local sprite = Sprite.newWithName(item:getImageFilename())
  sprite:inheritOpacity(self)
  sprite:setScl(lineHeight / sprite:getHeight())

  local effectiveWidth, effectiveHeight = sprite:getEffectiveDims()
  local shrinkFactor = 0.925
  local holderGroup = Group.new(effectiveWidth * shrinkFactor, effectiveHeight * shrinkFactor)
  holderGroup:insertAtCenter(sprite)

  return holderGroup
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function GoodsRationaleTextView.new(textWidth)
  local self = TextView.new(textWidth)
  Mixin.mix(self, GoodsRationaleTextView)

  return self
end
