--- GoodsTiledBackground
-- @author Created by Aaron Barrett on August 03, 2021.

class("GoodsTiledBackground")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WIDTH = Screen.width
local HEIGHT = Screen.height

local TILE_IMAGE_NAME = "tiles/background_tile.png"

local SOLID_BACKGROUND_COLOR = {0.02, 0.06, 0.15}

local Z_SOLID_BACKGROUND = 10
local Z_TILED_BACKGROUND = 20


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function GoodsTiledBackground:playLossOutroFadeIn()
  self:setOpacity(0.0)
  return AHOpacityTo.new(self, 1.0, AHEaseExponentialOut.new(), 1.0):start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function GoodsTiledBackground.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, GoodsTiledBackground)

  local solidBackground = FilledRectangle.newFullScreen(SOLID_BACKGROUND_COLOR)
  self:insertAtCenter(solidBackground, Z_SOLID_BACKGROUND)

  local tiledBackground = TiledImage.newWithFilename(TILE_IMAGE_NAME, WIDTH, HEIGHT)
  self:insertAtCenter(tiledBackground, Z_TILED_BACKGROUND)

  self:linkOpacityAttrToChildren()

  return self
end
