--- GoodsTipTextBuilder
-- @author Created by Aaron Barrett on July 28, 2021.

class("GoodsTipTextBuilder")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TIP_TEXT_BY_PERCENTAGE = {
  [5] = "To calculate 5%, find 10% by moving the decimal one digit to the left. Then, divide that amount by 2.",
  [10] = "To calculate 10%, move the decimal one digit to the left.",
  [15] = "To calculate 15%, find 10% by moving the decimal one digit to the left. Next, find 5% by dividing that amount by two. Then, add the two together.",
  [20] = "To calculate 20%, find 10% by moving the decimal one digit to the left. Then, double the amount.",
  [25] = "To calculate 25%, divide the original value by four.",
  [30] = "To calculate 30%, find 10% by moving the decimal one digit to the left. Then, multiply that amount by three.",
  [33] = "To calculate 33%, divide the original value by three.",
  [40] = "To calculate 40%, find 10% by moving the decimal one digit to the left. Then, multiply that amount by four.",
  [50] = "To calculate 50%, divide the original value in half.",
  [60] = "To calculate 60%, find 10% by moving the decimal one digit to the left. Next, find 50% by dividing the original value in half. Then, add the two together.",
  [70] = "To calculate 70%, find 10% by moving the decimal one digit to the left. Next, triple it to get 30%. Then, deduct that amount from the original value.",
  [75] = "To calculate 75%, find 25% by dividing by four. Then, deduct that amount from the original value.",
  [80] = "To calculate 80%, find 10% by moving the decimal one digit to the left. Next, double it to get 20%. Then, deduct that amount from the original value.",
  [90] = "To calculate 90%, find 10% by moving the decimal one digit to the left. Then, deduct that amount from the original value."
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function GoodsTipTextBuilder.getTipTextForPercentage(percentageAsInteger)
  local tipText = TIP_TEXT_BY_PERCENTAGE[percentageAsInteger]
  assert(tipText ~= nil, "No tip text defined for percentage '" .. tostring(percentage) .. "'.")
  return tipText
end
