--- LinkLayouts
-- @author Created by amorant on June 02, 2014.

class("LinkLayouts")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- Layouts for Links -----------

LinkLayouts.LINK_LAYOUTS = {
  { relativeStartX = 0.45, relativeEndX = 0.30, relativeEndY = 0.83, relativeSmallSegmentLength = 0.40, relativeBigSegmentLength = 0.65, side = "left" },
  { relativeStartX = 0.56, relativeEndX = 0.72, relativeEndY = 0.75, relativeSmallSegmentLength = 0.40, relativeBigSegmentLength = 0.75, side = "right" },
  { relativeStartX = 0.40, relativeEndX = 0.25, relativeEndY = 0.24, relativeSmallSegmentLength = 0.40, relativeBigSegmentLength = 0.65, side = "left" },
  { relativeStartX = 0.54, relativeEndX = 0.72, relativeEndY = 0.18, relativeSmallSegmentLength = 0.40, relativeBigSegmentLength = 0.70, side = "right" }
}

LinkLayouts.OUTRO_LAYOUTS = {
  { relativeStartX = 0.28, relativeEndX = 0.19, relativeEndY = 0.70, relativeSmallSegmentLength = 0.65, relativeBigSegmentLength = 0.70, side = "right" },
  { relativeStartX = 0.51, relativeEndX = 0.33, relativeEndY = 0.89, relativeSmallSegmentLength = 0.37, relativeBigSegmentLength = 0.52, side = "right" },
  { relativeStartX = 0.73, relativeEndX = 0.75, relativeEndY = 0.75, relativeSmallSegmentLength = 0.45, relativeBigSegmentLength = 0.65, side = "right" },
  { relativeStartX = 0.28, relativeEndX = 0.19, relativeEndY = 0.24, relativeSmallSegmentLength = 0.40, relativeBigSegmentLength = 0.55, side = "right" },
  { relativeStartX = 0.49, relativeEndX = 0.65, relativeEndY = 0.10, relativeSmallSegmentLength = 0.30, relativeBigSegmentLength = 0.65, side = "left" },
  { relativeStartX = 0.69, relativeEndX = 0.81, relativeEndY = 0.29, relativeSmallSegmentLength = 0.50, relativeBigSegmentLength = 0.55, side = "left" }
}

-- Patterns for LinksGraphPattern ----------

LinkLayouts.PATTERN_POINTS = {
  { 0.52, 0.62 },
  { 0.52, 0.48 },
  { 0.41, 0.69 },
  { 0.71, 0.75 },
  { 0.15, 0.67 }, -- 5
  { 0.16, 0.76 },
  { 0.42, 0.84 },
  { 0.68, 0.81 },
  { 0.90, 0.78 },
  { 0.81, 0.85 }, -- 10
  { 1.10, 0.96 },
  { -0.1, 0.83 },
  { 0.27, 0.88 },
  { 1.10, 0.78 },
  { 0.86, 0.68 }, -- 15
  { 1.10, 0.64 },
  { -0.1, 0.57 },
  { 0.21, 0.62 },
  { 0.71, 0.63 },
  { 0.92, 0.58 }, -- 20
  { 0.47, 0.92 },
  { 0.17, 0.96 },
  { 0.05, 0.90 },
  { 0.27, 0.43 },
  { 0.57, 0.87 }, -- 25
  { 0.61, 0.96 },
  { 0.40, 0.97 },
  { 0.35, 0.77 },
  { 0.61, 0.91 },
  { 0.78, 1.01 }, -- 30
  { 0.93, 0.94 },
  { 0.15, 1.10 },
  { 0.55, 0.73 },
  { 0.50, 1.10 },
  { 0.53, 1.10 }, -- 35
  { 0.72, 0.42 },
  { 0.06, 0.73 },
  { -0.1, 0.90 },
  { 0.08, 0.31 },
  { 0.41, 0.31 }, -- 40
  { 0.56, 0.27 },
  { 0.86, 0.37 },
  { 0.50, 0.41 },
  { 0.63, 0.19 },
  { 0.30, 0.22 }, -- 45
  { 0.93, 0.47 },
  { 0.07, 0.46 },
  { -0.1, 0.31 },
  { 0.22, 0.32 },
  { 0.08, 0.14 }, -- 50
  { 0.40, 0.12 },
  { 0.70, 0.29 },
  { 0.49, 0.07 },
  { 1.10, 0.47 },
  { 0.18, 0.08 }, -- 55
  { 0.73, 0.03 },
  { 0.92, 0.14 },
  { 0.88, 0.26 },
  { -0.1, 0.18 },
  { 0.02, -0.1 }, -- 60
  { 0.39, -0.1 },
  { 1.10, 0.36 },
  { 0.60, -0.1 },
  { 0.71, 0.08 },
  { 1.10, 0.11 }, -- 65
  { 0.11, 0.23 },
  { 0.48, 0.19 },
}

LinkLayouts.PATTERN_EDGES = {
  -- North sub-tree
  [1] = TableUtils.createSetFromArray({ 3, 4 }),
  [3] = TableUtils.createSetFromArray({ 5, 6, 33 }),
  [4] = TableUtils.createSetFromArray({ 8, 9, 15 }),
  [5] = TableUtils.createSetFromArray({ 17, 18 }),
  [6] = TableUtils.createSetFromArray({ 12, 13, 28, 37 }),
  [9] = TableUtils.createSetFromArray({ 10, 11, 14 }),
  [10] = TableUtils.createSetFromArray({ 29, 30, 31 }),
  [15] = TableUtils.createSetFromArray({ 16, 19, 20 }),
  [13] = TableUtils.createSetFromArray({ 22 }),
  [21] = TableUtils.createSetFromArray({ 25, 26, 27 }),
  [22] = TableUtils.createSetFromArray({ 23, 32, 34 }),
  [23] = TableUtils.createSetFromArray({ 38 }),
  [27] = TableUtils.createSetFromArray({ 35 }),
  [33] = TableUtils.createSetFromArray({ 7 }),
  [7] = TableUtils.createSetFromArray({ 21 }),
  -- South sub-tree
  [2] = TableUtils.createSetFromArray({ 24, 36 }),
  [24] = TableUtils.createSetFromArray({ 39, 40, 47 }),
  [36] = TableUtils.createSetFromArray({ 41, 42 }),
  [39] = TableUtils.createSetFromArray({ 48 }),
  [40] = TableUtils.createSetFromArray({ 43 }),
  [41] = TableUtils.createSetFromArray({ 44, 45 }),
  [42] = TableUtils.createSetFromArray({ 46 }),
  [44] = TableUtils.createSetFromArray({ 53, 58 }),
  [45] = TableUtils.createSetFromArray({ 50, 51 }),
  [46] = TableUtils.createSetFromArray({ 54 }),
  [50] = TableUtils.createSetFromArray({ 66, 59 }),
  [51] = TableUtils.createSetFromArray({ 55, 67 }),
  [53] = TableUtils.createSetFromArray({ 56, 63 }),
  [56] = TableUtils.createSetFromArray({ 57, 64 }),
  [57] = TableUtils.createSetFromArray({ 65 }),
  [58] = TableUtils.createSetFromArray({ 52, 62 }),
  [55] = TableUtils.createSetFromArray({ 60, 61 }),
  [66] = TableUtils.createSetFromArray({ 49 }),
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getFlippedLayout(layout, flipX, flipY)
  local flippedLayout = TableUtils.shallowCopy(layout)

  if flipX then
    flippedLayout.relativeStartX = 1 - layout.relativeStartX
    flippedLayout.relativeEndX = 1 - layout.relativeEndX
    if layout.side == "left" then
      flippedLayout.side = "right"
    else
      flippedLayout.side = "left"
    end
  end

  if flipY then
    flippedLayout.relativeEndY = 1 - layout.relativeEndY
  end

  return flippedLayout
end

local function getRandomlyFlippedLayouts(layouts)
  local flippedLayouts = {}
  local flipX = MathUtils.getRandomBoolean()
  local flipY = MathUtils.getRandomBoolean()

  for _, layout in ipairs(layouts) do
    local flippedLayout = getFlippedLayout(layout, flipX, flipY)
    table.insert(flippedLayouts, flippedLayout)
  end

  return flippedLayouts
end

local function getFlippedPoint(point, flipX, flipY)
  local x, y = unpack(point)

  if flipX then
    x = 1 - x
  end

  if flipY then
    -- Vertical flip is not exactly symmetrical to account for central node gap
    local northMinY, northMaxY = 0, 0.48
    local southMinY, southMaxY = 0.62, 1
    if y < 0.5 then
      y = MathUtils.mapLinear(y, northMinY, northMaxY, southMaxY, southMinY)
    else
      y = MathUtils.mapLinear(y, southMinY, southMaxY, northMaxY, northMinY)
    end
  end

  return { x, y }
end

local function getRandomlyFlippedPoints(originalPoints)
  local flippedPoints = {}
  local flipX = MathUtils.getRandomBoolean()
  local flipY = MathUtils.getRandomBoolean()

  for _, point in ipairs(originalPoints) do
    local flippedPoint = getFlippedPoint(point, flipX, flipY)
    table.insert(flippedPoints, flippedPoint)
  end

  return flippedPoints
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function LinkLayouts.getLinksLayouts()
  return getRandomlyFlippedLayouts(LinkLayouts.LINK_LAYOUTS)
end

function LinkLayouts.getOutroLayouts()
  return getRandomlyFlippedLayouts(LinkLayouts.OUTRO_LAYOUTS)
end

function LinkLayouts.getPatternPoints()
  return getRandomlyFlippedPoints(LinkLayouts.PATTERN_POINTS)
end

function LinkLayouts.getPatternEdges()
  return LinkLayouts.PATTERN_EDGES
end
