--- LinksDragHelpOverlay
-- @author Created by amorant on August 26, 2014.

class("LinksDragHelpOverlay")
require("widgets.DragHelpOverlay")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local MESSAGE = "drag answers to links"
local MESSAGE_RELATIVE_Y = 0.20
local ARROW_RELATIVE_X_OFFSET = 0.20
local MESSAGE_LABEL_FONT_SIZE = 16
local ARROW_SCALE = 0.5

local SHOW_AFTER_INACTIVITY_DELAY = 5

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function stopShowAfterInactivity(self)
  if self.showAfterInactivity then
    self.showAfterInactivity:stop()
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function LinksDragHelpOverlay:show()
  local shouldShow = self.isEnabled and not self.isShown

  if shouldShow then
    self.isShown = true
    return self.super.show(self)
  end
end

function LinksDragHelpOverlay:hide()
  local shouldHide = self.isEnabled and self.isShown

  if shouldHide then
    self.isShown = false
    return self.super.hide(self)
  end
end

function LinksDragHelpOverlay:enable()
  self.isEnabled = true
end

function LinksDragHelpOverlay:disable()
  self.isEnabled = false
  stopShowAfterInactivity(self)
end

function LinksDragHelpOverlay:showAfterInactivityDelay()
  stopShowAfterInactivity(self)
  self.showAfterInactivity = runInCoroutine(function()
    waitFor(SHOW_AFTER_INACTIVITY_DELAY)
    self:show()
  end)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function LinksDragHelpOverlay.new()
  local self = DragHelpOverlay.new(MESSAGE, MESSAGE_RELATIVE_Y, ARROW_RELATIVE_X_OFFSET, MESSAGE_LABEL_FONT_SIZE, ARROW_SCALE)
  Mixin.mix(self, LinksDragHelpOverlay)

  self.isShown = false
  self.isEnabled = true

  return self
end
