--- LinksPanelScroller
-- @author Created by amorant on June 02, 2014.

class("LinksPanelScroller")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- Z-Indices --------------------------

local Z_PANELS = 10

-- Colors -----------------------------

local OVERLAY_COLOR = { 0, 0, 0, 0.8 }

-- Animation --------------------------

local PANEL_MOVE_DURATION = 40

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createLoopAnimation(self)
  return AHLoop.new(
    AHSequence.new(
      AHLocationXTo.new(self.panel, PANEL_MOVE_DURATION, nil, 0),
      function() self.panel:setLoc(-2 * self:getWidth(), 0) end
    )
  )
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function LinksPanelScroller.startAnimation(self)
  local animation = createLoopAnimation(self)
  animation:start()
  self.animation = animation
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createElements(self)
  local width, height = self:getDims()

  local panel = Sprite.newWithName("bg_overlay.png")
  panel:setColor(unpack(OVERLAY_COLOR))
  panel:setEffectiveDims(3 * width, height)
  panel:setAnchorPointBottomLeft()
  panel:setLoc(-2 * width, 0)
  self:insert(panel, Z_PANELS)
  self.panel = panel
end

-- Constructor ------------------------

function LinksPanelScroller.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, LinksPanelScroller)

  createElements(self)

  return self
end
