--- LinusCommon
-- @author Created by Jay Austria on October 27, 2015.

class("LinusCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

LinusCommon.COLORS = {
  WHITE = ColorUtils.colorHex24ToStd(0xFFFFFF),
  BLACK = ColorUtils.colorHex24ToStd(0x000000),
  MAGENTA = ColorUtils.colorHex24ToStd(0xF7A4F7),
  DIMMED_MAGENTA = ColorUtils.colorHex24ToStd(0x332b55),
  CYAN = ColorUtils.colorHex24ToStd(0x27FFFF)
}

LinusCommon.UI_COMPONENTS_COLOR_DEFAULT = LinusCommon.COLORS.MAGENTA
LinusCommon.UI_COMPONENTS_COLOR_POSITIVE = ColorUtils.colorHex24ToStd(0x00FFFF)

LinusCommon.VISIBLE_OPACITY = 1.0
LinusCommon.INVISIBLE_OPACITY = 0.0

LinusCommon.SINGLE_PIXEL_DIMENSION = (1 / Host.contentScale)

LinusCommon.TABLET_RATIO_FONT_SCALE = 0.85

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

function LinusCommon.getAspectRatioAdjustedFontSize(fontSize)
  if (Screen.isTabletAspectRatio()) then
    return fontSize * LinusCommon.TABLET_RATIO_FONT_SCALE
  end

  return fontSize
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
