--- LinusConceptGenerator
-- @author Created by Jay Austria on October 20, 2015.

class("LinusConceptGenerator")

require("data.generators.UtilityGenerators")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function packageConceptIntoRound(concept)
  local answer = concept.minuend - concept.subtrahend

  local round =
  {
    minuend = concept.minuend,
    subtrahend = concept.subtrahend,
    answer = answer,
    identifier = concept.identifier,
    tipType = concept.tipType
  }

  return round
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function LinusConceptGenerator.new()
  local conceptGenerator = GameSession.conceptGenerator
  return TransformationGenerator.new(conceptGenerator, function(concept)
    return packageConceptIntoRound(concept)
  end)
end
