--- ManslapGame
-- @author Created by alexeychernikov on March 31, 2014.

class("ManslapBossModeBackground")
require("ManslapRewindSign")
require("actions.advanced.Shake")
require("ManslapColors")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function cancelAnimation(self)
  if (self.animation) then
    self.animation:stop()
    self.animation = nil
  end
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ManslapBossModeBackground:enable()
  self.view:setVisible(true)
end

function ManslapBossModeBackground:disable()
  self.view:setVisible(false)
end

function ManslapBossModeBackground:enterRewindMode()
  cancelAnimation(self)
  self.animation = AHColorTo.new(self.view, 0.1, nil, ManslapColors.REWIND_BACKGROUND_COLOR)
  self.animation:start()

  self.rewindSign:show()
  self.rewindSign:blink()
end

function ManslapBossModeBackground:enterNormalMode()
  cancelAnimation(self)
  self.animation = AHColorTo.new(self.view, 0.1, nil, ManslapColors.BOSS_MODE_BACKGROUND_COLOR):start()
  self.animation:start()

  self.rewindSign:stopBlink()
  self.rewindSign:hide()
end


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local view = FilledRectangle.newFullScreen(ManslapColors.BOSS_MODE_BACKGROUND_COLOR)
  self:insertAtCenter(view)
  self.view = view

  local rewindSign = ManslapRewindSign.new()
  rewindSign:setLoc(Screen.getSafeX(0.5), Screen.getSafeY(0.5))
  self:insert(rewindSign)
  rewindSign:hide()
  self.rewindSign = rewindSign
end

function ManslapBossModeBackground.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, ManslapBossModeBackground)
  createLayout(self)
  return self
end
