--- ManslapConfiguration
-- @author Created by Jay Austria on February 23, 2016.

class("ManslapConfiguration")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

ManslapConfiguration.POINTS_PER_LIVES_BONUS = 1000
ManslapConfiguration.TOTAL_POINTS_FOR_GAME = 9000
ManslapConfiguration.INITIAL_LIVES_COUNT = 5
ManslapConfiguration.MAX_POINTS_FROM_ALL_SPEED_BONUSES = 900
ManslapConfiguration.SPEED_BONUS_WINDOW_IN_SECONDS = 2.2
ManslapConfiguration.SPEED_BONUS_DECAY_START = 0.0

local EXTRA_LIVES_RANK_TWO = 3
local EXTRA_LIVES_RANK_THREE = 4


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ManslapConfiguration.getRankTwoScore()
  local scoreForQuestions = ManslapConfiguration.TOTAL_POINTS_FOR_GAME
  local extraPointsRankTwo = EXTRA_LIVES_RANK_TWO * ManslapConfiguration.POINTS_PER_LIVES_BONUS
  local rankTwoScore = scoreForQuestions + extraPointsRankTwo

  return rankTwoScore
end

function ManslapConfiguration.getRankThreeScore()
  local scoreForQuestions = ManslapConfiguration.TOTAL_POINTS_FOR_GAME
  local extraPointsRankThree = EXTRA_LIVES_RANK_THREE * ManslapConfiguration.POINTS_PER_LIVES_BONUS
  local rankThreeScore = scoreForQuestions + extraPointsRankThree

  return rankThreeScore
end


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
