--- ManslapGame
-- @author Created by alexeychernikov on March 31, 2014.

class("ManslapGame")

require("StandardUIBuilder")
require("ManslapColors")
require("ManslapScene")
require("ManslapGameManager")


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- gameFlow ---------------------------

function ManslapGame:gameFlow()
  self.sceneCover:removeSelf()
  self.gameManager:startGame()
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------


local function createGameElements(self)
  local uiOverlay = self:getUIOverlay()

  self.scene = ManslapScene.new(uiOverlay)
  self.sceneCover = FilledRectangle.newFullScreen(ManslapColors.BACKGROUND_COLOR)

  self:insertAtCenter(self.scene)
  self:insertAtCenter(self.sceneCover)
  self.gameManager = ManslapGameManager.new(self.scene, self.scoreCounter, self.livesCounter, self)
end

local function createUI(self)
  local builder = StandardUIBuilder.new(self:getUIOverlay(), ManslapColors.UI_COLOR)

  builder:addPauseButton()
  self.scoreCounter = builder:addScoreLabel()
  self.livesCounter = builder:addLivesDisplay(ManslapConfiguration.INITIAL_LIVES_COUNT)
  self.bonusTray = builder:addBonusTray()
end

-- Constructor ------------------------

function ManslapGame.new()
  local self = BaseGame.new()
  Mixin.mix(self, ManslapGame)

  createUI(self)
  createGameElements(self)

  return self
end
