--- ManslapGame
-- @author Created by alexeychernikov on March 31, 2014.

class("ManslapParticleSpeck")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getGlowColor(color)
  local r, g, b, a = unpack(color)
  a = a or 1
  return r, g, b, a * 0.5
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function ManslapParticleSpeck.new(color, radius)
  local width = radius * 2
  local height = width
  local self = Group.new(width, height)
  Mixin.mix(self, ManslapParticleSpeck)

  local isStroke = math.random() < 0.3
  local hasGlow = not isStroke and math.random() < 0.5

  local view = FilledCircle.new(radius, color, nil, isStroke)

  if (hasGlow) then
    local glow = FilledCircle.new(radius * 2, nil, nil, isStroke)
    glow:setColor(getGlowColor(color))
    self:insert(glow)
  end
  self:insert(view)

  return self
end
