--- ManslapTapToRewindLabel
-- @author Created by Aaron Barrett on October 27, 2021.

class("ManslapTapToRewindLabel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TAP_TO_REWIND_TEXT = "TAP TO REWIND"
local TAP_TO_CONTINUE_TEXT = Localizer.get("Misc.TAP_TO_CONTINUE")
local COLOR = ManslapColors.FULL_BLACK
local FULL_OPACITY = 0.5

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ManslapTapToRewindLabel:showAppearAnimation(gameHasEnded)
  if (gameHasEnded) then
    self:setText(TAP_TO_CONTINUE_TEXT)
  end

  return AHOpacityTo.new(self, 0.5, AHEaseBezier.newFlat({0.5, 0.4, 0.0, 1.0}), FULL_OPACITY):start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ManslapTapToRewindLabel.new()
  local self = Label.new(TAP_TO_REWIND_TEXT, Font.new(FontFaces.DIN_OT_MEDIUM, 15.0))
  Mixin.mix(self, ManslapTapToRewindLabel)

  self:setColor(unpack(COLOR))
  self:setOpacity(0.0)

  return self
end
