--- ManslapTextInterpreter
-- @author Created by Jay Austria on February 22, 2017.

class("ManslapTextInterpreter")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ManslapTextInterpreter:interpretXmlText(text)
  local items = self.super.interpretXmlText(self, text)

  -- prevent error text from splitting across a newline
  for i = 2, #items do
    local textItem = items[i]
    local previousTextItem = items[i - 1]

    local itemIsError = textItem:getAttribute("isError")
    local previousItemIsError = previousTextItem:getAttribute("isError")

    if (itemIsError and previousItemIsError) then
      previousTextItem:setAllowBreakLineAfter(false)
      textItem:setAllowBreakLineBefore(false)
    end
  end

  return items
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ManslapTextInterpreter.new(baseAttributes, attributesForLabels)
  local self = TextInterpreter.new(baseAttributes, attributesForLabels)
  Mixin.mix(self, ManslapTextInterpreter)

  return self
end
