--- MatryoshkaRoundLabel
-- @author Created by andrewc on June 27, 2019.

class("MatryoshkaRoundLabel")

require("MatryoshkaCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_TEXT = {1, 1, 1, 1}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function insertLabelIntoBox(label, color, width, height)
  local cornerRadius = 3
  local box = FilledRoundedRectangle.new(width, height, cornerRadius, color)

  box:insertAtCenter(label)
  box:setScl(1, 0)
  box:linkOpacityAttrToChildren()
  return box
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function MatryoshkaRoundLabel.newRoundLabel(text, color)
  local fontSize = 14

  color = ColorUtils.colorRGBToStd(unpack(color))
  local label = Label.new(text, PrerenderedFont.new(MatryoshkaCommon.FONT_NORMAL, fontSize))
  label:setColor(unpack(COLOR_TEXT))

  local width = label:getWidth() * 1.25
  local height = label:getHeight() * 1.5

  local self = insertLabelIntoBox(label, color, width, height)
  Mixin.mix(self, MatryoshkaQuestionLabel)

  return self
end

function MatryoshkaRoundLabel.newFinalSetLabel()
  local fontSize = 10 * Host.contentScale
  local text = Localizer.get("FINAL_SET")
  local color = {112,190,188}

  color = ColorUtils.colorRGBToStd(unpack(color))
  local label = Label.new(text, PrerenderedFont.new(MatryoshkaCommon.FONT_NORMAL, fontSize))
  label:setColor(unpack(COLOR_TEXT))

  local width = label:getWidth() * 1.2
  local height = label:getHeight() * 1.5

  local self = insertLabelIntoBox(label, color, width, height)
  Mixin.mix(self, MatryoshkaQuestionLabel)

  return self
end