--- MatryoshkaValidator
-- @author Created by Anton Morant on April 17, 2014.
-- ConceptValidator for Matryoshka.

class("MatryoshkaValidator")

require("validators.ConceptValidator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_KEYS = {
  'prompt',
  'answer',
  'image'
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function MatryoshkaValidator:validateConcept(concept)
  self:validateRequiredKeys(concept, REQUIRED_KEYS)
  self:validateImageFile(concept.image)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function MatryoshkaValidator.new()
  local self = ConceptValidator.new()
  Mixin.mix(self, MatryoshkaValidator)

  return self
end
