--- NominaCountdown
-- @author Created by Aaron Barrett on August 05, 2014.

class("NominaCountdown")
require("widgets.progress.BarProgressIndicator")
require("widgets.progress.ProgressTimer")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WIDTH = Screen.width
local HEIGHT = Screen.height

local FOREGROUND_COLOR = {0.94, 0.94, 0.94}
local BACKGROUND_COLOR = {0.84, 0.84, 0.84}

local GROW_DIRECTION = BarProgressIndicator.GrowUp

local DEFAULT_DURATION = 20.0

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function NominaCountdown:createFadeOutAction()
  local progressBar = self.progressBar
  local fadeOutAction = AHOpacityTo.new(progressBar, 0.3, nil, 0.0)
  return fadeOutAction
end

function NominaCountdown:createRefillAction()
  local duration = 0.2
  local ease = AHEaseSimpleInOut.new(2.0)
  local refillAction = AHNormalizedTimeTo.new(self, duration, ease, 0.0)
  return refillAction
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function NominaCountdown.new(onTimeoutCallback)
  local self = BarProgressIndicator.new(WIDTH, HEIGHT, FOREGROUND_COLOR, BACKGROUND_COLOR, GROW_DIRECTION)
  Mixin.mix(self, NominaCountdown)

  ProgressTimer.makeTimer(self, DEFAULT_DURATION, onTimeoutCallback)

  return self
end
