--- NominaDragHelpOverlay
-- @author Created by Aaron Barrett on August 14, 2014.

class("NominaDragHelpOverlay")
require("widgets.DragHelpOverlay")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local MESSAGE = "drag names to faces"

local ARROW_SCALE = 0.75

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function NominaDragHelpOverlay:show()
  local shouldShow = (not self.hasStartedShowing)
  if (shouldShow) then
    self.hasStartedShowing = true

    return self.super.show(self)
  end
end

function NominaDragHelpOverlay:hide()
  local shouldHide = (not self.hasStartedHiding)
  if (shouldHide) then
    self.hasStartedHiding = true

    return runInCoroutine(function()
      wait(self.super.hide(self))
      self:removeSelf()
    end)
  end
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function NominaDragHelpOverlay.new()
  local messageYFractional = 0.27 + (Screen.safeBottom/Screen.height)
  local self = DragHelpOverlay.new(MESSAGE, messageYFractional, nil, nil, ARROW_SCALE)
  Mixin.mix(self, NominaDragHelpOverlay)

  self.hasStartedShowing = false
  self.hasStartedHiding = false

  return self
end
