--- NominaFact
-- @author Created by Aaron Barrett on July 21, 2014.

class("NominaFact")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local LONG_VERSION_KEY = "fct_lg"
local SHORT_VERSION_KEY = "fct_sh"
local APPEAR_TIME_KEY = "fct_app"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function extractNumberedField(humanFromConcept, keyBase, factIndex)
  local key = keyBase .. "_" .. factIndex
  local field = humanFromConcept[key]
  assert(field ~= nil, "No field found for key: " .. key)
  return field
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- Accessors --------------------------

function NominaFact:getLongVersion()
  return self.longVersion
end

function NominaFact:getShortVersion()
  return self.shortVersion
end

function NominaFact:getAppearTime()
  return self.appearTime
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function NominaFact.new(humanFromConcept, factIndex)
  local self = {}
  Mixin.mix(self, NominaFact)

  self.longVersion = extractNumberedField(humanFromConcept, LONG_VERSION_KEY, factIndex)
  self.shortVersion = extractNumberedField(humanFromConcept, SHORT_VERSION_KEY, factIndex)
  self.appearTime = tonumber(extractNumberedField(humanFromConcept, APPEAR_TIME_KEY, factIndex))

  return self
end
