--- NominaRedFlash
-- @author Created by Aaron Barrett on August 05, 2014.

class("NominaRedFlash")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- Dimensions -------------------------

local WIDTH = Screen.width
local HEIGHT = Screen.height

-- Colors -----------------------------

local RED_COLOR = {1.0, 0.2, 0.2}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- Create Actions ---------------------

function NominaRedFlash:createFlashAction()
  local flashAction = AHSequence.new(
                                     function()
                                       self:setVisible(true)
                                     end,
                                     AHOpacityTo.new(self, 0.05, nil, 0.7),
                                     AHOpacityTo.new(self, 0.15, nil, 0.0),
                                     function()
                                       self:setVisible(false)
                                     end
                                     )

  return flashAction
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function NominaRedFlash.new()
  local self = FilledRectangle.new(WIDTH, HEIGHT, RED_COLOR)
  Mixin.mix(self, NominaRedFlash)

  self:setOpacity(0.0)
  self:setVisible(false)

  return self
end
