--- ObliviateShadowOverlay
-- @author Created by amorant on November 25, 2014.

class("ObliviateShadowOverlay")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createElements(self)
  -- To save memory, instead of one full-screen asset we use an asset containing one corner only
  -- and load it 4 times. We use scaling for flipping each of the corners into place.

  local signs = { 1, -1 }

  for _, scaleSignX in ipairs(signs) do
    for _, scaleSignY in ipairs(signs) do
      local corner = Sprite.newWithName("shadow_corner.png")
      local cornerWidth, cornerHeight = corner:getDims()
      local widthScale = self:getWidth() / (2 * cornerWidth)
      local heightScale = self:getHeight() / (2 * cornerHeight)
      corner:setScl(scaleSignX * widthScale, scaleSignY * heightScale)
      corner:setAnchorPointTopRight()
      corner:inheritColor(self)
      self:insertAtCenter(corner)
    end
  end
end

-- Constructor ------------------------

function ObliviateShadowOverlay.new(width, height)
  local self = Group.new(width, height)
  Mixin.mix(self, ObliviateShadowOverlay)

  createElements(self)

  return self
end
