--- OnboardioPanelEnglishSecondLanguage
-- @author Created by andrewcousins on September 03, 2024.

class("OnboardioPanelEnglishSecondLanguage")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BUTTON_DESCRIPTORS = {
  {
    text = Localizer.get("YES"),
    id = true
  },
  {
    text = Localizer.get("NO"),
    id = false
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getContinueCallback(questionAnsweredCallback)
  return function(self, answerID)
    OnboardioAnalytics.reportESLScreenAnswered(answerID)
    self:setDismissed()
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioPanelEnglishSecondLanguage:publicMethod()

end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelEnglishSecondLanguage.new()
  local promptText = Localizer.get("ESL_PROMPT")
  local continueCallback = getContinueCallback(questionAnsweredCallback)
  local buttonDescriptors = BUTTON_DESCRIPTORS

  local self = OnboardioQuestionPanel.new(promptText, buttonDescriptors, continueCallback)
  Mixin.mix(self, OnboardioPanelEnglishSecondLanguage)

  return self
end
