--- OnboardioPanelFirstGoalQuestion
-- @author Created by andrewcousins on September 04, 2024.

class("OnboardioPanelFirstGoalQuestion")

require("OnboardioQuestionPanel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BUTTON_DESCRIPTORS = {
  {
    text = Localizer.get("FIRST_GOAL_NEW_WORDS"),
    id = "use_new_words"
  },
  {
    text = Localizer.get("FIRST_GOAL_CALCULATE_TIPS"),
    id = "calculate_tips"
  },
  {
    text = Localizer.get("FIRST_GOAL_READ_FASTER"),
    id = "read_faster"
  },
  {
    text = Localizer.get("FIRST_GOAL_WRITE_BETTER"),
    id = "write_better"
  },
  {
    text = Localizer.get("FIRST_GOAL_REMEMBER_NAMES"),
    id = "remember_names"
  },
  {
    text = Localizer.get("FIRST_GOAL_OTHER"),
    id = "other", -- This id is used in OnboardioPanelFirstGoalReinforcement
    isInverted = true
  }
}
-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function continueCallback(self, answerID)
  OnboardioAnalytics.reportFirstGoalScreenAnswered(answerID)
  self:setSelectedAnswer(answerID)
  self:setDismissed()
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelFirstGoalQuestion.new()
  local promptText = Localizer.get("FIRST_GOAL_PROMPT")
  local buttonDescriptors = BUTTON_DESCRIPTORS

  local self = OnboardioQuestionPanel.new(promptText, buttonDescriptors, continueCallback)
  Mixin.mix(self, OnboardioPanelFirstGoalQuestion)

  return self
end
