--- OnboardioPanelFirstGoalReinforcement
-- @author Created by andrewcousins on September 04, 2024.

class("OnboardioPanelFirstGoalReinforcement")

require("OnboardioModernPanel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local PREVIOUS_ANSWER_UNSURE = "other"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local column = Column.new(24)
  local text = Localizer.get("FIRST_GOAL_REINFORCEMENT")
  local font = Font.new(FontFaces.DIN_OT_MEDIUM, 24)
  local textLabel = self:createTextArea(text, font)
  column:insert(textLabel)

  local continueButton = self:addContinueButton()
  column:takeChild(continueButton)

  column:alignChildren()
  self:insertAtCenter(column)

  return layout
end

-- Constructor ------------------------

function OnboardioPanelFirstGoalReinforcement.new(answer)
  if (answer == PREVIOUS_ANSWER_UNSURE) or (answer == OnboardioGame.ANSWER_SKIP) then
    -- Do not show this panel if the user responded "unsure" or skipped the previous question
    return nil
  end

  local self = OnboardioModernPanel.new()
  Mixin.mix(self, OnboardioPanelFirstGoalReinforcement)

  createLayout(self)

  return self
end
