--- OnboardioPanelLearningPace
-- @author Created by andrewcousins on September 02, 2024.

class("OnboardioPanelLearningPace")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BUTTON_DESCRIPTORS = {
  {
    text = Localizer.get("LEARNING_PACE_FAST"),
    id = "asap"
  },
  {
    text = Localizer.get("LEARNING_PACE_MEDIUM"),
    id = "in_between"
  },
  {
    text = Localizer.get("LEARNING_PACE_SLOW"),
    id = "slow"
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getContinueCallback(questionAnsweredCallback)
  return function(self, answerID)
    OnboardioAnalytics.reportLearningPaceScreenAnswered(answerID)

    self:setDismissed()
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelLearningPace.new()
  local promptText = Localizer.get("LEARNING_PACE_PROMPT")
  local continueCallback = getContinueCallback(questionAnsweredCallback)
  local buttonDescriptors = BUTTON_DESCRIPTORS

  local self = OnboardioQuestionPanel.new(promptText, buttonDescriptors, continueCallback)
  Mixin.mix(self, OnboardioPanelLearningPace)

  return self
end
