--- OnboardioPanelMoreQuestionsBreak
-- @author Created by andrewcousins on September 05, 2024.

class("OnboardioPanelMoreQuestionsBreak")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TITLE_TEXT_KEY = "PERSONALIZATION_QUESTION_INTRO"
local BUTTON_TEXT_KEY = "CONTINUE"
local TEXT_COLOR = OnboardioCommon.COLOR_PROMPT_TEXT

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelMoreQuestionsBreak.new()
  local self = OnboardioModernPanel.new()
  Mixin.mix(self, OnboardioPanelMoreQuestionsBreak)

  local column = Column.new(Screen.getHeightPart(0.04))
  local titleText = Localizer.get(TITLE_TEXT_KEY)
  local pretestButtonText = Localizer.get(BUTTON_TEXT_KEY)
  column:insert(self:createTextArea(titleText, Font.new(FontFaces.DIN_OT_MEDIUM, 22), TEXT_COLOR))
  column:insert(self:createButton(pretestButtonText, function()
    self:setDismissed()
  end))

  column:alignChildren()
  self:insertAtCenter(column)

  return self
end
