--- OnboardioPanelOtherBrainActivities
-- @author Created by andrewcousins on September 03, 2024.

class("OnboardioPanelOtherBrainActivities")

require("OnboardioCheckboxSelectionPanel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local PROMPT_KEY = "OTHER_BRAIN_ACTIVITIES_PROMPT"
local SUBTITLE_KEY = "OTHER_BRAIN_ACTIVITIES_SUBTITLE"

local BUTTON_DESCRIPTIONS = {
  {
    identifier = "reading",
    copyKey = "OTHER_BRAIN_ACTIVITIES_READING"
  },
  {
    identifier = "puzzles",
    copyKey = "OTHER_BRAIN_ACTIVITIES_PUZZLES"
  },
  {
    identifier = "new_language",
    copyKey = "OTHER_BRAIN_ACTIVITIES_NEW_LANGUAGE"
  },
  {
    identifier = "musical_instrument",
    copyKey = "OTHER_BRAIN_ACTIVITIES_MUSICAL_INSTRUMENT"
  },
  {
    identifier = "exercise",
    copyKey = "OTHER_BRAIN_ACTIVITIES_EXERCISE"
  },
  {
    identifier = "meditation",
    copyKey = "OTHER_BRAIN_ACTIVITIES_MEDITATION"
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getOnCompleted(self)
  return function(identifiersSelectedTable)
    local selectedIdentifiers = {}
    for identifier, isSelected in pairs(identifiersSelectedTable) do
      if isSelected then
        table.insert(selectedIdentifiers, identifier)
      end
    end
    OnboardioAnalytics.reportOtherBrainActivitiesScreenAnswered(selectedIdentifiers)
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelOtherBrainActivities.new()
  local promptText = Localizer.get(PROMPT_KEY)
  local subtitleText = Localizer.get(SUBTITLE_KEY)

  local self = OnboardioCheckboxSelectionPanel.new(promptText, subtitleText, BUTTON_DESCRIPTIONS, getOnCompleted(self))
  Mixin.mix(self, OnboardioPanelOtherBrainActivities)

  return self
end
