--- OnboardioPanelReviewProof
-- @author Created by andrewcousins on August 30, 2024.

class("OnboardioPanelReviewProof")

require("OnboardioModernPanel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local HEADER_TEXT_KEY = "REVIEW_PROOF_HEADER"
local REVIEW_IMAGE_NAME = "review_proof.png"
local REVIEW_DARK_MODE_IMAGE_NAME = "review_proof_dark.png"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local layoutColumn = Column.new(self:getHeightPart(0.07))
  local headerLabel = self:createTextArea(Localizer.get(HEADER_TEXT_KEY))
  layoutColumn:insert(headerLabel)
  local spriteName = REVIEW_IMAGE_NAME
  if OnboardioCommon.getIsDarkMode() then
    spriteName = REVIEW_DARK_MODE_IMAGE_NAME
  end
  local reviewImage = Sprite.newWithName(spriteName)
  reviewImage:setOpacity(0)
  table.insert(self.fadeableElements, reviewImage)

  layoutColumn:insert(reviewImage)
  layoutColumn:insertSpacer(0)
  layoutColumn:alignChildren()
  self:insertAtCenter(layoutColumn)

  self:addContinueButton()
end

-- Constructor ------------------------

function OnboardioPanelReviewProof.new()
  local self = OnboardioModernPanel.new()
  Mixin.mix(self, OnboardioPanelReviewProof)

  createLayout(self)

  return self
end
