--- OnboardioPanelTimeCommitment
-- @author Created by andrewcousins on September 02, 2024.

class("OnboardioPanelTimeCommitment")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BUTTON_DESCRIPTORS = {
  {
    text = Localizer.get("TIME_COMMITMENT_5_MINUTES"),
    id = 5
  },
  {
    text = Localizer.get("TIME_COMMITMENT_10_MINUTES"),
    id = 10
  },
  {
    text = Localizer.get("TIME_COMMITMENT_15_MINUTES"),
    id = 15
  },
  {
    text = Localizer.get("TIME_COMMITMENT_20_MINUTES"),
    id = 20
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getContinueCallback(questionAnsweredCallback)
  return function(self, answerID)
    OnboardioAnalytics.reportTimeCommitmentScreenAnswered(answerID)
    self:setDismissed()
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelTimeCommitment.new()
  local promptText = Localizer.get("TIME_COMMITMENT_PROMPT")
  local continueCallback = getContinueCallback(questionAnsweredCallback)
  local buttonDescriptors = BUTTON_DESCRIPTORS

  local self = OnboardioQuestionPanel.new(promptText, buttonDescriptors, continueCallback)
  Mixin.mix(self, OnboardioPanelTimeCommitment)

  return self
end
