--- OnboardioPersonalizationManager
-- @author Created by andrewcousins on April 16, 2024.

class("OnboardioPersonalizationManager")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local MOTIVATION_PROPERTY = "user_onboarding_motivation"
local ADHD_PROPERTY = "user_onboarding_adhd"
local HDYHAU_PROPERTY = "user_onboarding_hdyhau"


-- Singleton Instantiation ------------------------

local personalizationMap = {}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function saveProperty(propertyName, value)
  personalizationMap[propertyName] = value

  GameSession.personalizationMap = personalizationMap
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- All property values should be strings.

function OnboardioPersonalizationManager.saveMotivation(value)
  saveProperty(MOTIVATION_PROPERTY, value)
end

function OnboardioPersonalizationManager.saveADHD(value)
  saveProperty(ADHD_PROPERTY, value)
end

function OnboardioPersonalizationManager.saveHowDidYouHearAboutUs(value)
  saveProperty(HDYHAU_PROPERTY, value)
end
