--- OnboardioRoundSelfRate
-- @author Created by Aaron Barrett on October 09, 2014.

class("OnboardioRoundSelfRate")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioRoundSelfRate:getDivisionCount()
  return 1
end

function OnboardioRoundSelfRate:getIdentifier()
  return self.identifier
end

function OnboardioRoundSelfRate:getPrompt()
  return self.prompt
end

function OnboardioRoundSelfRate:getContributionSkillGroupIdentifier()
  return self.contributionSkillGroupIdentifier
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioRoundSelfRate.new(identifier, promptId, contributionSkillGroupIdentifier)
  local self = {}
  Mixin.mix(self, OnboardioRoundSelfRate)

  Asserts.assertType(identifier, "identifier", "string")
  Asserts.assertType(promptId, "promptId", "string")
  Asserts.assertType(contributionSkillGroupIdentifier, "contributionSkillGroupIdentifier", "string")

  self.identifier = identifier
  self.prompt = Localizer.get(promptId)
  self.contributionSkillGroupIdentifier = contributionSkillGroupIdentifier

  return self
end
