--- OnboardioOutroCommon
-- @author Created by karl on October 09, 2014.

class("OnboardioOutroCommon")
require("OnboardioCommon")
require("OnboardioButton")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TITLE_FONT = Font.new(OnboardioCommon.FONT_FACE_MEDIUM, 22)
local HEADER_FONT = Font.new(OnboardioCommon.FONT_FACE_BOLD, 13)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioOutroCommon.newButtonGroup(buttonText, onPressed, usePretestStyle)
  if usePretestStyle == nil then
    usePretestStyle = true
  end
  local button = OnboardioButton.newSkinny(buttonText, onPressed, usePretestStyle)
  local margin = (Screen.width - button:getWidth()) / 2
  local buttonCol = Column.new()
  buttonCol:insert(button)
  buttonCol:insertSpacer(margin)
  buttonCol:alignChildren()

  return buttonCol, button
end

function OnboardioOutroCommon.newTitle(title)
  local titleLabel = Label.new(title, TITLE_FONT)
  titleLabel:setColor(unpack(OnboardioCommon.COLOR_WHITE))
  return titleLabel
end

function OnboardioOutroCommon.newHeader(header)
  local headerLabel = Label.new(header, HEADER_FONT)
  headerLabel:setColor(unpack(OnboardioCommon.COLOR_OUTRO_TEXT))

  return headerLabel
end

function OnboardioOutroCommon.getSkillColor(skillName)
  return OnboardioCommon.SKILL_COLORS[string.lower(skillName)]
end

function OnboardioOutroCommon.inferSkillLevel(progress)
  return string.upper(PretestSession.getDisplayLevelFromIndex(progress))
end
