--- OnboardioPanelThankYou
-- @author Created by Aaron Barrett on February 10, 2015.

class("OnboardioPanelThankYou")

require("OnboardioPanel")
require("OnboardioOutroCommon")
require("OnboardioActivityDisplay")
require("OnboardioTextFactory")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local MESSAGE_KEY = "DETERMINING_SKILL"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function ensureThatLabelsDoNotFadeOut(self)
  self.fadableLabels = {}
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioPanelThankYou:usesHorizontalTransitionOut()
  return true
end

function OnboardioPanelThankYou:playAppear()
  return runInCoroutine(function()
      wait(self.activityDisplay:animate())

      ensureThatLabelsDoNotFadeOut(self)

      waitFor(0.8)
      self:setDismissed()
    end)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioPanelThankYou.new()
  local self = OnboardioPanel.new()
  Mixin.mix(self, OnboardioPanelThankYou)

  local separation = self:getWidthPart(0.1)

  local column = Column.new(separation)

  local fadableLabels = self.fadableLabels

  local thankYouLabel = OnboardioOutroCommon.newTitle(Localizer.get("THANK_YOU"))
  table.insert(fadableLabels, thankYouLabel)

  local activityDisplay = OnboardioActivityDisplay.new(self:getWidthPart(0.35), self:getWidthPart(0.008), OnboardioCommon.COLOR_BLUE)
  self.activityDisplay = activityDisplay
  table.insert(fadableLabels, activityDisplay)

  local message = Localizer.get(MESSAGE_KEY)
  local messageLabel = OnboardioTextFactory.newPlainTextView(message, OnboardioCommon.COLOR_OUTRO_TEXT)
  table.insert(fadableLabels, messageLabel)

  column:insert(activityDisplay)
  column:insert(thankYouLabel)
  column:insert(messageLabel)

  column:alignChildren()
  self:insertAtCenter(column)

  return self
end
