--- OnboardioIntroDescription
-- @author Created by karl on November 23, 2015.

class("OnboardioIntroDescription")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_TITLE = OnboardioCommon.COLOR_PROMPT_TEXT
local COLOR_DESCRIPTION = OnboardioCommon.COLOR_PROMPT_ADDITIONAL_TEXT

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioIntroDescription:getYLocationForDescription(panelHeight, canvasSize)
  local canvasY = panelHeight * OnboardioCommon.CAROUSEL_ANIMATION_RELATIVE_Y_POSITION
  local topOfDescription = canvasY - (canvasSize / 2)
  return topOfDescription - self:getHeightPart(0.5)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioIntroDescription.new(titleText, descriptionText, width)
  width = width or Screen.getWidthPart(0.85)

  local titleLabel = Label.new(titleText, Font.new(FontFaces.DIN_OT_MEDIUM, 24))
  titleLabel:setColor(unpack(COLOR_TITLE))

  local descriptionLabel = TextArea.new(descriptionText, Font.new(FontFaces.DIN_OT_MEDIUM, 18), width, Alignment.CENTER)
  descriptionLabel:setColor(unpack(COLOR_DESCRIPTION))

  local self = Column.new(titleLabel:getHeightPart(0.5))
  Mixin.mix(self, OnboardioIntroDescription)

  self:insert(titleLabel)
  self:insert(descriptionLabel)
  self:alignChildren()

  return self
end
