--- OnboardioIntroPanel1
-- @author Created by karl on November 20, 2015.

class("OnboardioIntroPanel1")
require("OnboardioCommon")
require("OnboardioTitleContent")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_SWIPE_LABEL = OnboardioCommon.COLOR_TABLE.ONBOARDING_TEXT_LIGHT

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioIntroPanel1:animateOnce()
  local contentAnimation = self.titleContent:getAnimation()
  return AHSequence.new(
    contentAnimation,
    AHDelayed.new(2, AHOpacityTo.new(self.swipeToBeginLabel, 1, nil, 1))
  ):start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioIntroPanel1.new()
  local self = FilledRectangle.newFullScreen({1, 1, 1})
  Mixin.mix(self, OnboardioIntroPanel1)

  self.titleContent = OnboardioTitleContent.new()
  self.titleContent:setLoc(self:getWidthPart(0.5), self:getHeightPart(0.55))
  self:insert(self.titleContent)

  local swipeToBeginLabel = Label.new(Localizer.get("SWIPE_BEGIN"), Font.new(FontFaces.DIN_OT_MEDIUM, 14))
  swipeToBeginLabel:setColor(unpack(COLOR_SWIPE_LABEL))
  local swipeToBeginLabelY = math.max(self:getHeightPart(0.1), swipeToBeginLabel:getHeightPart(0.5) + Screen.safeBottom)
  swipeToBeginLabel:setLoc(self:getWidthPart(0.5), swipeToBeginLabelY)
  self:insert(swipeToBeginLabel)

  swipeToBeginLabel:setOpacity(0)
  self:linkColorAttrToChildren()
  self.swipeToBeginLabel = swipeToBeginLabel

  return self
end
