--- OnboardioIntroPanel5
-- @author Created by karl on November 23, 2015.

class("OnboardioIntroPanel5")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_TITLE = OnboardioCommon.COLOR_PROMPT_TEXT
local COLOR_BACKGROUND = OnboardioCommon.COLOR_BACKGROUND

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioIntroPanel5:getSlideInAction()
  local spawn = AHSpawn.new()
  for _, icon in ipairs(self.icons) do
    spawn:addAction(AHLocationXBy.new(icon, 1, nil, -Screen.width))
  end
  return spawn
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioIntroPanel5.new(icons, onComplete, width, height)
  local self = FilledRectangle.new(width, height, COLOR_BACKGROUND)
  Mixin.mix(self, OnboardioIntroPanel5)

  local column = Column.new()
  self:insertAtCenter(column)
  local label = TextArea.new(Localizer.get("BEFORE_WE_BEGIN"), Font.new(FontFaces.DIN_OT_MEDIUM, 22), Screen.getWidthPart(0.8), Alignment.CENTER)
  label:setColor(unpack(COLOR_TITLE))
  column:insert(label)
  column:insertSpacer(Screen.getHeightPart(0.05))

  local buttons = nil
  buttons = OnboardioButton.newSkinny(Localizer.get("CONTINUE"), function() onComplete(buttons) end)
  column:insert(buttons)
  column:alignChildren()

  buttons:inheritOpacity(column)
  label:inheritOpacity(column)
  column:inheritOpacity(self)

  self.icons = icons

  return self
end
