--- OnboardioSkillButtonBar
-- @author Created by karl on November 11, 2015.

class("OnboardioSkillButtonBar")

require("OnboardioSkillButton")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function handleButtonPress(self, answer)
  self.onAnswerSelected(answer)
end

local function onYesPressed(self)
  handleButtonPress(self, true)
end

local function onNoPressed(self)
  handleButtonPress(self, false)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioSkillButtonBar:getNoButton()
  return self.noButton
end

function OnboardioSkillButtonBar:getYesButton()
  return self.yesButton
end

function OnboardioSkillButtonBar:setTouchEnabled(touchEnabled)
  self.noButton:setTouchEnabled(touchEnabled)
  self.yesButton:setTouchEnabled(touchEnabled)
end

function OnboardioSkillButtonBar:fadeIn()
  self.noButton:fadeIn()
  self.yesButton:fadeIn()
end

function OnboardioSkillButtonBar:fadeOut()
  self.noButton:fadeOut()
  self.yesButton:fadeOut()
end

function OnboardioSkillButtonBar:setVisible(isVisible)
  self.noButton:setVisible(isVisible)
  self.yesButton:setVisible(isVisible)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioSkillButtonBar.new(onAnswerSelected)
  local self = Row.new()
  Mixin.mix(self, OnboardioSkillButtonBar)

  self:setWidth(Screen.getWidthPart(0.8))

  self.noButton = OnboardioSkillButton.newButtonWithCross(Localizer.get("NO"), function() onNoPressed(self) end)
  self.yesButton = OnboardioSkillButton.newButtonWithCheckmark(Localizer.get("YES"), function() onYesPressed(self) end)

  self:insert(self.noButton)
  self:insert(self.yesButton)
  self:alignChildren()

  self.onAnswerSelected = onAnswerSelected

  return self
end
