--- OnboardioSkillHexagon
-- @author Created by karl on November 24, 2015.

class("OnboardioSkillHexagon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_INERT = ColorUtils.colorHex24ToStd(0xe0e3f0)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function OnboardioSkillHexagon:createFadeColorAction(duration, ease, opacity)
  return AHOpacityTo.new(self.colorHexagon, duration, ease, opacity)
end

function OnboardioSkillHexagon:createFadeIconColorAction(duration, ease, opacity)
  return self:createFadeColorAction(duration, ease, opacity)
end

function OnboardioSkillHexagon:reset()
  self.colorHexagon:setOpacity(0)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function OnboardioSkillHexagon.new(radius, color)
  local sideCount = 6
  local startAngle = math.pi * 0.5
  local roundingRadius = radius * 0.3
  local self = FilledRoundedRegularPolygon.new(radius, sideCount, startAngle, roundingRadius, COLOR_INERT)
  Mixin.mix(self, OnboardioSkillHexagon)

  self.colorHexagon = FilledRoundedRegularPolygon.new(radius, sideCount, startAngle, roundingRadius, color)
  self.colorHexagon:setOpacity(0)

  self:insertAtCenter(self.colorHexagon)

  return self
end
