--- OnboardioPanelAudioSection
-- @author Created by Aaron Barrett on October 09, 2014.

class("OnboardioPanelAudioSection")
require("OnboardioTextFactory")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local AUDIO_SECTION_MESSAGE = Localizer.get("AUDIO_MESSAGE")

local CONTINUE_BUTTON_TEXT = Localizer.get("OKAY")

local Z_MESSAGE_LABEL = 10
local Z_BUTTON = 20

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function buildMessageLabel(self)
  local fadableLabels = self.fadableLabels

  local color = OnboardioCommon.COLOR_BLACK
  local fontSize = 22
  local textView = OnboardioTextFactory.newPlainTextView(AUDIO_SECTION_MESSAGE, color, fontSize, OnboardioCommon.TEXT_WIDTH)
  textView:setLoc(self:getWidthPart(0.5), self:getHeightPart(0.6))
  self:insert(textView, Z_MESSAGE_LABEL)

  table.insert(fadableLabels, textView)
end

local function buildButtons(self)
  local buttons = self.buttons
  local stationaryButtons = self.stationaryButtons

  local function onChoseSkipCallback()
    local shouldSkip = true
    self.selectedAnswer = shouldSkip

    self:setDismissed()
  end

  local continueButton = OnboardioButton.newSkinny(CONTINUE_BUTTON_TEXT, onChoseSkipCallback)
  continueButton:setLoc(self:getWidthPart(0.5), self:getHeightPart(0.45))
  self:insert(continueButton, Z_BUTTON)
  table.insert(buttons, continueButton)
  table.insert(stationaryButtons, continueButton)
end

-- Constructor ------------------------

function OnboardioPanelAudioSection.new()
  local self = OnboardioPanel.new()
  Mixin.mix(self, OnboardioPanelAudioSection)

  buildMessageLabel(self)
  buildButtons(self)

  return self
end
