--- OnboardioViewTransitioner
-- @author Created by Aaron Barrett on November 10, 2014.

class("OnboardioViewTransitioner")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- Play Stationary Transitions --------

function OnboardioViewTransitioner.playStationaryTransitionInOnView(view, perspectiveDistance)
  local appearDuration = 0.5

  local moveScaleEase = AHEaseElasticOut.new(0.65)
  local fadeInEase = AHEaseSimpleOut.new(4.0)

  AHLocationYBy.new(view, appearDuration, moveScaleEase, perspectiveDistance):start()
  AHScaleTo.new(view, appearDuration, moveScaleEase, 1.0):start()
  AHOpacityTo.new(view, appearDuration, fadeInEase, 1.0):start()
end

function OnboardioViewTransitioner.playStationaryTransitionOutOnView(view, perspectiveDistance, wasPressed)
  local scaleDownAmount = 0.75

  if (wasPressed) then
    scaleDownAmount = 0.25
  end

  local disappearDuration = 0.15
  local fadeOutDuration = disappearDuration * 0.67

  local ease = AHEaseSimpleIn.new(2.0)

  AHLocationYBy.new(view, disappearDuration, ease, -perspectiveDistance):start()
  AHOpacityTo.new(view, fadeOutDuration, nil, 0.0):start()
  AHScaleTo.new(view, disappearDuration, ease, scaleDownAmount):start()

  -- Attribute links don't always propogate, so sometimes a view that is supposed to have
  -- opacity 0.0 at the end of the fade is still visible.  To get around this, remove the view.
  AHDelayed.new(
                fadeOutDuration,
                AHRemove.new(view)
                ):start()
end
