--- OrbitColors
-- @author Created by Alexey Chernikov

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

BACKGROUND_COLOR = {0.03, 0.02, 0.07}
UI_COMPONENTS_COLOR = {1, 1, 1, 0.5}
FLOATER_TEXT_COLOR = {0.68, 0.65, 0.93}

-- PURPLE
LAYER_COLORS_1 = {
  {0.91, 0.64, 0.98, 1.0},
  {0.67, 0.38, 0.78, 1.0},
  {0.4, 0.21, 0.53, 1.0},
  {0.2, 0.1, 0.35, 1.0},
  {0.09, 0.05, 0.24, 1.0}
}
-- BLUE
LAYER_COLORS_2 = {
  {0.62, 0.73, 0.85, 1.0},
  {0.24, 0.37, 0.55, 1.0},
  {0.16, 0.25, 0.45, 1.0},
  {0.1, 0.14, 0.35, 1.0},
  {0.06, 0.05, 0.24, 1.0}
}
-- PINK
LAYER_COLORS_3 = {
  {0.98, 0.63, 0.86, 1.0},
  {0.78, 0.32, 0.67, 1.0},
  {0.59, 0.22, 0.5, 1.0},
  {0.36, 0.1, 0.35, 1.0},
  {0.19, 0.05, 0.22, 1.0},
}

WRONG_ANSWER_LAYER_COLORS = {
  {1.0, 0.57, 0.69},
  {0.91, 0.09, 0.36},
  {0.67, 0.0, 0.23},
  {0.42, 0.04, 0.12},
  {0.3, 0.01, 0.07}
}

COMPLETE_LAYER_COLORS = {
  {0.49, 0.98, 0.79},
  {0.07, 0.68, 0.54},
  {0.0, 0.48, 0.41},
  {0.0, 0.3, 0.28},
  {0.0, 0.21, 0.21},
  {0.0, 0.14, 0.15}
}

BONUS_ROUND_STROBE_EFFECT_COLORS = {
  LAYER_COLORS_1[1],
  LAYER_COLORS_2[1],
  LAYER_COLORS_3[1]
}

LAST_BONUS_TEXT_STROBE_COLOR = {0.96, 0.68, 0.85}

CIRCLE_QUALITY = 128


---------------------------- INTRO COLORS -----------
PLEASE_ENABLE_AUDIO_STROBE_COLORS = {
  {0.98, 0.63, 0.86},
  {0.91, 0.63, 0.98},
  {0.77, 0.63, 0.98},
  {0.63, 0.73, 0.98},
  {0.63, 0.94, 0.98},
  {0.63, 0.98, 0.77}
}

TAP_TO_CONTINUE_STROBE_COLORS = {
  {0.91, 0.63, 0.98},
  {0.77, 0.63, 0.98},
  {0.63, 0.73, 0.98},
  {0.63, 0.94, 0.98},
  {0.63, 0.98, 0.77},
  {0.98, 0.63, 0.86}
}

TAP_TO_CONTINUE_COLOR = {0.91, 0.63, 0.98}
AUDIO_ICON_COLOR = TAP_TO_CONTINUE_COLOR
-----------------------------------------------------


local function makeArrayOfPermutations(initialArray, numberOfPermutations)
  local arrayOfPermutations = {}
  for i = 1, numberOfPermutations do
    local currentPermutation = {}
    for offset = 1, #initialArray do
      local indexInPermutation = (i + offset - 1) % #initialArray + 1
      table.insert(currentPermutation, initialArray[indexInPermutation])
    end
    table.insert(arrayOfPermutations, currentPermutation)
  end
  table.insert(arrayOfPermutations, initialArray)
  return arrayOfPermutations
end

local function makeStrobeColorSet(iteratedColorSets, finalSet)
  local result = {}
  for strobeIndex = 0, 1 do
    for i = #iteratedColorSets - strobeIndex, 1 + strobeIndex, -1 do
      table.insert(result, iteratedColorSets[i])
    end
  end
  table.insert(result, finalSet)
  return result
end

local ITERATED_COMPLETE_LAYER_COLOR_SETS = makeArrayOfPermutations(COMPLETE_LAYER_COLORS, #COMPLETE_LAYER_COLORS)
COMPLETE_LAYER_STROBE_COLOR_SETS = makeStrobeColorSet(ITERATED_COMPLETE_LAYER_COLOR_SETS, COMPLETE_LAYER_COLORS)
