--- ParticleWithGlow
-- @author Created by Alexey Chernikov

class("ParticleWithGlow")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getGlowColor(color)
  local r, g, b, a = unpack(color)
  a = a or 1
  return r, g, b, a * 0.5
end

local function newCircle(color, radius, isStroke)
  if isStroke then
    return HollowCircle.new(color, radius)
  else
    return FilledCircle.new(color, radius)
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ParticleWithGlow.new(color, radius)
  local diameter = radius * 2.0
  local self = Group.new(diameter, diameter)
  Mixin.mix(self, ParticleWithGlow)

  local isStroke = math.random() < 0.3
  local hasGlow = not isStroke and math.random() < 0.5

  local view = newCircle(radius, color, isStroke)

  if (hasGlow) then
    local glow = newCircle(diameter, nil, isStroke)
    glow:setColor(getGlowColor(color))
    self:insertAtCenter(glow)
  end
  self:insertAtCenter(view)

  return self
end
