--- LayerView
-- @author Created by Alexey Chernikov

class("LayerView")

require("scene.text.CircularText")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WHITE = {1, 1, 1, 1}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function LayerView:setText(text, font)
  local textView = CircularText.new(text, font, self.radius - font:getActualSize() / 2.0)
  self:insertAtCenter(textView)
  self.textView = textView
end

function LayerView:getSizeInDegrees()
  return math.deg(self.textView:getAngularSizeInRadians())
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self, radius, color)
  local view = FilledCircle.new(radius, WHITE)
  self:insertAtCenter(view)
  self.view = view
  view:setAttrLink(MOAIColor.INHERIT_COLOR, self, MOAIColor.COLOR_TRAIT)
  self:setColor(unpack(color))
end

-- Constructor ------------------------

function LayerView.new(radius, color)
  local diameter = radius * 2.0
  local self = Group.new(diameter, diameter)
  Mixin.mix(self, LayerView)
  createLayout(self, radius, color)
  self.radius = radius
  return self
end
