--- ParagraphsCommon
-- @author Created by Steven Mah on March 31, 2017

class("ParagraphsCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

ParagraphsCommon.QUESTION_TYPES = {
  REPLACE = "replace",
  COMBINE = "combine",
  MOVE = "move"
}

ParagraphsCommon.QUESTION_ORDER = {
  ParagraphsCommon.QUESTION_TYPES.REPLACE,
  ParagraphsCommon.QUESTION_TYPES.COMBINE,
  ParagraphsCommon.QUESTION_TYPES.MOVE
}

ParagraphsCommon.MENU_BUTTON_STYLES_BY_QUESTION_TYPE =
{
  [ParagraphsCommon.QUESTION_TYPES.REPLACE] =
  {
    color = { 0.55, 0.37, 0.83 },
    iconName = "replace_icon.png"
  },
  [ParagraphsCommon.QUESTION_TYPES.MOVE] =
  {
    color = { 0.78, 0.41, 0.78 },
    iconName = "move_icon.png"
  },
  [ParagraphsCommon.QUESTION_TYPES.COMBINE] =
  {
    color = { 0.68, 0.36, 0.83 },
    iconName = "combine_icon.png"
  }
}

ParagraphsCommon.ACTIVE_QUESTION_HEIGHT = Screen.getSafeY(0.4)
ParagraphsCommon.ACTIVE_MOVE_QUESTION_HEIGHT = Screen.getSafeY(0.16)
ParagraphsCommon.QUESTION_MENU_HEIGHT = Screen.getSafeY(0.12)

ParagraphsCommon.PASSAGE_MARGIN_HEIGHT = (Screen.fullHeight - Screen.safeTop) + 50

ParagraphsCommon.PASSAGE_TEXT_COLOR = {0.3, 0.3, 0.3}

ParagraphsCommon.TEXT_MOVE_DURATION = 0.5
ParagraphsCommon.FADE_DURATION = 0.25
