--- ParagraphsTextModel
-- @author Created by Steven Mah on April 3, 2017

class("ParagraphsTextModel")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function transactionEnded(self, shouldAddHighlights)
  assert(not self.transactionInProgress, "Transaction is still in progress")
  for _, listener in ipairs(self.listeners) do
    listener:transactionEnded(shouldAddHighlights)
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function ParagraphsTextModel:getItemsAndIndicesWithAttributes(attribute, value)
  local items = {}
  local indices = {}

  for index, item in ipairs(self.items) do
    if item:hasAttribute(attribute) and (item:getAttribute(attribute) == value or value == nil) then
      table.insert(items, item)
      table.insert(indices, index)
    end
  end

  return items, indices
end

function ParagraphsTextModel:endTransaction(shouldAddHighlights)
  assert(self.transactionInProgress, "Transaction not in progress")
  self.transactionInProgress = false
  transactionEnded(self, shouldAddHighlights)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function ParagraphsTextModel.new(items)
  local self = TextModel.new(items)
  Mixin.mix(self, ParagraphsTextModel)

  return self
end
