--- PercentagesCentralSubmitButton
-- @author Created by andrewcousins on November 29, 2022.

class("PercentagesCentralSubmitButton")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WIDTH = Screen.getSafeWidthPart(0.65)
local HEIGHT = WIDTH * 0.65

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PercentagesCentralSubmitButton:attachInputField(inputField)
  self.inputField = inputField
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function configureInput(self)
  function onSubmit()
    runInCoroutine(function()
      if (self.onSubmitCallback ~= nil) then
        local fieldValue = tonumber(self.inputField:getValue())
        self.onSubmitCallback(fieldValue)
      end
    end)
  end
  Button.makeButton(self, onSubmit)
  self:setTouchEnabled(false)
end

-- Constructor ------------------------

function PercentagesCentralSubmitButton.new(onSubmitCallback)
  local self = Group.new(WIDTH, HEIGHT)
  Mixin.mix(self, PercentagesCentralSubmitButton)

  self.onSubmitCallback = onSubmitCallback
  self.inputField = nil

  configureInput(self)

  return self
end