--- PercentagesCommon
-- @author Created by Jay Austria on May 5, 2015.

class("PercentagesCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------
PercentagesCommon.BACKGROUND_COLOR_TOP = ColorUtils.colorRGBToStd(100, 40, 78)
PercentagesCommon.BACKGROUND_COLOR_BOTTOM = ColorUtils.colorRGBToStd(140, 40, 79)
PercentagesCommon.BACKGROUND_COLOR_TOP_GREEN = ColorUtils.colorHex24ToStd(0x176e69)
PercentagesCommon.BACKGROUND_COLOR_BOTTOM_GREEN = ColorUtils.colorHex24ToStd(0x85d1a3)

PercentagesCommon.INVISIBLE_OPACITY = 0.0
PercentagesCommon.VISIBLE_OPACITY = 1.0
PercentagesCommon.INPUT_FIELD_FONT_SIZE = 60
PercentagesCommon.COLOR =
{
  WHITE = ColorUtils.colorHex24ToStd(0xffffff),
  BLACK = ColorUtils.colorHex24ToStd(0x000000),
  INCORRECT_RED = ColorUtils.colorHex24ToStd(0xff5fa0),
  CORRECT_GREEN = ColorUtils.colorHex24ToStd(0xbdffe3)
}

local KNOWN_TARGET_HEIGHT = 667 -- from iPhone 6

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PercentagesCommon.getScaledFontSize(size)
  local screenScale = Screen.fullHeight / KNOWN_TARGET_HEIGHT
  local adjustedFontSize = size * screenScale

  return MathUtils.round(adjustedFontSize)
end

function PercentagesCommon.playValidInputSound()
  Sound.playSoundEffect("light_pop")
end

function PercentagesCommon.playInvalidInputSound()
  Sound.playSoundEffect("shared_keytap")
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
