--- PercentagesRoundIndicator
-- @author Created by Jay Austria on May 5, 2015.

class("PercentagesRoundIndicator")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local INITIAL_ROUND_INDEX = 1

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getRoundString(round, max)
  return string.format(Localizer.get("ROUND"), round, max)
end

local function setRoundNumber(self)
  local indicatorString = getRoundString(self.currentRound, self.roundCount)
  self.indicatorLabel:setText(indicatorString)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PercentagesRoundIndicator:incrementRound(round)
  self.currentRound = self.currentRound + 1

  setRoundNumber(self)
end

function PercentagesRoundIndicator:getRound()
  return self.currentRound
end


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function PercentagesRoundIndicator.new(roundCount)
  local initialLabelString = getRoundString(INITIAL_ROUND_INDEX, roundCount)
  local indicatorLabel = Label.new(initialLabelString, Font.new(FontFaces.DIN_OT_MEDIUM, 16))

  -- Create group from dimensions of an initialized label so StandardUIBuilder can
  -- align properly for intro play in
  local self = Group.new(indicatorLabel:getDims())
  Mixin.mix(self, PercentagesRoundIndicator)

  self:insertAtCenter(indicatorLabel)
  self.indicatorLabel = indicatorLabel
  self.currentRound = INITIAL_ROUND_INDEX
  self.roundCount = roundCount

  self:linkOpacityAttrToChildren()

  return self
end
