--- PercentagesShape
-- @author Created by Jay Austria on May 14, 2015.

class("PercentagesShape")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

PercentagesShape.GROUP_WIDTH = 70
PercentagesShape.GROUP_HEIGHT = 70
PercentagesShape.Types =
{
  CIRCLE = "shape_1.png",
  SQUARE = "shape_2.png",
  TRIANGLE = "shape_3.png"
}

PercentagesShape.START_COLOR = ColorUtils.colorHex24ToStd(0xff9887)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createLayout(self, shapeType)
  local filename = PercentagesShape.Types[shapeType]
  local shape = Sprite.newWithName(filename)
  self:insertAtCenter(shape)
  self.shape = shape

  self:linkOpacityAttrToChildren()
  self:linkColorAttrToChildren(true)

  self:setColor(unpack(PercentagesShape.START_COLOR))
end

local function getColorAction(self, color)
  local colorAction = AHColorTo.new(self, 0.3, nil, color)
  return colorAction
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PercentagesShape:getShowAsCorrectAction()
  return getColorAction(self, PercentagesCommon.COLOR.CORRECT_GREEN)
end

function PercentagesShape:getShowAsIncorrectAction()
  return getColorAction(self, PercentagesCommon.COLOR.INCORRECT_RED)
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function PercentagesShape.new(shapeType)
  shapeType = shapeType or "CIRCLE"

  local testSprite = Sprite.newWithName("shape_1.png")
  local self = Group.new(testSprite:getDims())
  Mixin.mix(self, PercentagesShape)

  createLayout(self, shapeType)

  return self
end
