---- pounceGame
-- @author Template created by Aaron Barrett on September 27, 2013.

class("PounceGame")

require("scene.PounceScene")
require("scene.PounceInterface")
require("game.PounceConfiguration")
require("game.PounceGameManager")

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- gameFlow ---------------------------

function PounceGame:gameFlow()
   self.gameManager:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function configureGameDifficulty(self)
  self.gameManager:configureGameDifficulty(self)
end

local function createGameElements(self)
  local gameManager = PounceGameManager.new()
  local callbacks = gameManager:getCallBacks()

  local scene = PounceScene.new(self, callbacks)
  self:insertAtCenter(scene)

  local ui = PounceInterface.new(self:getUIOverlay(), scene.progressIndicator)
  gameManager:setUI(ui)
  gameManager:setScene(scene)

  self.gameManager = gameManager
end

-- Constructor ------------------------

function PounceGame.new()
  local self = BaseGame.new()
  Mixin.mix(self, PounceGame)

  createGameElements(self)

  configureGameDifficulty(self)

  return self
end
