class("StalkDescriptors")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

StalkDescriptors.STALK_THICKNESS = 7

local STALK_PARAM_SETS =
{
  ------------------------- Set 1 ---------------------------
  {
    { -- bottom left
      length = Screen.height * 0.25,
      x = Screen.width * 0.17,
      y = Screen.height * 0.5,
      z = 1,
      curvature = 20,
      colorIndex = 1,
      boxType = 1,
      overlay = true
    },
    { -- top left
      length = Screen.height * 0.25,
      x = Screen.width * 0.30,
      y = Screen.height * 0.50,
      z = 0,
      curvature = 10,
      colorIndex = 4,
      rotation = 180,
      boxType = 2,
      overlay = true
    },
    { -- top right
      length = Screen.height * 0.22,
      x = Screen.width * 0.8,
      y = Screen.height * 0.50,
      z = 2,
      curvature = 10,
      colorIndex = 2,
      rotation = 180,
      boxType = 3,
      overlay = true
    },
    { -- bottom right
      length = Screen.width * 0.26,
      x = Screen.width * 1.02,
      y = Screen.height * -0.265,
      z = 3,
      curvature = -10,
      colorIndex = 3,
      rotation = 90,
      boxType = 2,
      overlay = true
    },
    { -- bottom middle
      length = Screen.height * 0.21,
      x = Screen.width * 0.57,
      y = Screen.height * 0.45,
      z = 4,
      curvature = -20,
      colorIndex = 2,
      boxType = 1,
      overlay = true
    }
  },
  ------------------------- Set 2 ---------------------------
  {
    { -- top right
      length = Screen.width * 0.26,
      x = Screen.width,
      y = Screen.height * 0.35,
      z = 1,
      curvature = 20,
      colorIndex = 2,
      rotation = 80,
      middleYOffset = 20,
      boxType = 2
    },
    { -- top left
      length = Screen.width * 0.33,
      x = Screen.width * -0.05,
      y = Screen.height * 1.33,
      z = 2,
      curvature = -20,
      colorIndex = 1,
      rotation = 280,
      middleYOffset = 0,
      topXOffset = 0,
      boxType = 1,
      overlay = true
    },
    { -- middle left
      length = Screen.height * 0.19,
      x = Screen.width * 0.34,
      y = Screen.height * -0.04,
      z = 2,
      curvature = -10,
      colorIndex = 1,
      rotation = 180,
      topXOffset = 0,
      boxType = 1
    },
    { -- middle right
      length = Screen.height * 0.21,
      x = Screen.width * 0.78,
      y = Screen.height * -0.04,
      z = 3,
      curvature = 13,
      colorIndex = 3,
      rotation = 180,
      boxType = 3
    },
    { -- bottom
      length = Screen.height * 0.14,
      x = Screen.width * 0.44,
      y = Screen.height * 0.50,
      z = 0,
      curvature = 20,
      colorIndex = 2,
      rotation = 0
    }
  },
  ------------------------- Set 3 ---------------------------
  {
    { -- top left
      length = Screen.width * 0.33,
      x = Screen.width * 0.01 ,
      y = Screen.height * 1.06,
      z = 1,
      curvature = -10,
      colorIndex = 1,
      rotation = 240,
      boxType = 2,
      overlay = true
    },
    { -- top right
      length = Screen.width * 0.33,
      x = Screen.width * 1.04,
      y = Screen.height * 0.10,
      z = 2,
      curvature = 10,
      colorIndex = 2,
      rotation = 120,
      boxType = 1,
      overlay = true
    },
    { -- middle left
      length = Screen.width * 0.31,
      x = Screen.width * -0.05,
      y = Screen.height * 0.90,
      z = 3,
      curvature = 20,
      colorIndex = 2,
      rotation = -45,
      boxType = 2,
      overlay = true
    },
    { -- bottom middle
      length = Screen.height * 0.16,
      x = Screen.width * 0.54,
      y = Screen.height * 0.5,
      z = 13,
      curvature = 10,
      colorIndex = 3,
      boxType = 1,
      overlay = true
    },
    { -- middle right
      length = Screen.width * 0.33,
      x = Screen.width * 1.05,
      y = Screen.height * -0.32,
      z = 2,
      curvature = -10,
      colorIndex = 1,
      rotation = 120,
      boxType = 2,
      overlay = true
    }
  },
  ------------------------- Set 4 ---------------------------
  {
    { -- top left
      length = Screen.height * 0.21,
      x = Screen.width * 0.29,
      y = Screen.height * 0.50,
      z = 0,
      curvature = 10,
      colorIndex = 1,
      rotation = 180,
      boxType = 1,
      overlay = true

    },
    { -- top right
      length = Screen.height * 0.16,
      x = Screen.width * 0.68,
      y = Screen.height + Screen.height/8 - Screen.height/16 + 20,
      z = 2,
      curvature = 0,
      colorIndex = 3,
      boxType = 2
    },
    { -- bottom left
      length = Screen.height * 0.135,
      x = Screen.width * 0.29,
      y = Screen.height * -0.09,
      z = 3,
      curvature = 0,
      colorIndex = 2,
      rotation = 180,
      boxType = 2
    },
    { -- bottom middle
      length = Screen.height * 0.28,
      x = Screen.width * 0.60,
      y = Screen.height * -0.09,
      z = 2,
      curvature = 0,
      colorIndex = 1,
      rotation = 180
    },
    { -- bottom right
      length = Screen.height * 0.29,
      x = Screen.width * 0.76,
      y = Screen.height * 0.50,
      z = 3,
      curvature = 10,
      colorIndex = 3,
      boxType = 3,
      overlay = true
    }
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function StalkDescriptors.getRandomLayoutSet()
  local layoutSetIndex = math.random(#STALK_PARAM_SETS)
  return STALK_PARAM_SETS[layoutSetIndex]
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
