class("BeanStalkWobbleAnimation")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getAnimationFunction(self)
  local xPhaseShift = math.random()
  local yPhaseShift = xPhaseShift--math.random()
  local xAmp = 2
  local yAmp = 2
  local startAngle = self.beanStalk:getLastSegmentAngle()
  return function(t)
    --xPhaseShift = xPhaseShift + math.random()/10
    --yPhaseShift = yPhaseShift + math.random()/10
    --local dx = math.sin((t + xPhaseShift) * math.pi * 2) * xAmp
    --local dy = math.cos((t + yPhaseShift) * math.pi * 2) * yAmp  * t
    local dx = (t + t * xPhaseShift) * xAmp/2 - xAmp/2
    local dy = (-t + t * yPhaseShift) * yAmp/2 - yAmp/2
    self.currentPoints[3][1] = self.targetPoints[3][1] + dx
    self.currentPoints[3][2] = self.targetPoints[3][2] + dy
    self.currentPoints[2][1] = self.targetPoints[2][1] - dx/2
    self.beanStalk:setPointLocations(self.currentPoints)
    local rotation = self.beanStalk:getLastSegmentAngle() - startAngle
    rotation = rotation
    self.beanStalk:setAttachmentRotation(math.deg(rotation))
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function BeanStalkWobbleAnimation:start(animationTime, completeHandler)
  animationTime = animationTime or 5
  local animation = PounceAnimation.cycle(animationTime, self.animationFunction, completeHandler)
  self.animation = animation
  return animation
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function BeanStalkWobbleAnimation.new(beanStalk)
  local self = BeanStalkAnimation.new()
  Mixin.mix(self, BeanStalkWobbleAnimation)

  self.currentPoints = beanStalk:getPoints()
  self.targetPoints = TableUtils.deepCopy(self.currentPoints)

  self.beanStalk = beanStalk
  self.animationFunction = getAnimationFunction(self)

  return self
end
