class("Hexagon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createNGonPoints(n, r)
  local angle = 0
  local dAngle = 2 * math.pi/n
  local points = {}
  for i = 1, n + 1 do
    local x = math.cos(angle) * r
    local y = math.sin(angle) * r
    points[i] = {x, y}
    angle = angle + dAngle
  end
  return points
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function Hexagon.new(r, w)
  local points = createNGonPoints(6, r)
  local self = Line.new(points)
  self:setWidth(w)
  return self
end
