--- PronunciationConceptGenerator
-- @author Created by Jay Austria on July 03, 2023.

class("PronunciationConceptGenerator")

require("PronunciationConfiguration")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getDifficultyNameChooser()
  local difficultyKeyFrames = PronunciationConfiguration.getDifficultyKeyFrames()
  local difficultyNameChooser = KeyFrameInterpolator.new(difficultyKeyFrames, GameSession.getDifficulty())

  return difficultyNameChooser
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PronunciationConceptGenerator:next()
  local concept = self.conceptGenerator:next()

  return concept
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function PronunciationConceptGenerator.new()
  local self = {}
  Mixin.mix(self, PronunciationConceptGenerator)

  self.conceptGenerator = GameSession.conceptGenerator
  self.conceptGenerator:setDifficultyNameChooser(getDifficultyNameChooser())

  return self
end
