--- PronunciationEndSequence
-- @author Created by karl on August 02, 2014.

class("PronunciationEndSequence")
require("PronunciationCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PronunciationEndSequence:play()
  return runInCoroutine(function()
    local selfW, selfH = self:getDims()
    local animation = Animation.newWithPrefix("ending/ending_half_")

    local topHalf = animation:createSpriteFromFrame(1)
    topHalf:setScl(0)
    topHalf:setAnchorPointBottom()
    self:insertAtCenter(topHalf)

    local bottomHalf = animation:createSpriteFromFrame(1)
    bottomHalf:setScl(0)
    bottomHalf:setAnchorPointBottom()
    self:insertAtCenter(bottomHalf)

    local check = Sprite.newWithName("check.png")
    check:setScl(0)
    self:insertAtCenter(check)

    local scaleDuration = 0.3
    local scaleEase = AHEaseSineInOut.new()
    local scaleX, scaleY = topHalf:scaleForEffectiveDims(selfW, selfH/2)
    local scaleAction = AHSpawn.new(
      AHScaleTo.new(check, scaleDuration, scaleEase, 1),
      AHScaleTo.new(topHalf, scaleDuration, scaleEase, scaleX, scaleY),
      AHScaleTo.new(bottomHalf, scaleDuration, scaleEase, scaleX, -scaleY)
    )

    scaleAction:start()

    waitFor(0.16)

    local animAction = AHSpawn.new(
      AHAnimate.new(topHalf, animation, 30),
      AHAnimate.new(bottomHalf, animation, 30)
    )

    animAction:start()

    waitFor(1.5)

    local fadeAction = AHOpacityTo.new(check, 0.9, nil, 0)
    wait(fadeAction:start())
  end)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function PronunciationEndSequence.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, PronunciationEndSequence)

  return self
end
