--- PronunciationValidator
-- @author Created by karl on July 15, 2014.
-- ConceptValidator for Pronunciation.

class("PronunciationValidator")

require("validators.ConceptValidator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_KEYS = {
  "definition",
  "word",
  "phonetic",
  "incorrect_phonetic",
  "audio_correct_link",
  "audio_incorrect_link",
  "report_title"
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function validateSoundFilenames(self, concept)
  local correctFilename = concept.audio_correct_link:lower()
  local incorrectFilename = concept.audio_incorrect_link:lower()
  local word = concept.word:lower()
  word = word:gsub(" ", "_")

  self:expectStringContains(correctFilename, word)
  self:expectStringContains(correctFilename, "correct")
  self:expectStringContains(incorrectFilename, word)
  self:expectStringContains(incorrectFilename, "incorrect")
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PronunciationValidator:validateConcept(concept)
  self:validateRequiredKeys(concept, REQUIRED_KEYS)

  validateSoundFilenames(self, concept)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function PronunciationValidator.new()
  local self = ConceptValidator.new()
  Mixin.mix(self, PronunciationValidator)

  return self
end
