class("PunctuationAnswerReactionNegative")
require("PunctuationColors")
require("PunctuationAnswerReaction")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PunctuationAnswerReactionNegative:reset()
  self.innerCircle:setScl(1)
  self.outerCircle:setScl(1)
  self:setOpacity(1)
end

function PunctuationAnswerReactionNegative:createReactionAnimation(seconds)
  seconds = seconds or 0.9
  local innerCircle = self.innerCircle
  local outerCircle = self.outerCircle

  local innerScaleUpDuration = seconds * 0.4
  local innerScaleDownDuration = seconds * 0.4
  local outerScaleUpDuration = seconds * 0.5
  local outerScaleDownDuration = seconds * 0.5
  local fadeOutDelay = outerScaleDownDuration
  local fadeOutDuration = seconds - fadeOutDelay

  local innerScaleUpAmount = 1.2
  local outerScaleUpAmount = 2
  local innerScaleDownAmount = 0.8
  local outerScaleDownAmount = 0.2

  local scaleInnerUp = AHScaleTo.new(innerCircle, innerScaleUpDuration, nil, innerScaleUpAmount)
  local scaleInnerDown = AHScaleTo.new(innerCircle, innerScaleDownDuration, nil, innerScaleDownAmount)
  local innerAnimation = AHSequence.new(scaleInnerUp, scaleInnerDown)

  local outerScaleUp = AHScaleTo.new(outerCircle, outerScaleUpDuration, nil, outerScaleUpAmount)
  local outerScaleDown = AHScaleTo.new(outerCircle, outerScaleDownDuration, nil, outerScaleDownAmount)
  local outerAnimation = AHSequence.new(outerScaleUp, outerScaleDown)

  local fadeOut = AHOpacityTo.new(self, fadeOutDuration, nil, 0)
  local wholeGroupAnimation = AHDelayed.new(fadeOutDelay, fadeOut)

  local animation = AHSpawn.new(innerAnimation, outerAnimation, wholeGroupAnimation)
  return animation
end


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function PunctuationAnswerReactionNegative.new(width, height)
  local self = PunctuationAnswerReaction.new(width, height, PunctuationColors.getWrongColor())
  Mixin.mix(self, PunctuationAnswerReactionNegative)

  return self
end
