class("PunctuationAnswerReactionPositive")
require("PunctuationColors")
require("PunctuationAnswerReaction")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PunctuationAnswerReactionPositive:reset()
  self.innerSolidFill:setOpacity(1)
  self.innerCircle:setOpacity(1)
  self.outerCircle:setOpacity(1)
  self.outerCircle:setScl(1)
  self.innerCircle:setScl(1)
end

function PunctuationAnswerReactionPositive:createReactionAnimation(seconds)
  seconds = seconds or 0.8

  if (self.animation) then
    return self.animation
  end

  local innerCircle = self.innerCircle
  local outerCircle = self.outerCircle

  local outerRadiusExpand = self.radius * 4
  local outerRadiusScale = outerRadiusExpand / self.radius

  local outerScaleTime = seconds
  local innerSolidDisappearStartTime = seconds * 0.2
  local innerSolidDisappearTime = seconds * 0.2

  local disappearInnerSolid = AHOpacityTo.new(self.innerSolidFill, innerSolidDisappearTime, nil, 0)
  local innerSolidAnimation = AHDelayed.new(innerSolidDisappearStartTime, disappearInnerSolid)
  local disappearInner = AHOpacityTo.new(innerCircle, outerScaleTime, nil, 0)

  local scaleOuter = AHScaleTo.new(outerCircle, outerScaleTime, nil, outerRadiusScale)
  local disappearOuter = AHOpacityTo.new(outerCircle, outerScaleTime, nil, 0)

  local core = AHSequence.new(innerSolidAnimation, disappearInner)

  local animation = AHSpawn.new(core, scaleOuter, disappearOuter)
  self.animation = animation
  return animation
end


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function PunctuationAnswerReactionPositive.new(width, height)
  local self = PunctuationAnswerReaction.new(width, height, PunctuationColors.getCorrectColor())
  Mixin.mix(self, PunctuationAnswerReactionPositive)

  return self
end
