class("PunctuationInputHelper")
require("widgets.DragHelpOverlay")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function PunctuationInputHelper:show()
  return self.tipView:show()
end

function PunctuationInputHelper:hide()
  return self.tipView:hide()
end


-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local message = "tap a mark to answer"
  local messageRelativeY = 0
  local arrowRelativeXOffset = 0.1
  local messageLabelFontSize = Screen.height * 0.03
  local arrowScale = -1
  local view = DragHelpOverlay.new(message, messageRelativeY, arrowRelativeXOffset, messageLabelFontSize, arrowScale)
  local _, arrowHeight = view.leftArrow:getDims()
  local hoverAmount = view:getHoverAmount()
  view:setLoc(Screen.width/2, Screen.height/2 + arrowHeight/2 + hoverAmount)
  self:insert(view)

  self.tipView = view
end

function PunctuationInputHelper.new()
  local self = Group.newDeprecated()
  Mixin.mix(self, PunctuationInputHelper)
  createLayout(self)

  return self
end
