--- RainDividendGrouper
-- @author Created by Aaron Barrett on July 13, 2015.

class("RainDividendGrouper")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RainDividendGrouper.getDividendGroupingStrings(dividend, divisor)
  local groupingStrings = {}

  local dividendString = tostring(dividend)

  local currentGroupingString = ""
  for digitString in dividendString:gmatch(".") do
    currentGroupingString = currentGroupingString .. digitString

    local groupingNumber = tonumber(currentGroupingString)
    local isDivisible = (groupingNumber % divisor == 0)
    if (isDivisible) then
      table.insert(groupingStrings, currentGroupingString)
      currentGroupingString = ""
    end
  end

  assert(currentGroupingString == "", "Last digits `" .. currentGroupingString .. "` are not divisible by divisor `" .. tostring(divisor) .. "`.")

  return groupingStrings
end
