--- RainMathGlyphSprite
-- @author Created by Aaron Barrett on July 20, 2015.

class("RainMathGlyphSprite")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local FILENAMES_BY_CHARACTER = {
  ["/"] = "divide.png",
  ["*"] = "times.png"
}

local HOLDER_OFFSET = 9.0

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getFilenameForCharacter(character)
  return FILENAMES_BY_CHARACTER[character]
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RainMathGlyphSprite.filenameSpecifiedForCharacter(character)
  local filename = getFilenameForCharacter(character)
  return (filename ~= nil)
end

function RainMathGlyphSprite:getLeftMargin()
  return 0.0
end

function RainMathGlyphSprite:getRightMargin()
  return 0.0
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function RainMathGlyphSprite.new(character)
  local filename = getFilenameForCharacter(character)
  local sprite = Sprite.newWithName(filename)

  local width = sprite:getWidth()
  local height = sprite:getHeight() + HOLDER_OFFSET
  local self = Group.new(width, height)
  Mixin.mix(self, RainMathGlyphSprite)

  sprite:setLoc(sprite:getWidthPart(0.5), sprite:getHeightPart(0.5))
  self:insert(sprite)
  sprite:inheritColor(self)

  return self
end
