--- RainTipReverseMultiplication
-- @author Created by Aaron Barrett on July 13, 2015.

class("RainTipReverseMultiplication")
require("RainEquation")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RainTipReverseMultiplication:createAppearAction()
  local equationLine = self.equationLine
  return equationLine:createAppearAction()
end

function RainTipReverseMultiplication:createDisappearAction()
  local equationLine = self.equationLine
  return equationLine:createDisappearAction()
end

function RainTipReverseMultiplication:prepareToAppear()
  -- RainTipReverseMultiplication has no looping animation, so do nothing here.
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function RainTipReverseMultiplication.new(round, roundColor)
  local dividend = round:getDividend()
  local divisor = round:getDivisor()
  local quotient = round:getCorrectAnswer()

  local equationText = tostring(divisor) .. " * " .. tostring(quotient) .. " = " .. tostring(dividend)
  local equationLine = RainEquation.new(equationText, roundColor)

  local width, height = equationLine:getDims()

  local self = Group.new(width, height)
  Mixin.mix(self, RainTipReverseMultiplication)

  self:insertAtCenter(equationLine)

  self.equationLine = equationLine

  return self
end
