--- RainWhiteOverlay
-- @author Created by Aaron Barrett on July 20, 2015.

class("RainWhiteOverlay")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local FULL_OPACITY = 0.5

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RainWhiteOverlay:playAppear()
  local appearAction = AHOpacityTo.new(self, 0.5, nil, FULL_OPACITY)
  self.actionInterrupt:insert(appearAction)
end

function RainWhiteOverlay:playDisappear()
  local disappearAction = AHOpacityTo.new(self, 0.5, nil, 0.0)
  self.actionInterrupt:insert(disappearAction)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function RainWhiteOverlay.new()
  local self = FilledRectangle.newFullScreen()
  Mixin.mix(self, RainWhiteOverlay)

  self:setOpacity(0.0)

  self.actionInterrupt = ActionInterrupt.new()

  return self
end
