--- RainZeroHelpers
-- @author Created by Aaron Barrett on August 12, 2015.

class("RainZeroHelpers")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local LUA_PATTER_TO_COUNT_TRAILING_ZEROES = "0*$"

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getTrailingZeroesCount(numberText)
  local startIndex, endIndex = string.find(numberText, LUA_PATTER_TO_COUNT_TRAILING_ZEROES)
  local zeroesWereFound = (startIndex ~= nil)
  if (zeroesWereFound) then
    return endIndex - startIndex + 1
  else
    return 0
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RainZeroHelpers.getZeroesToDrop(dividendText, divisorText)
  local dividendZeroesCount = getTrailingZeroesCount(dividendText)
  local divisorZeroesCount = getTrailingZeroesCount(divisorText)

  local dividendTextLength = #dividendText
  local divisorTextLength = #divisorText

  for divisorZeroesToDrop = divisorZeroesCount, 0, -1 do
    local divisorDroppedText = string.sub(divisorText, 1, divisorTextLength - divisorZeroesToDrop)
    local divisorDroppedNumber = tonumber(divisorDroppedText)

    for dividendZeroesToDrop = dividendZeroesCount, 0, -1 do
      local dividendDroppedText = string.sub(dividendText, 1, dividendTextLength - dividendZeroesToDrop)
      local dividendDroppedNumber = tonumber(dividendDroppedText)

      local evenlyDivisible = (dividendDroppedNumber % divisorDroppedNumber == 0)
      if (evenlyDivisible) then
        return dividendZeroesToDrop, divisorZeroesToDrop
      end
    end
  end
  error("None of the possible combinations of zeroes to drop were evenly divisible.")
end
