--- RiffleCommon
-- @author Created by Jay Austria on February 24, 2015.

class("RiffleCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------
RiffleCommon.COLORS =
{
  BLACK = ColorUtils.colorHex24ToStd(0x000000),
  WHITE = ColorUtils.colorHex24ToStd(0xffffff),
  ORANGE = ColorUtils.colorHex24ToStd(0xfdb32e),
  AQUA = ColorUtils.colorHex24ToStd(0x3cefdd),
  GREY = ColorUtils.colorHex24ToStd(0x6f6f6f),
  LIGHT_GREY = ColorUtils.colorHex24ToStd(0xcccccc),
  DARK_GREY = ColorUtils.colorHex24ToStd(0x222222),
  TRANSLUCENT_BLACK = ColorUtils.colorHex32ToStd(0x000000aa),
  INVISIBLE_BLACK = ColorUtils.colorHex32ToStd(0x00000000),
  MUTED_BLACK = ColorUtils.colorHex24ToStd(0x4c4c4c)
}

RiffleCommon.VISIBLE_OPACITY = 1.0
RiffleCommon.INVISIBLE_OPACITY = 0.0

RiffleCommon.LayoutStyle =
{
  IMAGE_AND_SUBHEADER = "RiffleCommon.LayoutStyle.IMAGE_AND_SUBHEADER",
  SUBHEADER_ONLY = "RiffleCommon.LayoutStyle.SUBHEADER_ONLY",
  IMAGE_ONLY = "RiffleCommon.LayoutStyle.IMAGE_ONLY",
  NO_ORNAMENTS = "RiffleCommon.LayoutStyle.NO_ORNAMENTS"
}

local NUMBER_TO_STRING = {
  [1] = "ONE",
  [2] = "TWO",
  [3] = "THREE",
  [4] = "FOUR",
  [5] = "FIVE"
}

RiffleCommon.QUESTION_ANIMATE_IN_AMOUNT = Screen.getHeightPart(0.1)
RiffleCommon.UI_BAR_HEIGHT = 55 + (Screen.fullHeight - Screen.safeTop)

RiffleCommon.QUESTION_PANEL_HEIGHT = Screen.getHeightPart(0.72)
RiffleCommon.COLLAPSED_QUESTION_PANEL_HEIGHT = RiffleCommon.QUESTION_PANEL_HEIGHT - Screen.getHeightPart(0.5)

local KNOWN_TARGET_HEIGHT = 568

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RiffleCommon.getCountText(questionIndex, questionMax)
  local indexString = NUMBER_TO_STRING[questionIndex]
  local countString = NUMBER_TO_STRING[questionMax]

  assert(indexString and countString, "No string defined for displaying the given number as text")

  local text = string.format("%s  of  %s", indexString, countString)

  return text
end

function RiffleCommon.getScaledFontSize(size)
  local screenScale = Screen.height / KNOWN_TARGET_HEIGHT
  local adjustedFontSize = size * screenScale

  return MathUtils.round(adjustedFontSize)
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
