--- default
-- @author Created by Jay Austria on February 23, 2015.
-- Test content validation entry point for Riffle.

require("Bootstrap")
require("RiffleValidator")
require("validators.SimpleParametersValidator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_PARAMETERS = {}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local validator = RiffleValidator.new()
local parametersValidator = SimpleParametersValidator.new(REQUIRED_PARAMETERS)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function validate(concept)
  validator:validate(concept)
  return validator:getPassed(), validator:getMessage()
end

function validateParameters(parameters)
  parametersValidator:validate(MOAIJsonParser.decode(parameters))
  return parametersValidator:getPassed(), parametersValidator:getMessage()
end
