--- RutabagaPausedOverlay
-- @author Created by Jay Austria on May 31, 2016.

class("RutabagaPausedOverlay")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BG_BLEND_COLOR = {0.36, 0.01, 0.0}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createFadeAction(self, targetOpacity)
  local bottomGradientColors = {
    {BG_BLEND_COLOR[1],BG_BLEND_COLOR[2],BG_BLEND_COLOR[3], 0},
    {BG_BLEND_COLOR[1],BG_BLEND_COLOR[2],BG_BLEND_COLOR[3], targetOpacity},
    {BG_BLEND_COLOR[1],BG_BLEND_COLOR[2],BG_BLEND_COLOR[3], targetOpacity}
  }

  return self.bottomGradient:newGradientToAction(0.2, nil, bottomGradientColors)
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RutabagaPausedOverlay:createFadeInAction()
  return createFadeAction(self, 1.0)
end

function RutabagaPausedOverlay:createFadeOutAction()
  return createFadeAction(self, 0.0)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local isHorizontal = false
  local colors = {
    {BG_BLEND_COLOR[1], BG_BLEND_COLOR[2], BG_BLEND_COLOR[3], 0},
    {BG_BLEND_COLOR[1], BG_BLEND_COLOR[2], BG_BLEND_COLOR[3], 0},
    {BG_BLEND_COLOR[1], BG_BLEND_COLOR[2], BG_BLEND_COLOR[3], 0}
  }
  local thicknesses = {
    0.35,
    0.55
  }
  local bottomGradient = MultiGradient.new(Screen.fullWidth, Screen.getSafeHeightPart(0.45), isHorizontal, colors, thicknesses)
  self:insert(bottomGradient)
  bottomGradient:setAnchorPointBottom()
  bottomGradient:setX(Screen.getWidthPart(0.5))
  self.bottomGradient = bottomGradient
end

-- Constructor ------------------------

function RutabagaPausedOverlay.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, RutabagaPausedOverlay)

  createLayout(self)

  return self
end
