--- RutabagaVisualStateGroup
-- @author Created by Jay Austria on May 22, 2015.

class("RutabagaVisualStateGroup")

require("graphics.RectangleGradient")
require("utils.StateMachine")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function RutabagaVisualStateGroup:setVisualState(state)
  self._visualStateMachine:transition(state)
end

function RutabagaVisualStateGroup:initialize(colorsForStates, colorSetter)
  self._visualStateMachine = StateMachine.new()
  self._colorsForStates = colorsForStates

  for state, colorDictionary in pairs(colorsForStates) do
    local colorSetterWrapped = function()
      if (colorSetter ~= nil) then
        colorSetter(self, colorDictionary)
      end
    end

    local otherStates = TableUtils.getKeys(self._colorsForStates)
    TableUtils.removeValueFromArray(otherStates, state)

    self._visualStateMachine:addState(state, colorSetterWrapped, nil, unpack(otherStates))
  end
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
function RutabagaVisualStateGroup.makeVisualStateGroup(group, colorsForStates, colorSetter)
  Mixin.mix(group, RutabagaVisualStateGroup)

  group:initialize(colorsForStates, colorSetter)
end
