--- SimonContainer
-- @author Created by Aaron Barrett on February 24, 2015.

class("SimonContainer")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- Dimensions -------------------------

local WIDTH = Screen.width

-- Colors -----------------------------

local COLOR_LABEL = {0.92, 0.90, 0.32}

-- Z-Indices --------------------------

local Z_LABEL = 10

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- Accessors --------------------------

function SimonContainer:getContainerIndex()
  return self.containerIndex
end

--- Drag And Drop Container -----------

-- Returns true if the object is acceptable to the container.
function SimonContainer:canAcceptDNDObject(object)
  return true
end

-- Notify that an object is hovering over the container.
function SimonContainer:notifyDNDEnter(object)
  self.onEnteredCallback(object, self)
end

-- Notify that an object is no longer hovering over the container.
function SimonContainer:notifyDNDLeave(object)

end

-- Notify that an object has moved while hovering over the container.
function SimonContainer:notifyDNDMove(object)

end

-- Notify that an object has been dropped on the container.
function SimonContainer:notifyDNDDrop(object)

end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SimonContainer.new(height, containerIndex, onEnteredCallback)
  local self = Group.new(WIDTH, height)
  Mixin.mix(self, SimonContainer)

  self.containerIndex = containerIndex
  self.onEnteredCallback = onEnteredCallback

  return self
end
