--- SimonTextLabel
-- @author Created by Aaron Barrett on April 10, 2015.

class("SimonTextLabel")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local DEFAULT_SIZE = 18
local DEFAULT_FONT_FACE = FontFaces.DIN_OT_LIGHT
local DEFAULT_ATTRIBUTES_FOR_LABELS = {
  b = {font = Font.new(FontFaces.DIN_OT_BOLD, DEFAULT_SIZE)},
  i = {font = Font.new(FontFaces.DIN_OT_LIGHT_ITALIC, DEFAULT_SIZE)},
  m = {font = Font.new(FontFaces.DIN_OT_MEDIUM, DEFAULT_SIZE)}
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function SimonTextLabel.new(text, width, fontFace, fontSize, attributesForLabels, horizontalAlignment, verticalAlignment, lineSpacing)
  fontFace = fontFace or DEFAULT_FONT_FACE
  fontSize = fontSize or DEFAULT_SIZE

  local baseAttributes = {
    font = Font.new(fontFace, fontSize)
  }

  attributesForLabels = attributesForLabels or DEFAULT_ATTRIBUTES_FOR_LABELS

  local self = DynamicTextArea.new(text, width, baseAttributes, attributesForLabels, horizontalAlignment, verticalAlignment, lineSpacing)
  Mixin.mix(self, SimonTextLabel)

  return self
end
