--- SimonTheme
-- @author Created by Aaron Barrett on March 30, 2015.

class("SimonTheme")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

SimonTheme.CATEGORY_NAME_DIRECTIONS = "Directions"
SimonTheme.CATEGORY_NAME_DATES = "Dates"

local GRAYED_TEXT_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.28, 0.45, 0.37},
  [SimonTheme.CATEGORY_NAME_DATES] = {0.39, 0.32, 0.24}
}

local BACKGROUND_TOP_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.27, 0.67, 0.65},
  [SimonTheme.CATEGORY_NAME_DATES] = {0.99, 0.62, 0.43}
}

local BACKGROUND_BOTTOM_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.73, 0.96, 0.73},
  [SimonTheme.CATEGORY_NAME_DATES] = {1.00, 0.95, 0.71}
}

local SUBMIT_BUTTON_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.61, 0.84, 0.66},
  [SimonTheme.CATEGORY_NAME_DATES] = {0.87, 0.71, 0.53}
}

local SUBMIT_BUTTON_PRESSED_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.81, 1.00, 0.86},
  [SimonTheme.CATEGORY_NAME_DATES] = {1.00, 0.91, 0.73}
}

local ITEM_TOP_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.22, 0.36, 0.31},
  [SimonTheme.CATEGORY_NAME_DATES] = {0.39, 0.31, 0.26}
}

local ITEM_BOTTOM_COLORS = SUBMIT_BUTTON_COLORS

local ITEM_CORRECT_TOP_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {1.0, 1.0, 1.0},
  [SimonTheme.CATEGORY_NAME_DATES] = {1.0, 1.0, 1.0}
}

local ITEM_CORRECT_BOTTOM_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.66, 0.90, 0.77},
  [SimonTheme.CATEGORY_NAME_DATES] = {1.0, 0.87, 0.67}
}

local ITEM_CORRECT_TEXT_COLORS = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = {0.27, 0.39, 0.35},
  [SimonTheme.CATEGORY_NAME_DATES] = {0.39, 0.29, 0.27}
}

local SUBMIT_BUTTON_IMAGERY_FILENAMES = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = "theme_directions.png",
  [SimonTheme.CATEGORY_NAME_DATES] = "theme_dates.png"
}

local SUBMIT_BUTTON_MOUNTAINS_FILENAMES = {
  [SimonTheme.CATEGORY_NAME_DIRECTIONS] = "mountains_directions.png",
  [SimonTheme.CATEGORY_NAME_DATES] = "mountains_dates.png",
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SimonTheme:getGrayedTextColor()
  return GRAYED_TEXT_COLORS[self.categoryName]
end

function SimonTheme:getBackgroundTopColor()
  return BACKGROUND_TOP_COLORS[self.categoryName]
end

function SimonTheme:getBackgroundBottomColor()
  return BACKGROUND_BOTTOM_COLORS[self.categoryName]
end

function SimonTheme:getSubmitButtonColor()
  return SUBMIT_BUTTON_COLORS[self.categoryName]
end

function SimonTheme:getSubmitButtonPressedColor()
  return SUBMIT_BUTTON_PRESSED_COLORS[self.categoryName]
end

function SimonTheme:getItemTopColor()
  return ITEM_TOP_COLORS[self.categoryName]
end

function SimonTheme:getItemBottomColor()
  return ITEM_BOTTOM_COLORS[self.categoryName]
end

function SimonTheme:getItemCorrectTopColor()
  return ITEM_CORRECT_TOP_COLORS[self.categoryName]
end

function SimonTheme:getItemCorrectBottomColor()
  return ITEM_CORRECT_BOTTOM_COLORS[self.categoryName]
end

function SimonTheme:getItemCorrectTextColor()
  return ITEM_CORRECT_TEXT_COLORS[self.categoryName]
end

function SimonTheme:getSubmitButtonImageryFilename()
  return SUBMIT_BUTTON_IMAGERY_FILENAMES[self.categoryName]
end

function SimonTheme:getSubmitButtonMountainsFilename()
  return SUBMIT_BUTTON_MOUNTAINS_FILENAMES[self.categoryName]
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SimonTheme.new(categoryName)
  local self = {}
  Mixin.mix(self, SimonTheme)

  self.categoryName = categoryName

  return self
end
