--- SquaresConstants
-- @author Created by Aaron Barrett on December 16, 2013.

class("SquaresConstants")

require("SquaresConfiguration")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- Balloon Sizing ---------------------

-- I tested with a bunch of sizes, and these settings are fairly good
-- to fit 20 balloons on any mobile device screen.
SquaresConstants.WIDTH_WEIGHT = 1.3
SquaresConstants.HEIGHT_WEIGHT = 0.7
SquaresConstants.SCREEN_DIMENSION_AMALGAM = (Screen.width * 1.3 + Screen.height * 0.7) * 0.5

SquaresConstants.BASE_RADIUS_FACTOR = 0.11
SquaresConstants.RANDOM_RADIUS_FACTOR = 0.015

SquaresConstants.BASE_RADIUS = SquaresConstants.BASE_RADIUS_FACTOR * SquaresConstants.SCREEN_DIMENSION_AMALGAM
SquaresConstants.MAX_RANDOM_RADIUS = SquaresConstants.RANDOM_RADIUS_FACTOR * SquaresConstants.SCREEN_DIMENSION_AMALGAM

SquaresConstants.MIN_RADIUS = SquaresConstants.BASE_RADIUS * 0.72
SquaresConstants.MAX_RADIUS = SquaresConstants.BASE_RADIUS * 2.75

SquaresConstants.PENALTY_RESIZE_AMOUNT = SquaresConstants.BASE_RADIUS * SquaresConfiguration.PENALTY_RESIZE_FACTOR
