--- SquaresEffectShrinker
-- @author Created by Aaron Barrett on January 9, 2014.

class("SquaresEffectShrinker")
-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local MAX_DELAY_DURATION = 0.3

local SHRINK_AMOUNT = -SquaresConstants.BASE_RADIUS * 0.27

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SquaresEffectShrinker:getGroup()
  return nil
end

function SquaresEffectShrinker:getAction()
  local action = self.action
  return action
end

function SquaresEffectShrinker:getHitBalloons()
  return {}
end

function SquaresEffectShrinker:getDelayDuration()
  return 0.05
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SquaresEffectShrinker.new(otherBalloons)
  local self = {}
  Mixin.mix(self, SquaresEffectShrinker)

  local shrinkBalloonActions = {}
  for balloon in pairs(otherBalloons) do
    local delayDuration = math.random() * MAX_DELAY_DURATION
    local shouldPlayShrinkSound = true
    local shrinkBalloonAction = balloon:resize(SHRINK_AMOUNT, delayDuration, shouldPlayShrinkSound)
    table.insert(shrinkBalloonActions, shrinkBalloonAction)
  end

  local action = AHSpawn.new(unpack(shrinkBalloonActions))

  self.hitBalloons = nil
  self.group = nil
  self.action = action

  return self
end
