--- SquaresFlasher
-- @author Created by Aaron Barrett on January 16, 2014.

class("SquaresFlasher")
-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WIDTH = Screen.width
local HEIGHT = Screen.height

local CENTER_X = WIDTH * 0.5
local CENTER_Y = HEIGHT * 0.5

local FLASH_COLOR = {1.0, 1.0, 1.0}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SquaresFlasher:flash()
  local flashRectangle = FilledRectangle.new(WIDTH, HEIGHT, FLASH_COLOR)
  flashRectangle:setOpacity(0.0)
  flashRectangle:setLoc(CENTER_X, CENTER_Y)
  self:insert(flashRectangle)

  local flashAction = AHSequence.new(
                                     AHOpacityTo.new(flashRectangle, 0.05, nil, 0.85),
                                     AHOpacityTo.new(flashRectangle, 0.2, nil, 0.0),
                                     AHCallLogic.new(function()
                                                         flashRectangle:removeSelf()
                                                       end)
                                     )
  return flashAction:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function SquaresFlasher.new()
  local self = Group.new(WIDTH, HEIGHT)
  Mixin.mix(self, SquaresFlasher)

  return self
end
