--- SquaresPopParticles
--
-- Rather than creating a new particle system each time a balloon is popped,
-- Squares reuses a single particle systems that exists for the entire
-- duration of the game.  This is done to prevent major performance hits when
-- many balloons are popped at once.
--
-- @author Created by Aaron Barrett on January 9, 2014.

class("SquaresPopParticles")
-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local PARTICLES_PER_BALLOON = 128

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SquaresPopParticles:destroy()
  self:reset()
  self:stop()
end

function SquaresPopParticles:show(x, y)
  self:setSourcePosition(x, y)
  self:surge(PARTICLES_PER_BALLOON)
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function SquaresPopParticles.new()
  local self = Particles.new("pop.pex")
  Mixin.mix(self, SquaresPopParticles)

  self:start()

  return self
end
