--- SquaresScoreCell
-- @author Created by Aaron Barrett on November 04, 2021.

class("SquaresScoreCell")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local PAIR_ICON_Y_OFFSET = -4.0

local SPACING = 10.0

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function buildLabel(self, labelWidth, concept, isForRightColumn)
  local label = SquaresScoreDefinition.new(labelWidth, concept, isForRightColumn)
  self:insert(label)
end

-- Constructor ------------------------

function SquaresScoreCell.new(width, concept, isMatched)
  local self = Row.new(SPACING, Alignment.TOP)
  Mixin.mix(self, SquaresScoreSlidingElement)
  Mixin.mix(self, SquaresScoreCell)

  local pairIcon = SquaresScorePairIcon.new(isMatched)
  local labelWidth = 0.5 * (width - pairIcon:getWidth())

  local leftLabelIsForRightColumn = false
  buildLabel(self, labelWidth, concept, leftLabelIsForRightColumn)

  self:insert(pairIcon)

  local rightLabelIsForRightColumn = true
  buildLabel(self, labelWidth, concept, rightLabelIsForRightColumn)

  self:alignChildren()
  pairIcon:offsetY(PAIR_ICON_Y_OFFSET)

  local isRecursive = true
  self:linkColorAttrToChildren(isRecursive)
  self:setOpacity(0.0)

  return self
end
