--- SquaresScorePairIcon
-- @author Created by Aaron Barrett on November 06, 2021.

class("SquaresScorePairIcon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WIDTH = 34.0
local HEIGHT = 22.0

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function getLeftIconName(isMatched)
  if (isMatched) then
    return "score_card_icon_blue.png"
  else
    return "score_card_icon_empty.png"
  end
end

local function getRightIconName(isMatched)
  if (isMatched) then
    return "score_card_icon_red.png"
  else
    return "score_card_icon_empty.png"
  end
end

-- Constructor ------------------------

function SquaresScorePairIcon.new(isMatched)
  local self = Group.new(WIDTH, HEIGHT)
  Mixin.mix(self, SquaresScorePairIcon)

  local leftIconName = getLeftIconName(isMatched)
  local rightIconName = getRightIconName(isMatched)
  local leftIcon = Sprite.newWithName(leftIconName)
  local rightIcon = Sprite.newWithName(rightIconName)

  leftIcon:setX(leftIcon:getWidthPart(0.5))
  leftIcon:setY(self:getHeightPart(0.5))
  self:insert(leftIcon)

  rightIcon:setX(self:getWidth() - rightIcon:getWidthPart(0.5))
  rightIcon:setY(self:getHeightPart(0.5))
  self:insert(rightIcon)

  return self
end
