--- SquaresScoreSlidingElement
-- @author Created by Aaron Barrett on November 09, 2021.

class("SquaresScoreSlidingElement")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

SquaresScoreSlidingElement.SLIDE_DURATION = 0.333

local SLIDE_DISTANCE = 50.0

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SquaresScoreSlidingElement:prepareToSlideIn()
  self:setOpacity(0.0)
  self:offsetX(SLIDE_DISTANCE)
end

function SquaresScoreSlidingElement:playSlideIn()
  local ease = AHEaseBezier.newFlat({0.0, 0.0, 0.2, 1.0})
  return AHSpawn.new(
    AHLocationXBy.new(self, SquaresScoreSlidingElement.SLIDE_DURATION, ease, -SLIDE_DISTANCE),
    AHOpacityTo.new(self, SquaresScoreSlidingElement.SLIDE_DURATION, ease, 1.0)
  ):start()
end
