--- SquaresTipLocalizer
-- @author Created by andrewc on October 07, 2021.

class("SquaresTipLocalizer")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TIP_AMERICAN_ENGLISH = "Tap on pairs of different-colored <br/>opposites to pop the balloons"
local TIP_BRITISH_ENGLISH = "Tap on pairs of different-coloured <br/>opposites to pop the balloons"

local TIP_BY_LOCALE = {
  en_US = TIP_AMERICAN_ENGLISH,
  en_GB = TIP_BRITISH_ENGLISH,
  en_CA = TIP_BRITISH_ENGLISH,
  en_AU = TIP_BRITISH_ENGLISH
}

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SquaresTipLocalizer.getLocalizedTip()
  local currentLocale = GameSession.getCurrentLocale()
  local localizedTip = TIP_BY_LOCALE[currentLocale]
  if (localizedTip == nil) then
    return TIP_AMERICAN_ENGLISH
  end
  return localizedTip
end
