--- SummationColorUtils
-- @author Created by Jay Austria on August 7, 2014.

class("SummationColorUtils")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SummationColorUtils.getColorToAction(element, color, duration)
  return AHColorTo.new(element, duration, nil, color)
end

function SummationColorUtils.morphElementColors(element, color, duration)
  if (element.colorActionInterrupt == nil) then
    element.colorActionInterrupt = ActionInterrupt.new()
  end

  local morphAction = SummationColorUtils.getColorToAction(element, color, duration)

  element.colorActionInterrupt:insert(morphAction)

  return morphAction
end

function SummationColorUtils.getFlipElementColorToAction(element, colorFirst, colorSecond, durationFirst, durationSecond, delayDuration)
  local colorTo = SummationColorUtils.getColorToAction(element, colorFirst, durationFirst)
  local flipDelay = AHDelay.new(delayDuration)
  local colorFrom = SummationColorUtils.getColorToAction(element, colorSecond, durationSecond)

  local flipSequence = AHSequence.new(colorTo, flipDelay, colorFrom)

  return flipSequence
end

function SummationColorUtils.flipElementColor(element, colorFirst, colorSecond, durationFirst, durationSecond, delayDuration)
  if (element.colorActionInterrupt == nil) then
    element.colorActionInterrupt = ActionInterrupt.new()
  end

  local flipAction = SummationColorUtils.getFlipElementColorToAction(element, colorFirst, colorSecond, durationFirst, durationSecond, delayDuration)

  element.colorActionInterrupt:insert(flipAction)

  return flipAction
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
