--- SummationScreenShake
-- @author Created by Jay Austria on September 28, 2015.

class("SummationScreenShake")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------
local SHAKE_MAGNITUDE = Screen.getWidthPart(0.015)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createScreenShakeAction()
  local rootGroup = Screen.rootGroup
  local x, y = rootGroup:getLoc()

  local randomShakeAngle = MathUtils.getRandomFloat(0, 2 * math.pi)

  local offsetX = SHAKE_MAGNITUDE * math.cos(randomShakeAngle)
  local offsetY = SHAKE_MAGNITUDE * math.sin(randomShakeAngle)

  local screenShakeAction = AHSequence.new(
    function() rootGroup:setLoc(x + offsetX, y + offsetY) end,
    AHLocationTo.new(rootGroup, 1.2, AHEaseElasticOut.new(), x, y)
  )

  return screenShakeAction
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SummationScreenShake.playScreenShake()
  local screenShakeAction = createScreenShakeAction()

  screenShakeAction:start()
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------
