--- SwapRoundGenerator
-- @author Created by karl on August 11, 2014.

module("SwapRoundGenerator", package.seeall)

require("GameSession")
require("data.generators.UtilityGenerators")

SwapRoundGenerator.CONCEPT_IDENTIFIER_KEY = "conceptId"

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SwapRoundGenerator.new()
  local conceptGenerator = GameSession.conceptGenerator
  return TransformationGenerator.new(GameSession.conceptGenerator, function(concept)
    local conceptId = concept.identifier
    local sentence = concept.sentence
    local words = {concept.wordOne, concept.wordTwo}

    for i = 1, 2 do
      assert(words[i] and words[i] ~= "", "One of the words is empty for " .. tostring(concept.identifier))
    end

    local conceptData = {}
    conceptData[SwapRoundGenerator.CONCEPT_IDENTIFIER_KEY] = conceptId
    conceptData.sentence = sentence
    conceptData.words = words
    conceptData.rationale = concept.rationale

    return conceptData
  end)
end
