--- SynonymsCursor
-- @author Created by karl on January 28, 2015.

class("SynonymsCursor")

local CURSOR_WIDTH = 7

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------



local function startBlink(self)
  local blinkAction = AHLoop.new(
                                AHSequence.new(
                                               AHColorTo.new(self.rect, 0.5, AHEaseSineIn.new(), self.endColor),
                                               AHColorTo.new(self.rect, 0.5, AHEaseSineOut.new(), self.startColor)
                                               )
                                )
  self.blinkAction = blinkAction
  blinkAction:start()
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function SynonymsCursor:stopBlink()
  self.blinkAction:stop()
end

function SynonymsCursor:toggleBlink(isPaused)
  self.blinkAction:pause(isPaused)
  if (isPaused) then
    self.rect:setOpacity(0.0)
  end
end

function SynonymsCursor:createClone(height)
  local clone = Group.new(CURSOR_WIDTH, height)

  return clone
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SynonymsCursor.new(height, startColor, endColor)
  local self = Group.new(CURSOR_WIDTH, height)
  Mixin.mix(self, SynonymsCursor)

  self.rect = FilledRectangle.new(2, height, startColor)
  self.rect:setLoc(self:getWidthPart(0.5), self:getHeightPart(0.4))
  self:insert(self.rect)
  self.startColor = startColor
  self.endColor = endColor

  startBlink(self)

  return self
end
