--- SynonymsScoreRectangle
-- @author Created by karl on March 18, 2015.

-- ============================================================================
class("SynonymsScoreRectangle")
-- ============================================================================

require("SynonymsCommon")

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function SynonymsScoreRectangle.new(size, color)
  color = color or SynonymsCommon.COLORS.YELLOW
  local cornerRadius = size * 0.1
  return FilledRoundedRectangle.new(size, size, cornerRadius, color)
end



-- ============================================================================
class("SynonymsScoreRectangleSet")
-- ============================================================================

function SynonymsScoreRectangleSet.new(width, count, shouldShowEmpties)
  local maxCount = 3
  local rectWidth = width * 0.9
  local spaceWidth = width - rectWidth
  local rectSize = rectWidth / maxCount
  local spacing = spaceWidth / (maxCount - 1)

  local self = Row.new(spacing)
  for i=1, count do
    self:insert(SynonymsScoreRectangle.new(rectSize))
  end
  if shouldShowEmpties then
    for i=count+1, maxCount do
      self:insert(SynonymsScoreRectangle.new(rectSize, SynonymsCommon.COLORS.LIGHT_GREY))
    end
  end
  self:alignChildren()
  return self
end
