--- default
-- @author Created by karl on January 05, 2015.
-- Test content validation entry point for Synonyms.

require("Bootstrap")
require("SynonymsValidator")
require("validators.SimpleParametersValidator")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local REQUIRED_PARAMETERS = {}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local validator = SynonymsValidator.new()
local parametersValidator = SimpleParametersValidator.new(REQUIRED_PARAMETERS)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function validate(concept)
  validator:validate(concept)
  return validator:getPassed(), validator:getMessage()
end

function validateParameters(parameters)
  parametersValidator:validate(MOAIJsonParser.decode(parameters))
  return parametersValidator:getPassed(), parametersValidator:getMessage()
end
