--- HelpOverlay
-- @author Created by karl on August 27, 2014.

class("HelpOverlay")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function HelpOverlay:animateIn()
  return AHOpacityTo.new(self, 0.5, nil, 1):start()
end

function HelpOverlay:animateOut()
  return AHOpacityTo.new(self, 0.5, nil, 0):start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function newArrow(isPointingRight)
  local rectW, rectH = math.floor(Screen.width * 0.08), math.floor(Screen.width * 0.055)
  local triW, triH = math.floor(Screen.width * 0.055), math.floor(Screen.width * 0.12)

  local row = Row.new()
  local rectangle = FilledRectangle.new(rectW, rectH)

  if isPointingRight then
    local triangle = FilledTriangle.new(0, 0, triW, triH/2, 0, triH)
    row:insert(rectangle)
    row:insert(triangle)
  else
    local triangle = FilledTriangle.new(0, triH/2, triW, 0, triW, triH)
    row:insert(triangle)
    row:insert(rectangle)
  end

  row:alignChildren()

  return row
end

-- Constructor ------------------------

function HelpOverlay.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, HelpOverlay)

  local selfW, selfH = self:getDims()

  local background = FilledRectangle.new(selfW, selfH, {0, 0, 0, 0.6})
  self:insertAtCenter(background)

  local spacing = math.floor(Screen.width * 0.5)

  local row = Row.new(spacing)
  row:insert(newArrow(false))
  row:insert(newArrow(true))
  row:alignChildren()
  self:insertAtCenter(row)

  self:linkColorAttrToChildren(true)

  self:setOpacity(0)

  return self
end
