--- TotemPercentage
-- @author Created by karl on May 27, 2014.

class("TotemPercentage")
require("TotemCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local FONT = TotemCommon.FONT_TOTEM_FACE


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function TotemPercentage:setTextColor(color)
  self.label:setColor(unpack(color))
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function TotemPercentage.new(selfW, selfH, value)
  local self = Group.new(selfW, selfH)
  Mixin.mix(self, TotemPercentage)

  local fontSize = math.floor(selfW * 0.33)

  local formatString = "%.2f%%"
  if value % 1 == 0 then
  	formatString = "%g%%"
  end

  local percentString = string.format(formatString, value)
  local label = DeprecatedLabel.newSingleLine(percentString, FONT, fontSize)
  label:setColor(unpack(TotemCommon.TOTEM_FACE_TEXT_COLOR))
  self:insertAtCenter(label)

  self.label = label

  return self
end
