--- TotemRoundGenerator
-- @author Created by karl on December 19, 2014.

class("TotemRoundGenerator")

require("GameSession")
require("data.generators.UtilityGenerators")


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function makeMathConcept(concept, index)
  local numerator = concept["num_" .. index]
  local denominator = concept["denom_" .. index]
  local moneyDenominator = concept["money_" .. index]

  return {
    identifier = concept.identifier,
    difficulty = concept.difficulty,
    numerator = numerator,
    denominator = denominator,
    moneyDenominator = moneyDenominator,
    moneyNumerator = numerator * moneyDenominator / denominator,
    percent = numerator / denominator * 100
  }
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function TotemRoundGenerator.new()
  return TransformationGenerator.new(GameSession.conceptGenerator, function(concept)
    local mathConceptCount = 4

    local concepts = {}
    for i = 1, mathConceptCount do
      table.insert(concepts, makeMathConcept(concept, i))
    end

    return concepts
  end)
end
