--- TransitionsDiamond
-- @author Created by Steven Mah on May 9, 2017.

class("TransitionsDiamond")

require("TransitionsDiamondTexture")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

local function createLayout(self, textureParameters)
  local sideLength = textureParameters.sideLength
  local spriteScaleX = sideLength / self:getWidth()
  local spriteScaleY = sideLength / self:getHeight()
  self:setScl(spriteScaleX, spriteScaleY)
  self:setRot(45.0)
end

-- Constructor ------------------------

function TransitionsDiamond.new(textureParameters)
  local texture = TransitionsDiamondTexture.new(textureParameters)

  local self = Sprite.newWithTexture(texture)
  Mixin.mix(self, TransitionsDiamond)

  createLayout(self, textureParameters)

  return self
end
