--- TypoBubbleLayouts
-- @author Created by anton on August 12, 2015.

class("TypoBubbleLayouts")

require("TypoCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_KEY_HIGHLIGHT = "HIGHLIGHT"
local COLOR_KEY_HIGHLIGHT_LIGHT = "HIGHLIGHT_LIGHT"
local COLOR_KEY_HIGHLIGHT_DARK = "HIGHLIGHT_DARK"
local COLOR_KEY_GRAY = "GRAY"
local COLOR_KEY_GRAY_LIGHT = "GRAY_LIGHT"
local COLOR_KEY_GRAY_DARK = "GRAY_DARK"

local DIMMED_OPACITY = 0.5

TypoBubbleLayouts.LAYOUTS_ONE = {
  -- 1
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 68, startPoint = { x = 0.19, y = 0.93 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 40, startPoint = { x = 0.26, y = 0.76 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.10, y = 0.80 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 22, startPoint = { x = 0.44, y = 0.79 } },
  -- 5
  { colorKey = COLOR_KEY_GRAY,            radius = 18, startPoint = { x = 0.36, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 18, startPoint = { x = 0.53, y = 0.83 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 16, startPoint = { x = 0.47, y = 0.88 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.41, y = 0.99 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 18, startPoint = { x = 0.43, y = 0.93 } },
  -- 10
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = 0.62, y = 0.76 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = 0.76, y = 0.65 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 15, startPoint = { x = -0.02, y = 0.81 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = -0.02, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 75, startPoint = { x = 1.02, y = 0.87 } },
  -- 15
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 40, startPoint = { x = 0.93, y = 0.69 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 40, startPoint = { x = 0.62, y = 1.00 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 25, startPoint = { x = 0.74, y = 0.92 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 25, startPoint = { x = 0.75, y = 0.725 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 20, startPoint = { x = 0.74, y = 0.835 } },
  -- 20
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 20, startPoint = { x = 0.61, y = 0.90 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 15, startPoint = { x = 0.52, y = 0.74 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 15, startPoint = { x = 0.64, y = 0.835 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 17, startPoint = { x = 0.81, y = 0.785 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 15, startPoint = { x = 0.82, y = 0.97 } },
  -- 25
  { colorKey = COLOR_KEY_GRAY,            radius = 8, startPoint = { x = -0.01, y = 0.99 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.53, y = 0.91 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.54, y = 0.93 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 8, startPoint = { x = 0.70, y = 0.79 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 18, startPoint = { x = 0.91, y = 1.01 } },
  -- 30
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 8, startPoint = { x = 0.76, y = 0.99 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 10, startPoint = { x = 0.50, y = 0.96 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.68, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.89, y = 0.76 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.69, y = 0.68 } },
  -- 35
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 5, startPoint = { x = 0.38, y = 0.89 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 5, startPoint = { x = 0.04, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 55, startPoint = { x = -0.18, y = 0.94 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 8, startPoint = { x = -0.08, y = 0.84 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 23, startPoint = { x = 1.1, y = 0.725 } },
  -- 40
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK, radius = 60, startPoint = { x = 1.2, y = 1.06 } },
}

-- LAYOUTS_TWO is LAYOUTS_ONE with some removals
TypoBubbleLayouts.LAYOUTS_TWO = {
  -- 1
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 68, startPoint = { x = 0.19, y = 0.93 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 40, startPoint = { x = 0.26, y = 0.76 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.10, y = 0.80 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 22, startPoint = { x = 0.44, y = 0.79 } },
  -- 5
  { colorKey = COLOR_KEY_GRAY,            radius = 18, startPoint = { x = 0.36, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 18, startPoint = { x = 0.53, y = 0.83 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 16, startPoint = { x = 0.47, y = 0.88 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.41, y = 0.99 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 18, startPoint = { x = 0.43, y = 0.93 } },
  -- 10
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = 0.62, y = 0.76 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 15, startPoint = { x = -0.02, y = 0.81 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = -0.02, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 75, startPoint = { x = 1.02, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 40, startPoint = { x = 0.62, y = 1.00 } },
  -- 15
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 25, startPoint = { x = 0.74, y = 0.92 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 20, startPoint = { x = 0.74, y = 0.835 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 20, startPoint = { x = 0.61, y = 0.90 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 15, startPoint = { x = 0.52, y = 0.74 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 15, startPoint = { x = 0.64, y = 0.835 } },
  -- 20
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 17, startPoint = { x = 0.81, y = 0.785 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 15, startPoint = { x = 0.82, y = 0.97 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 8, startPoint = { x = -0.01, y = 0.99 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.53, y = 0.91 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.54, y = 0.93 } },
  -- 25
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 8, startPoint = { x = 0.70, y = 0.79 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 18, startPoint = { x = 0.91, y = 1.01 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 8, startPoint = { x = 0.76, y = 0.99 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 10, startPoint = { x = 0.50, y = 0.96 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.68, y = 0.87 } },
  -- 30
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.89, y = 0.76 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 5, startPoint = { x = 0.38, y = 0.89 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 5, startPoint = { x = 0.04, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 55, startPoint = { x = -0.18, y = 0.94 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 8, startPoint = { x = -0.08, y = 0.84 } },
  -- 35
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 23, startPoint = { x = 1.1, y = 0.725 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK, radius = 60, startPoint = { x = 1.2, y = 1.06 } },
}

-- LAYOUTS_THREE is unique
TypoBubbleLayouts.LAYOUTS_THREE = {
  -- 1
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 95, startPoint = { x = 0.32, y = 0.97 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 46, startPoint = { x = 0.26, y = 0.75 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 27, startPoint = { x = 0.03, y = 0.865 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 27, startPoint = { x = 0.47, y = 0.71 } },
  -- 5
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 27, startPoint = { x = 0.66, y = 0.95 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 22, startPoint = { x = 0.455, y = 0.80 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 22, startPoint = { x = -0.01, y = 1.00 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 10, startPoint = { x = 0.17, y = 0.83 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.037, y = 0.935 } },
  -- 10
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 46, startPoint = { x = 0.90, y = 0.89 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 30, startPoint = { x = 0.79, y = 1.00 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 25, startPoint = { x = 0.775, y = 0.785 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 22, startPoint = { x = 0.05, y = 0.775 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 22, startPoint = { x = 0.615, y = 0.73 } },
  -- 15
  { colorKey = COLOR_KEY_GRAY,            radius = 22, startPoint = { x = 0.63, y = 1.025 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.605, y = 0.87 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 20, startPoint = { x = 0.60, y = 0.80 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 1.00, y = 1.00 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 20, startPoint = { x = 1.00, y = 0.785 } },
  -- 20
  { colorKey = COLOR_KEY_GRAY,            radius = 10, startPoint = { x = 0.723, y = 0.878 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 7, startPoint = { x = 0.74, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 7, startPoint = { x = 0.70, y = 0.82 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 7, startPoint = { x = 0.52, y = 0.843 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 7, startPoint = { x = 0.915, y = 0.985 } },
  -- 25
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 70, startPoint = { x = 1.25, y = 0.94 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 7, startPoint = { x = 1.02, y = 0.83 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 46, startPoint = { x = -0.17, y = 0.925 } },
}

-- LAYOUTS_BONUS is LAYOUTS_ONE with some tweaks
TypoBubbleLayouts.LAYOUTS_BONUS = {
  -- 1
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 68, startPoint = { x = 0.19, y = 0.93 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 40, startPoint = { x = 0.26, y = 0.76 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.10, y = 0.80 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 22, startPoint = { x = 0.44, y = 0.79 } },
  -- 5
  { colorKey = COLOR_KEY_GRAY,            radius = 18, startPoint = { x = 0.36, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 18, startPoint = { x = 0.53, y = 0.83 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 16, startPoint = { x = 0.47, y = 0.88 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 20, startPoint = { x = 0.41, y = 0.99 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 18, startPoint = { x = 0.43, y = 0.93 } },
  -- 10
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = 0.62, y = 0.76 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 15, startPoint = { x = -0.02, y = 0.81 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 15, startPoint = { x = -0.02, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 75, startPoint = { x = 1.02, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 26, startPoint = { x = 0.07, y = 0.725 } },
  -- 15
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 12, startPoint = { x = 0.03, y = 0.66 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 40, startPoint = { x = 0.93, y = 0.69 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 40, startPoint = { x = 0.62, y = 1.00 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 25, startPoint = { x = 0.74, y = 0.92 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 25, startPoint = { x = 0.75, y = 0.725 } },
  -- 20
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 20, startPoint = { x = 0.74, y = 0.835 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 20, startPoint = { x = 0.61, y = 0.90 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 15, startPoint = { x = 0.52, y = 0.74 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 15, startPoint = { x = 0.64, y = 0.835 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 17, startPoint = { x = 0.81, y = 0.785 } },
  -- 25
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 15, startPoint = { x = 0.82, y = 0.97 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 8, startPoint = { x = -0.01, y = 0.99 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.53, y = 0.91 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.54, y = 0.93 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 8, startPoint = { x = 0.70, y = 0.79 } },
  -- 30
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 18, startPoint = { x = 0.91, y = 1.01 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 8, startPoint = { x = 0.76, y = 0.99 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 10, startPoint = { x = 0.50, y = 0.96 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.68, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 8, startPoint = { x = 0.89, y = 0.76 } },
  -- 35
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 5, startPoint = { x = 0.38, y = 0.89 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 5, startPoint = { x = 0.04, y = 0.84 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 55, startPoint = { x = -0.18, y = 0.94 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 8, startPoint = { x = -0.08, y = 0.84 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 23, startPoint = { x = 1.1, y = 0.725 } },
  -- 40
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 60, startPoint = { x = 1.2, y = 1.06 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 30, startPoint = { x = 1.12, y = 0.64 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 23, startPoint = { x = -0.08, y = 0.7 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 10, startPoint = { x = -0.05, y = 0.76 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 15, startPoint = { x = -0.15, y = 0.64 } },
  -- This second section contains extra bubbles to avoid blank spaces in iPad resolution
  --45
  { colorKey = COLOR_KEY_GRAY,            radius = 35, startPoint = { x = -0.19, y = 0.78 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 22, startPoint = { x = 1.27, y = 0.93 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 30, startPoint = { x = 1.34, y = 0.84 } },
}

-- LAYOUTS_INTRO is unique
TypoBubbleLayouts.LAYOUTS_INTRO = {
  -- 1
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 55, startPoint = { x = 0.95, y = 1.005 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 26, startPoint = { x = 0.98, y = 0.87 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 18, startPoint = { x = 0.85, y = 0.867 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 5, startPoint = { x = 0.913, y = 0.912 } },
  -- 5
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 10, startPoint = { x = 0.86, y = 0.918 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 12, startPoint = { x = 0.75, y = 0.87 } },
  { colorKey = COLOR_KEY_GRAY_DARK,       radius = 5, startPoint = { x = 0.778, y = 0.90 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 14, startPoint = { x = 0.79, y = 0.94 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 12, startPoint = { x = 0.71, y = 0.925 } },
  -- 10
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT, radius = 5, startPoint = { x = 0.727, y = 0.951 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,  radius = 18, startPoint = { x = 0.74, y = 0.995 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 14, startPoint = { x = 0.667, y = 0.96 } },
  { colorKey = COLOR_KEY_GRAY,            radius = 5, startPoint = { x = 0.607, y = 0.975 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 30, startPoint = { x = 0.625, y = 1.03 } },
  -- 15
  { colorKey = COLOR_KEY_HIGHLIGHT,       radius = 36, startPoint = { x = 1.21, y = 0.98 } },
  { colorKey = COLOR_KEY_GRAY_LIGHT,      radius = 20, startPoint = { x = 1.085, y = 0.915 } },
}

-- LAYOUTS_WIN is a combination of LAYOUTS_ONE rotated plus some additional bubbles.
-- Note: Color keys here only matter as far as the the LIGHT/DARK feature, colors will be randomly
-- assigned.
TypoBubbleLayouts.LAYOUTS_WIN = {
  -- This first section is LAYOUTS_ONE rotated 180 degrees
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 68, startPoint = { x = 0.81, y = 0.07 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 40, startPoint = { x = 0.74, y = 0.24 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 20, startPoint = { x = 0.9, y = 0.2 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 22, startPoint = { x = 0.56, y = 0.21 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 18, startPoint = { x = 0.64, y = 0.16 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 18, startPoint = { x = 0.47, y = 0.17 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 16, startPoint = { x = 0.53, y = 0.12 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 20, startPoint = { x = 0.59, y = 0.01 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 18, startPoint = { x = 0.57, y = 0.07 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 15, startPoint = { x = 0.38, y = 0.24 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 15, startPoint = { x = 0.24, y = 0.35 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 15, startPoint = { x = 1.02, y = 0.19 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 15, startPoint = { x = 1.02, y = 0.13 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 75, startPoint = { x = -0.02, y = 0.13 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 40, startPoint = { x = 0.07, y = 0.31 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 40, startPoint = { x = 0.38, y = 0 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 25, startPoint = { x = 0.26, y = 0.08 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 25, startPoint = { x = 0.25, y = 0.275 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 20, startPoint = { x = 0.26, y = 0.165 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 20, startPoint = { x = 0.39, y = 0.1 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 15, startPoint = { x = 0.48, y = 0.26 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 15, startPoint = { x = 0.36, y = 0.165 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 17, startPoint = { x = 0.19, y = 0.215 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 15, startPoint = { x = 0.18, y = 0.03 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 8, startPoint = { x = 1.01, y = 0.01 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 5, startPoint = { x = 0.47, y = 0.09 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 5, startPoint = { x = 0.46, y = 0.07 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 8, startPoint = { x = 0.3, y = 0.21 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 18, startPoint = { x = 0.09, y = -0.01 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 8, startPoint = { x = 0.24, y = 0.01 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 10, startPoint = { x = 0.5, y = 0.04 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 8, startPoint = { x = 0.32, y = 0.13 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 8, startPoint = { x = 0.11, y = 0.24 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 8, startPoint = { x = 0.31, y = 0.32 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 5, startPoint = { x = 0.62, y = 0.11 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 5, startPoint = { x = 0.96, y = 0.16 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 55, startPoint = { x = 1.18, y = 0.06 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 8, startPoint = { x = 1.08, y = 0.16 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 23, startPoint = { x = -0.1, y = 0.275 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 60, startPoint = { x = -0.2, y = -0.06 } },
  -- This second section are additional bubbles to cover the sides of the screen
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 34, startPoint = { x = 0.03, y = 0.71 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 22, startPoint = { x = -0.005, y = 0.60 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 8, startPoint = { x = 0.035, y = 0.53 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 20, startPoint = { x = 0.00, y = 0.47 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 16, startPoint = { x = -0.015, y = 0.395 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 20, startPoint = { x = 0.97, y = 0.71 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 8, startPoint = { x = 0.96, y = 0.66 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 32, startPoint = { x = 1.05, y = 0.60 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 15, startPoint = { x = 1.00, y = 0.51 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 12, startPoint = { x = 0.98, y = 0.41 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 12, startPoint = { x = 0.95, y = 0.36 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 30, startPoint = { x = 0.94, y = 0.29 } },
  -- This third section contains extra bubbles to avoid blank spaces in iPad resolution
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 38, startPoint = { x = -0.16, y = 0.65 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 10, startPoint = { x = -0.05, y = 0.54 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 50, startPoint = { x = -0.2, y = 0.48 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 22, startPoint = { x = -0.12, y = 0.35 } },
  { colorKey = COLOR_KEY_HIGHLIGHT,           radius = 38, startPoint = { x = 1.24, y = 0.53 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_DARK,      radius = 24, startPoint = { x = 1.08, y = 0.45 } },
  { colorKey = COLOR_KEY_HIGHLIGHT_LIGHT,     radius = 95, startPoint = { x = 1.30, y = 0.30 } },
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function isHighlightColor(colorKey)
  return (colorKey == COLOR_KEY_HIGHLIGHT) or (colorKey == COLOR_KEY_HIGHLIGHT_LIGHT) or (colorKey == COLOR_KEY_HIGHLIGHT_DARK)
end

local function isGrayColor(colorKey)
  return (colorKey == COLOR_KEY_GRAY) or (colorKey == COLOR_KEY_GRAY_LIGHT) or (colorKey == COLOR_KEY_GRAY_DARK)
end

local function isLightColor(colorKey)
  return (colorKey == COLOR_KEY_HIGHLIGHT_LIGHT) or (colorKey == COLOR_KEY_GRAY_LIGHT)
end

local function isDarkColor(colorKey)
  return (colorKey == COLOR_KEY_HIGHLIGHT_DARK) or (colorKey == COLOR_KEY_GRAY_DARK)
end

local function adjustLayoutsToDevice(bubbleLayouts)
  -- The dimensions in the layouts are specified with respect to an iPhone 6 screen:
  --   * startPoint: relative to the width/height of iPhone 6
  --   * radius: points in iPhone 6
  --
  -- Of course, simply scaling these dimensions doesn't work for other devices, so we need to do some
  -- transformations. The required output for a bubble displayed across different devices is that:
  --  * y coordinate, expressed as relative to the height of the screen, is constant across devices.
  --  * ratio between radius and height of the screen is constant across devices.
  --  * aspect ratio of the layout is respected in all devices.
  --
  -- As a consequence:
  --  * x coordinate changes to acommodate.
  --  * in wider devices (iPad) you see extra bubbles on the sides that on narower ones (iPhone 6)
  --    are off screen.
  --
  -- From this, the ratio by which we are going to multiply our dimensions is:
  --   height_iphone6 / height_current_device
  --
  -- Note that we also need to multiply widths by this ratio - the aspect ratio can't change!
  -- Multiplying by this ratio is exactly what ReferenceDevice.getScaledHeight does.

  local referenceWidth = ReferenceDevice.screenWidthInPoints
  local deviceWidth = Screen.width
  local deviceHeight = Screen.height
  local xOffsetForCentering = (deviceWidth - ReferenceDevice.getScaledHeight(referenceWidth)) / 2

  local adjustedLayouts = {}

  for _, layout in ipairs(bubbleLayouts) do
    local referenceRadius = layout.radius
    local referenceRelativeX = layout.startPoint.x
    local referenceRelativeY = layout.startPoint.y

    local referenceAbsoluteX = referenceRelativeX * referenceWidth
    local deviceAbsoluteX = ReferenceDevice.getScaledHeight(referenceAbsoluteX) + xOffsetForCentering
    local deviceAbsoluteY = referenceRelativeY * deviceHeight
    local deviceRadius = ReferenceDevice.getScaledHeight(referenceRadius)

    local adjustedLayout = {
      colorKey = layout.colorKey,
      radius = deviceRadius,
      startPoint = { x = deviceAbsoluteX, y = deviceAbsoluteY }
    }

    table.insert(adjustedLayouts, adjustedLayout)
  end

  return adjustedLayouts
end

TypoBubbleLayouts.LAYOUTS_INTRO = adjustLayoutsToDevice(TypoBubbleLayouts.LAYOUTS_INTRO)
TypoBubbleLayouts.LAYOUTS_ONE = adjustLayoutsToDevice(TypoBubbleLayouts.LAYOUTS_ONE)
TypoBubbleLayouts.LAYOUTS_TWO = adjustLayoutsToDevice(TypoBubbleLayouts.LAYOUTS_TWO)
TypoBubbleLayouts.LAYOUTS_THREE = adjustLayoutsToDevice(TypoBubbleLayouts.LAYOUTS_THREE)
TypoBubbleLayouts.LAYOUTS_BONUS = adjustLayoutsToDevice(TypoBubbleLayouts.LAYOUTS_BONUS)
TypoBubbleLayouts.LAYOUTS_WIN = adjustLayoutsToDevice(TypoBubbleLayouts.LAYOUTS_WIN)

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- Get Colors -------------------------

function TypoBubbleLayouts.getColor(colorKey, roundColor)
  local mainColor = nil

  if isHighlightColor(colorKey) then
    mainColor = roundColor
  elseif isGrayColor(colorKey) then
    mainColor = TypoCommon.COLOR_GRAY
  else
    error(string.format("Unxpected color key: %s", tostring(colorKey)))
  end

  if isLightColor(colorKey) then
    return TypoCommon.getLightColor(mainColor)
  elseif isDarkColor(colorKey) then
    return TypoCommon.getDarkColor(mainColor)
  else
    return mainColor
  end
end

function TypoBubbleLayouts.getDimmedColor(colorKey)
  local color = nil
  if isGrayColor(colorKey) then
    color = TypoBubbleLayouts.getColor(colorKey, nil)
  else
    if isLightColor(colorKey) then
      return TypoCommon.COLOR_GRAY_LIGHT
    elseif isDarkColor(colorKey) then
      return TypoCommon.COLOR_GRAY_DARK
    else
      return TypoCommon.COLOR_GRAY
    end
  end

  color = ColorUtils.colorWithOpacity(color, DIMMED_OPACITY)
  return color
end

function TypoBubbleLayouts.getColorBonus(layout)
  local colorKey = layout.colorKey
  local startPoint = layout.startPoint
  local x = startPoint.x / Screen.width
  local y = startPoint.y / Screen.height

  -- For the bottom half of the screen, flip the gradient
  if y < 0.5 then
    x = 1 - x
  end

  -- Add some randomness so that the gradient frontiers are not obvious
  x = x + MathUtils.getRandomFloat(-0.15, 0.15)
  y = y + MathUtils.getRandomFloat(-0.2, 0.2)

  local distanceToCenter = MathUtils.distance(x, y, 0.5, 0.5)
  local mainColor = nil

  if distanceToCenter < 0.3 then
    mainColor = TypoCommon.COLOR_GRAY
  elseif x < 0.3 then
    mainColor = TypoCommon.COLOR_PURPLE
  elseif x < 0.7 then
    mainColor = TypoCommon.COLOR_PINK
  else
    mainColor = TypoCommon.COLOR_ORANGE
  end

  if isLightColor(colorKey) then
    return TypoCommon.getLightColor(mainColor)
  elseif isDarkColor(colorKey) then
    return TypoCommon.getDarkColor(mainColor)
  else
    return mainColor
  end
end
