--- TypoCheckmark
-- @author Created by anton on August 20, 2015.

class("TypoCheckmark")

require("TypoCommon")
require("graphics.primitives.Checkmark")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WIDTH = Screen.getWidthPart(0.35)
local OFFSCREEN_OFFSET = Screen.getHeightPart(0.6)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function TypoCheckmark:prepareToShow()
  local offscreenY = self:getY() - OFFSCREEN_OFFSET
  self:setY(offscreenY)
end

function TypoCheckmark:getShowAnimation(duration)
  return AHSpawn.new(
    function()
      TypoCommon.startBonusColorAnimation(self)
    end,
    AHLocationYBy.new(self, duration, AHEaseElasticOut.new(0.7), OFFSCREEN_OFFSET)
  )
end

function TypoCheckmark:getHideAnimation(duration)
  return AHLocationYBy.new(self, duration, AHEaseQuadraticIn.new(), OFFSCREEN_OFFSET)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function TypoCheckmark.new()
  local self = FilledCheckmark.new(WIDTH)
  Mixin.mix(self, TypoCheckmark)

  return self
end
