--- TypoExampleTextController
-- @author Created by anton on August 24, 2015.

class("TypoExampleTextController")

require("TypoTextController")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function makeCorrectionsById(corrections)
  local correctionsByErrorId = {}

  for _, correction in ipairs(corrections) do
    correctionsByErrorId[correction:getErrorId()] = correction
  end

  return correctionsByErrorId
end

local function setFontSize(self, fontSize)
  local baseAttributes = TableUtils.shallowCopy(self.textInterpreter.baseAttributes)
  local font = baseAttributes.font
  local resizedFont = font:newFontWithNominalSize(fontSize)
  baseAttributes.font = resizedFont
  self.textInterpreter.baseAttributes = baseAttributes
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function TypoExampleTextController:revertError(errorId)
  self:_replaceErrorWithIncorrectSubtle(errorId)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function TypoExampleTextController.new(corrections, textView, fontSize)
  local correctionsByErrorId = makeCorrectionsById(corrections)
  local self = TypoTextController.new(correctionsByErrorId, textView)

  Mixin.mix(self, TypoExampleTextController)

  setFontSize(self, fontSize)

  return self
end
