--- TypoQuoteReplacer
-- @author Created by andrewcousins on February 13, 2023.

class("TypoQuoteReplacer")

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function replaceStraightQuotesWithCurlyQuotes(text, straightQuote, openCurlyQuote, closeCurlyQuote)
  -- Open quotes:
  text = string.gsub(text, "(%s+)("..straightQuote..")(%w+)", "%1"..openCurlyQuote.."%3") -- quote after a space and before a word
  text = string.gsub(text, "^("..straightQuote..")(%w+)", openCurlyQuote.."%2") -- quote at the start of the text and before a word

  -- Close quotes:
  text = string.gsub(text, "([%w%p]+)("..straightQuote..")(%s+)", "%1"..closeCurlyQuote.."%3") -- quote after a word or punctuation and before a space
  text = string.gsub(text, "([%w%p]+)("..straightQuote..")$", "%1"..closeCurlyQuote) -- quote after a word or punctuation and at the end of the text
  text = string.gsub(text, "(%w+)("..straightQuote..")(%p+)", "%1"..closeCurlyQuote.."%3") -- quote after a word and before punctuation
  text = string.gsub(text, "(%w+)("..straightQuote..")(%w+)", "%1"..closeCurlyQuote.."%3") -- quote after a word and before a word (apostrophes)
  return text
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function TypoQuoteReplacer.replaceStraightQuotesWithCurlyQuotes(text)
  text = replaceStraightQuotesWithCurlyQuotes(text, "\'", "‘", "’")
  text = replaceStraightQuotesWithCurlyQuotes(text, "\"", "“", "”")
  return text
end
