--- UpperBubble
-- @author Created by steven on March 16, 2016.

class("UpperBubble")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local RIM_NAME = "bubble_white_rim.png"
local BLURRY_NAME = "blurry_particle.png"
local WHITE = {1.0, 1.0, 1.0}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------



-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructors ------------------------

function UpperBubble.newSimple(radius, isBlurred)
  local diameter = 2 * radius
  local self = Group.new(diameter, diameter)

  local colorLayer = nil

  if (isBlurred == true) then
    colorLayer = Sprite.newWithName(BLURRY_NAME)
    colorLayer:setEffectiveDims(diameter * 1.5, diameter * 1.5) -- file is larger than the actual image
  else
    colorLayer = FilledCircle.new(radius)
  end

  colorLayer:setOpacity(0.25)
  self.colorLayer = colorLayer
  self:insertAtCenter(colorLayer)

  return self
end

function UpperBubble.newComplex(radius)
  local diameter = 2 * radius
  local self = Group.new(diameter, diameter)

  local colorLayer = FilledCircle.new(radius, WHITE)
  colorLayer:setOpacity(0.25)
  self:insertAtCenter(colorLayer)
  self.colorLayer = colorLayer

  local transparentLayer = Sprite.newWithName(RIM_NAME)
  transparentLayer:setEffectiveDims(diameter, diameter)
  self:insertAtCenter(transparentLayer)
  self.transparentLayer = transparentLayer

  return self
end
