--- UpperCommon
-- @author Created by steven on February 01, 2016.

class("UpperCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

UpperCommon.STANDARD_BRICK_HEIGHT = Screen.getSafeHeightPart(0.075)
UpperCommon.RESPONSE_BRICK_HEIGHT = Screen.getSafeHeightPart(0.13)
UpperCommon.RESPONSE_BRICK_WIDTH = Screen.getSafeWidthPart(0.8)

UpperCommon.BRICK_PADDING = 3

UpperCommon.STANDARD_BRICK_FONT = Font.new(FontFaces.DIN_OT_MEDIUM, 30.0)
UpperCommon.RESPONSE_BRICK_FONT = Font.new(FontFaces.DIN_OT_MEDIUM, 26.0)
UpperCommon.QUESTION_FONT = Font.new(FontFaces.DIN_OT_BOLD, 21.0)
UpperCommon.ROUND_NUMBER_FONT = nil
UpperCommon.WPM_TEXT_FONT = nil
UpperCommon.NUMBER_FONT = nil

UpperCommon.RATIONALE_HEADER_FONT = nil
UpperCommon.RATIONALE_PASSAGE_FONT = Font.new(FontFaces.DIN_OT_MEDIUM, 20)
UpperCommon.RATIONALE_QUESTION_FONT = Font.new(FontFaces.DIN_OT_BOLD, 21)
UpperCommon.RATIONALE_RESPONSE_FONT = Font.new(FontFaces.DIN_OT_BOLD, 12)
UpperCommon.RATIONALE_CONTINUE_FONT = nil

UpperCommon.WHITE = {1.0, 1.0, 1.0}
UpperCommon.NEUTRAL_PURPLE = {0.64, 0.31, 0.54}
UpperCommon.INCORRECT_RED = {1.0, 0.074, 0.439}
UpperCommon.BRICK_TEXT_COLOR = UpperCommon.NEUTRAL_PURPLE

UpperCommon.WPM_STRING = Localizer.get("WPM")
UpperCommon.SHADOW_FILENAME = "shadow.png"

UpperCommon.COLOR_STATES = {
  NEUTRAL = "UpperCommon.COLOR_STATES.NEUTRAL",
  CORRECT = "UpperCommon.COLOR_STATES.CORRECT",
  OUTRO = "UpperCommon.COLOR_STATES.OUTRO",
}

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function UpperCommon.initialize()
  UpperCommon.RATIONALE_HEADER_FONT = PrerenderedFont.new(FontFaces.DIN_OT_BOLD, 13)
  UpperCommon.RATIONALE_CONTINUE_FONT = PrerenderedFont.new(FontFaces.DIN_OT_MEDIUM, 14)

  UpperCommon.WPM_TEXT_FONT = PrerenderedFont.new(FontFaces.DIN_OT_BOLD, 36)
  UpperCommon.ROUND_NUMBER_FONT = PrerenderedFont.new(FontFaces.DIN_OT_BOLD, 24)
  UpperCommon.NUMBER_FONT = PrerenderedFont.new(FontFaces.DIN_OT_BOLD, 224, "0123456789")
end
