--- UpperOutroOverlay
-- @author Created by steven on March 18, 2016.

class("UpperOutroOverlay")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local WHITE = {1.0, 1.0, 1.0}
local WHITE_INVISIBLE = {1.0, 1.0, 1.0, 0.0}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------



-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function UpperOutroOverlay:createFlashAction(totalDuration)
  local flashActionStepCount = 9 
  local duration = totalDuration / flashActionStepCount
  local outroLayers = self.outroLayers
  local firstLayer = outroLayers[1]
  local secondLayer = outroLayers[2]
  local thirdLayer = outroLayers[3]

  local flashAction = AHSequence.new(
    AHSpawn.new(
      secondLayer:newOpacityToAction(duration, nil, 0.0, 0.25),
      AHOpacityTo.new(firstLayer, duration, nil, 0.1)
    ),
    AHDelay.new(duration),
    AHSpawn.new(
      secondLayer:newOpacityToAction(duration, nil, 0.0, 0.5)
    ),
    AHDelay.new(duration),
    AHSpawn.new(
      secondLayer:newOpacityToAction(duration, nil, 0.0, 0.25)
    ),
    AHDelay.new(duration),
    AHSpawn.new(
      secondLayer:newOpacityToAction(duration, nil, 0.0, 1.0),
      thirdLayer:newOpacityToAction(duration, nil, 1.0, 0.0)
    ),
    AHDelay.new(duration),
    AHSpawn.new(
      secondLayer:newOpacityToAction(duration, nil, 0.0, 0.3),
      thirdLayer:newOpacityToAction(duration, nil, 0.3, 0.0)
    )
  )

  return flashAction
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayers(self)
  local outroLayers = self.outroLayers
  local firstLayer = FilledRectangle.newFullScreen(WHITE_INVISIBLE)
  firstLayer:setBlendMode(MOAIProp2D.BLEND_ADD)
  self:insertAtCenter(firstLayer)
  outroLayers[1] = firstLayer

  local secondLayer = RectangleGradient.new(Screen.fullWidth, Screen.fullHeight, WHITE_INVISIBLE, WHITE_INVISIBLE, true)
  secondLayer:setBlendMode(MOAIProp2D.BLEND_ADD)
  self:insertAtCenter(secondLayer)
  outroLayers[2] = secondLayer

  local thirdLayer = RectangleGradient.new(Screen.fullWidth, Screen.fullHeight, WHITE_INVISIBLE, WHITE_INVISIBLE)
  thirdLayer:setBlendMode(MOAIProp2D.BLEND_ADD)
  self:insertAtCenter(thirdLayer)
  outroLayers[3] = thirdLayer

end

-- Constructors ------------------------

function UpperOutroOverlay.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, UpperOutroOverlay)
  self.outroLayers = {}

  createLayers(self)

  return self
end
