--- UpperPieTimer
-- @author Created by Jay on March 22, 2016.

class("UpperPieTimer")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local RADIUS = 14.0
local INITIAL_COLOR = {0.64, 0.31, 0.54}
local FLASH_COLOR = {1, 0, 0}
local BACKING_OPACITY = 0.0

local FLASH_IN_DURATION = 0.1
local FLASH_OUT_DURATION = 0.25

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------
function UpperPieTimer:addVisualWarningSequence()
  self:addWarningHandler(function()
    local flashInAction = AHColorTo.new(self.pie, FLASH_IN_DURATION, AHEaseSimpleOut.new(), FLASH_COLOR)
    local flashOutAction = AHColorTo.new(self.pie, FLASH_OUT_DURATION, nil, INITIAL_COLOR)
    local flashSequence = AHSequence.new(flashInAction, flashOutAction)

    flashSequence:start()
  end)
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

function UpperPieTimer.new(duration, onTimeOut)
  local self = PieTimer.new(RADIUS, INITIAL_COLOR, BACKING_OPACITY, duration, onTimeOut)
  Mixin.mix(self, UpperPieTimer)

  return self
end
