--- UpperSpecksLayer
-- @author Created by steven on March 22, 2016.

class("UpperSpecksLayer")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local NUMBER_OF_SPECKS = 100
local COLOR = UpperCommon.WHITE

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function createSpecks(self)
  for speckIndex = 1, NUMBER_OF_SPECKS do
    local randomRadius = MathUtils.getRandomFloat(0.5, 1.0)
    local speck = FilledCircle.new(randomRadius, COLOR)
    local randomX = MathUtils.getRandomFloat(0, Screen.fullWidth)
    local randomY = MathUtils.getRandomFloat(0, Screen.fullHeight)

    speck:setLoc(randomX, randomY)
    self:insert(speck)
    table.insert(self.specks, speck)
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function UpperSpecksLayer:fadeInSpecks()
  local fadeInAction = AHOpacityTo.new(self, 0.1, nil, 1.0)

  fadeInAction:start()
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

function UpperSpecksLayer.new()
  local self = Group.newFullScreen()
  Mixin.mix(self, UpperSpecksLayer)
  self.specks = {}

  createSpecks(self)

  self:setOpacity(0.0)
  self:linkOpacityAttrToChildren()

  return self
end
