--- VendettaCommon
-- @author Created by steven on July 13, 2016.

class("VendettaCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

VendettaCommon.PROMPT_WIDTH = Screen.getWidthPart(0.3)
VendettaCommon.PROMPT_HEIGHT = Screen.getHeightPart(0.125)
VendettaCommon.CARD_WIDTH = Screen.getWidthPart(0.8)

VendettaCommon.DEFAULT_TEXT_COLOR = {1.0, 1.0, 1.0}
VendettaCommon.CORRECT_TEXT_COLOR = {1.0, 0.99, 0.61}
VendettaCommon.INCORRECT_TEXT_COLOR = {1.0, 0.0, 0.0}

VendettaCommon.SYNONYM_ORB_Y = Screen.getSafeYFromTop(0.35)
VendettaCommon.MINIMUM_Y = Screen.getSafeY(0.35)

VendettaCommon.SYNONYM_FONT = nil

VendettaCommon.ROUND_LAYOUTS = {
  {
    {x = Screen.getWidthPart(0.25), y = VendettaCommon.MINIMUM_Y},
    {x = Screen.getWidthPart(0.75), y = VendettaCommon.MINIMUM_Y}
  },
  {
    {x = Screen.getWidthPart(0.2), y = VendettaCommon.MINIMUM_Y},
    {x = Screen.getWidthPart(0.5), y = VendettaCommon.MINIMUM_Y},
    {x = Screen.getWidthPart(0.8), y = VendettaCommon.MINIMUM_Y}
  },
  {
    {x = Screen.getWidthPart(0.175), y = Screen.getSafeY(0.475)},
    {x = Screen.getWidthPart(0.35), y = VendettaCommon.MINIMUM_Y},
    {x = Screen.getWidthPart(0.65), y = VendettaCommon.MINIMUM_Y},
    {x = Screen.getWidthPart(0.825), y = Screen.getSafeY(0.475)}
  }
}

VendettaCommon.REVIEW_LAYOUTS = {
  {
    {x = Screen.getWidthPart(0.25), y = Screen.getSafeY(0.525)},
    {x = Screen.getWidthPart(0.75), y = Screen.getSafeY(0.525)}
  },
  {
    {x = Screen.getWidthPart(0.25), y = Screen.getSafeY(0.625)},
    {x = Screen.getWidthPart(0.5), y = 0.0},
    {x = Screen.getWidthPart(0.75), y = Screen.getSafeY(0.625)}
  },
  {
    {x = Screen.getWidthPart(0.25), y = Screen.getSafeY(0.625)},
    {x = Screen.getWidthPart(0.25), y = 0.0},
    {x = Screen.getWidthPart(0.75), y = 0.0},
    {x = Screen.getWidthPart(0.75), y = Screen.getSafeY(0.625)}
  }
}

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function VendettaCommon.createShakeAction(group)
  local shakeDelta = Screen.getWidthPart(0.025)
  local shakeDuration = 0.05
  local ease = nil

  local shake = AHSequence.new(
    AHLocationXBy.new(group, shakeDuration, ease, shakeDelta),
    AHLocationXBy.new(group, shakeDuration, ease, -2 * shakeDelta),
    AHLocationXBy.new(group, shakeDuration, ease, 2 * shakeDelta),
    AHLocationXBy.new(group, shakeDuration, ease, -2 * shakeDelta),
    AHLocationXBy.new(group, shakeDuration, ease, 2 * shakeDelta),
    AHLocationXBy.new(group, shakeDuration, ease, -shakeDelta)
  )

  return shake
end

function VendettaCommon.initialize()
  VendettaCommon.SYNONYM_FONT = PrerenderedFont.new(FontFaces.DIN_OT_BOLD, 36)
end
