-- VendettaReviewOverlay
-- Created by Steven on September 12, 2016

class("VendettaReviewOverlay")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local TAP_COLOR = ColorUtils.colorHex24ToStd(0xb78faf)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function VendettaReviewOverlay:createFadeAction(opacity, duration, ease)
  local fadeAction = AHSpawn.new(
    AHOpacityTo.new(self.headerLabel, duration, ease, opacity),
    AHOpacityTo.new(self.tapLabel, duration, ease, opacity)
  )

  return fadeAction
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

local function createLayout(self, numberOfPrompts)
  local middleX = Screen.getWidthPart(0.5)
  local headerLabel = Label.new("WORDS MATCHED", Font.new(FontFaces.DIN_OT_BOLD, 20))
  headerLabel:setOpacity(0.0)
  local headerY = Screen.getSafeY(0.625) + headerLabel:getHeightPart(4.5)
  if (numberOfPrompts == 2) then
    headerY = Screen.getSafeY(0.525) + headerLabel:getHeightPart(4.5)
  end
  headerLabel:setLoc(middleX, headerY)
  self:insert(headerLabel)
  self.headerLabel = headerLabel

  local tapLabel = Label.new(Localizer.get("Misc.TAP_TO_CONTINUE"), Font.new(FontFaces.DIN_OT_MEDIUM, 15))
  tapLabel:setColor(unpack(TAP_COLOR))
  tapLabel:setOpacity(0.0)
  local tapLabelY = Screen.getSafeY(0.1)
  tapLabel:setLoc(middleX, tapLabelY)
  self:insert(tapLabel)
  self.tapLabel = tapLabel
end

function VendettaReviewOverlay.new(numberOfPrompts)
  local self = Group.newFullScreen()
  Mixin.mix(self, VendettaReviewOverlay)

  createLayout(self, numberOfPrompts)

  return self
end
