--- WitAdvancedWordNotification

class("WitAdvancedWordNotification")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local EXPAND_DURATION = 0.3
local COLLAPSE_DURATION = 0.5

local FONT = Font.new(FontFaces.DIN_OT_MEDIUM, 12)

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function WitAdvancedWordNotification:show()
  if (self.showAnimation ~= nil) then
    self.showAnimation:stop()
    self.showAnimation = nil
  end

  self:setY(self.baseY)
  self:setOpacity(1)

  local expand = AHLocationYBy.new(self, EXPAND_DURATION, nil, self:getHeightPart(0.45))
  local fadeOut = AHOpacityTo.new(self, COLLAPSE_DURATION, nil, 0)
  local moveOut = AHLocationYBy.new(self, COLLAPSE_DURATION, nil, self:getHeightPart(0.75))
  local collapse = AHSpawn.new(fadeOut, moveOut)

  self.showAnimation = AHSequence.new(expand, collapse)
  self.showAnimation:start()
end

function WitAdvancedWordNotification:hide()
  self:setOpacity(0)
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function WitAdvancedWordNotification.new(inputFieldHeight)
  local self = Label.new("ADVANCED WORD", FONT)
  Mixin.mix(self, WitAdvancedWordNotification)

  self.baseY = inputFieldHeight + self:getHeightPart(0.5)

  return self
end
