--- WitImprovableSentenceView

class("WitImprovableSentenceView")

require("WitConstants")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local BASE_ATTRIBUTES = {
  font = Font.new(FontFaces.DIN_OT_LIGHT, WitConstants.HUGE_FONT_SIZE)
}

local ATTRIBUTES_FOR_LABELS = {
  replace = {
    highlight = true
  }
}

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function setHighlightedViewColor(self)
  local highlightedViews = self:getViewsWithAttribute("highlight", true)

  for _, view in ipairs(highlightedViews) do
    view:inheritOpacity(self)
    view:clearAttrLink(MOAIColor.INHERIT_COLOR)
    view:setColor(unpack(self.activeWordsColor))
  end
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function WitImprovableSentenceView:setSentence(text)
  self:setText('"' .. text .. '"')

  setHighlightedViewColor(self)
end

function WitImprovableSentenceView:setActiveColor(color)
  self.activeWordsColor = color
end

function WitImprovableSentenceView:createFadeAction(seconds, targetOpacity)
  targetOpacity = targetOpacity or 0

  return AHOpacityTo.new(self, seconds, nil, targetOpacity)
end

-- ----------------------------------------------------------------------------
-- Object construction
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function WitImprovableSentenceView.new(width)
  local self = DynamicTextArea.new("", width, BASE_ATTRIBUTES, ATTRIBUTES_FOR_LABELS)
  Mixin.mix(self, WitImprovableSentenceView)

  return self
end
