class("WitSolutionExamples")
local EXAMPLES =
{
  complimentary =
  {
    prompt = "The soldiers are <replace>brave</replace>.",
    acceptable = {"courageous", "heroic"},
    wrong = {"amazing", "awesome"},
  },
  extreme =
  {
    prompt = "The student is <replace>intelligent</replace>.",
    acceptable = {"brilliant", "astute"},
    wrong = {"amazing", "wonderful"},
  },
  critical =
  {
    prompt = "The pace of the movie was <replace>slow</replace>.",
    acceptable = {"sluggish", "monotonous"},
    wrong = {"awful", "terrible"},
  },
  forceful =
  {
    prompt = "Slow traffic is <replace>frustrating</replace>.",
    acceptable = {"maddening", "infuriating"},
    wrong = {"horrible", "awful"},
  },
  respectful =
  {
    prompt = "Your opinion is <replace>strange</replace>.",
    acceptable = {"atypical", "unfamiliar"},
    wrong = {"awful", "terrible"},
  },
  specific =
  {
    prompt = "My Internet connection is <replace>bad</replace>.",
    acceptable = {"sluggish", "plodding"},
    wrong = {"horrible", "awful"},
  },
}
local EXTRACT_KEYWORD_REGEXP = "<replace>(.*)</replace>"

function WitSolutionExamples.getExampleForRound(round)
  local example = TableUtils.deepCopy(EXAMPLES[round.task])
  example.task = round.task
  example.keyword = string.match(round.prompt, EXTRACT_KEYWORD_REGEXP)
  return example
end

-- Used for validation
function WitSolutionExamples.hasExampleForTask(task)
  local example = EXAMPLES[task]
  local hasExample = example ~= nil and example.prompt ~= nil and example.acceptable ~= nil and example.wrong ~= nil
  if(hasExample) then
    hasExample = hasExample and type(example.acceptable) == "table" and type(example.wrong) == "table" and type(example.prompt) == "string"
  end
  if(hasExample) then
    hasExample = hasExample and #example.acceptable == 2 and #example.wrong == 2
  end
  return hasExample
end
