module ("WitBackground", package.seeall)

function WitBackground.new()
  local w = Screen.fullWidth
  local h = Screen.fullHeight
  local colors = WitColors.getBackgroundGradientByColorSchemeIndex(1)
  local beginColor = colors[1]
  local endColor = colors[2]
  local isHorizontal = false
  local self = RectangleGradient.new(w, h, beginColor, endColor, isHorizontal)
  Mixin.mix(self, WitBackground)

  return self
end

function WitBackground:setColorScheme(index)
  local colors = WitColors.getBackgroundGradientByColorSchemeIndex(index)
  local beginColor = colors[1]
  local endColor = colors[2]
  local duration = 0.5
  local ease = nil
  local colorToAction = self:newGradientToAction(duration, ease, beginColor, endColor)
  colorToAction:start()
end
