module ("BlockGrid", package.seeall)
require("scene.effects.BlockPicture")


-------------------------------------------------
----------------- UTILITY -----------------------
-------------------------------------------------
local function getBlocksForSize(w, blockW)
  local blockCount = w/blockW
  local wholeBlocks = math.floor(blockCount)
  return wholeBlocks
end
local function createShape(gridW, gridH)
  local shape = {}
  for y = 1, gridH do
    local row = {}
    shape[#shape + 1] = row
    for x = 1, gridW do
      row[#row + 1] = BlockPicture.BlockTypes.Square
    end
  end
  return shape
end
-------------------------------------------------
----------------- CONSTRUCTOR -------------------
-------------------------------------------------
function BlockGrid.new(totalW, totalH, blockW, blockH, color)
  local gridW = getBlocksForSize(totalW, blockW)
  local gridH = getBlocksForSize(totalH, blockH)
  local shape = createShape(gridW, gridH)
  local self = BlockPicture.new(shape, blockW, blockH, color)
  Mixin.mix(self, BlockGrid)

  self.gridW = gridW
  self.gridH = gridH

  return self
end
