module ("BlockPictureFadeInOutAction", package.seeall)

function BlockPictureFadeInOutAction.new(blockPicture, totalAnimTime, maxOpacity)
  local self = AHSpawn.new()
  Mixin.mix(self, BlockPictureFadeInOutAction)

  maxOpacity = maxOpacity or 1
  local w = blockPicture:getGridWidth()
  local h = blockPicture:getGridHeight()
  local totalAnimTime = totalAnimTime or 1
  local maxDelayTime = 0.2 * totalAnimTime
  local minAppearTime = 0.1 * totalAnimTime
  local maxAppearTime = 0.40 * totalAnimTime
  local minDisappearTime = 0.1 * totalAnimTime
  local maxDisappearTime = 0.40 * totalAnimTime
  local minStartScale = 0
  local maxStartScale = 0.5
  for x = 1, w do
    for y = 1, h do
      local block = blockPicture:getView(x, y)
      if(block) then
        local delayTime = math.random() * maxDelayTime
        local appearTime = math.random() * (maxAppearTime - minAppearTime) + minAppearTime
        local disappearTime = totalAnimTime - delayTime - appearTime
        local blockInit = function()
          local startScale = math.random() * (maxStartScale - minStartScale) + minStartScale
          block:setOpacity(0)
          block:setScl(startScale)
        end
        local waitToShow = AHDelay.new(delayTime)
        local blockScale = AHScaleTo.new(block ,appearTime, nil, 1, 1)
        local blockShow = AHOpacityTo.new(block, appearTime, nil, maxOpacity)
        local blockAppear = AHSpawn.new(blockScale, blockShow)
        local blockHide = AHOpacityTo.new(block, disappearTime, nil, 0)
        local blockAction = AHSequence.new(blockInit, waitToShow, blockAppear, blockHide)
        self:addAction(blockAction)
      end
    end
  end

  return self
end
