--- WitCountdownTimer
-- @author Created by Aaron Barrett on August 26, 2014.

class("WitCountdownTimer")

require("WitColors")
require("WitConfiguration")
require("ExperimentsConfiguration")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local RADIUS = 10.0

local ACTIVE_OPACITY = 1.0
local PAUSED_OPACITY = 0.25

local WARNING_SOUND = "shared_countdown_warning"
local WARNING_SOUND_VOLUME = 0.6

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function WitCountdownTimer.new(timeoutHandler)
  local backOpacity = WitColors.getTimerBackgroundOpacity()
  local fillColor = WitColors.getTimerFillColor()
  local secondsPerRound = WitConfiguration.ROUND_DURATION_IN_SECONDS
  local digitTimerColor = {1, 1, 1}
  local digitTimerFont = FontFaces.DIN_OT_MEDIUM
  local digitTimerFontSize = 13

  self = DigitTimer.new(secondsPerRound, timeoutHandler, digitTimerFont, digitTimerFontSize, digitTimerColor)
  Mixin.mix(self, WitCountdownTimer)

  self:setActiveOpacity(0.8)
  self:setWarningInterval(1)
  self:setWarningCount(5)
  self:addVisualWarningSequence()
  self:addWarningHandler(function()
    Sound.playSoundEffect(WARNING_SOUND, WARNING_SOUND_VOLUME)
  end)
  self:setActiveOpacity(ACTIVE_OPACITY)
  self:setPausedOpacity(PAUSED_OPACITY)

  return self
end
