--- WordBirdsBirdCounter.lua
-- @author created by Jay Austria on April 26, 2016

class("WordBirdsBirdCounter")

require("WordBirdsCommon")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local LARGE_NOT_HUGE_NUMBER = 999

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function getProgressStepText(self)
  local labelText = tostring(self:getProgressStep())

  return labelText
end

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function WordBirdsBirdCounter:setProgressStep(step)
  self.super.setProgressStep(self, step)

  self.countLabel:setText(getProgressStepText(self))
end

function WordBirdsBirdCounter:getKeyColor()
  return WordBirdsConfiguration.UI_COMPONENTS_COLOR
end

-- ----------------------------------------------------------------------------
-- Object creation
-- ----------------------------------------------------------------------------

local function createLayout(self)
  local icon = Sprite.newWithName("bird_ui_icon.png")
  self:insert(icon)

  self:insertSpacer(5)

  local countLabelColumn = Column.new()

  local countLabel = Label.new(getProgressStepText(self), Font.new(StandardUIBuilder.STANDARD_FONT, 16))
  countLabelColumn:insert(countLabel)
  self.countLabel = countLabel

  countLabelColumn:insertSpacer(2)

  countLabelColumn:alignChildren()
  self:insert(countLabelColumn)

  self:alignChildren()

  local isRecursive = true
  self:linkOpacityAttrToChildren(isRecursive)
end

function WordBirdsBirdCounter.new()
  local self = Row.new()

  local stepCount = LARGE_NOT_HUGE_NUMBER -- math.huge seems to break this
  ProgressIndicator.makeProgressIndicator(self, stepCount)

  Mixin.mix(self, WordBirdsBirdCounter)

  createLayout(self)

  return self
end
