--- WordBirdsEditor
-- @author Created by karl on October 24, 2014.

class("WordBirdsEditor")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function WordBirdsEditor:appendLetter(letter)
  table.insert(self.letters, letter)
end

function WordBirdsEditor:getBackspacesRemaining()
  return #self.letters - self.minLength
end

function WordBirdsEditor:canBackspace()
  return #self.letters > self.minLength
end

function WordBirdsEditor:backspace()
  if self:canBackspace() then
    table.remove(self.letters, #self.letters)
  end
end

function WordBirdsEditor:getWord()
  return table.concat(self.letters)
end

function WordBirdsEditor:reset(initialText)
  self.letters = TableUtils.createArrayFromString(initialText)
  self.minLength = #self.letters
end

-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function WordBirdsEditor.new()
  local self = {}
  Mixin.mix(self, WordBirdsEditor)

  return self
end
