--- Word Birds Note Player

class("WordBirdsNotePlayer")

-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local NOTES = {}
for noteIndex = 1, 10 do
  table.insert(NOTES, string.format("wordbirds_tone%d", noteIndex))
end


-- ----------------------------------------------------------------------------
-- Utility
-- ----------------------------------------------------------------------------

local function modifyIndex(self, delta)
  self.noteIndex = MathUtils.clamp(self.noteIndex + delta, 1, #NOTES + 1)
end


-- ----------------------------------------------------------------------------
-- API
-- ----------------------------------------------------------------------------

function WordBirdsNotePlayer:playNextNote()
  assert(self.noteIndex <= #NOTES)

  Sound.playSoundEffect(NOTES[self.noteIndex])
  modifyIndex(self, 1)
end

function WordBirdsNotePlayer:playPreviousNote()
  assert(self.noteIndex > 0)

  modifyIndex(self, -1)
  Sound.playSoundEffect(NOTES[self.noteIndex])
end

function WordBirdsNotePlayer:reset()
  self.noteIndex = 1
end


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function WordBirdsNotePlayer.new()
  local self = {}
  Mixin.mix(self, WordBirdsNotePlayer)

  self:reset()

  return self
end
