-- Question Label

class("WordBirdsQuestionLabel")
require("WordBirdsCommon")


-- ----------------------------------------------------------------------------
-- Configuration
-- ----------------------------------------------------------------------------

local COLOR_TEXT = {29/255, 70/255, 94/255, 1}
local COLOR_BG = {207/255, 235/255, 246/255, 0.85}

local SELF_WIDTH = Screen.getSafeWidthPart(0.8)
local SELF_HEIGHT = 80
local CORNER_RADIUS = 1.5

local FONT_SIZE_MIN = 14
local FONT_SIZE_MAX = 20


-- ----------------------------------------------------------------------------
-- Object Creation
-- ----------------------------------------------------------------------------

-- Constructor ------------------------

function WordBirdsQuestionLabel.new(text)
  local self = Group.new(SELF_WIDTH, SELF_HEIGHT)
  Mixin.mix(self, WordBirdsQuestionLabel)

  self:insertAtCenter(FilledRoundedRectangle.new(self:getWidth(), self:getHeight(), CORNER_RADIUS, COLOR_BG))

  local label = DeprecatedLabel.newMultiLineFitted(
    text,
    self:getWidthPart(0.9),
    self:getHeightPart(0.9),
    WordBirdsConfiguration.NORMAL_FONT,
    FONT_SIZE_MAX,
    FONT_SIZE_MIN,
    Alignment.CENTER,
    Alignment.CENTER
  )
  label:setColor(unpack(COLOR_TEXT))
  self:insertAtCenter(label)

  self:linkColorAttrToChildren()

  return self
end
